-- structure de la base de donnée superadmin
--
--
-- i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
--
-- @author Stéphane Sampaio
-- @copyright Adullact Projet
-- @link http://adullact.org/
-- @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
--
-- SVN Informations
-- $Date: 2014-08-01 09:45:35 +0200 (ven. 01 août 2014) $
-- $Revision: 546 $
-- $Author: ssampaio $
-- $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Config/sql/001_idelibre_admin.sql $
-- $Id: 001_idelibre_admin.sql 546 2014-08-01 07:45:35Z ssampaio $

--
-- PostgreSQL database dump
--

SET statement_timeout = 0;
SET client_encoding = 'UTF8';
SET standard_conforming_strings = on;
SET check_function_bodies = false;
SET client_min_messages = warning;

--
-- Name: plpgsql; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS plpgsql WITH SCHEMA pg_catalog;


--
-- Name: EXTENSION plpgsql; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION plpgsql IS 'PL/pgSQL procedural language';


--
-- Name: uuid-ossp; Type: EXTENSION; Schema: -; Owner:
--

CREATE EXTENSION IF NOT EXISTS "uuid-ossp" WITH SCHEMA public;


--
-- Name: EXTENSION "uuid-ossp"; Type: COMMENT; Schema: -; Owner:
--

COMMENT ON EXTENSION "uuid-ossp" IS 'generate universally unique identifiers (UUIDs)';


SET search_path = public, pg_catalog;

SET default_tablespace = '';

SET default_with_oids = false;

--
-- Name: cake_sessions; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE cake_sessions (
    id character varying(255) NOT NULL,
    data text,
    expires integer
);


ALTER TABLE public.cake_sessions OWNER TO idelibre;

--
-- Name: collectivites; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE collectivites (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    name character varying(255) NOT NULL,
    conn character varying(255) NOT NULL,
    created timestamp without time zone,
    modified timestamp without time zone,
    active boolean DEFAULT false NOT NULL,
    login_suffix character varying(255),
    use_cert boolean DEFAULT false NOT NULL,
    public_key bytea,
    CONSTRAINT collectivites_use_cert_chk CHECK ((((use_cert = false) AND (login_suffix IS NOT NULL)) OR ((use_cert = true) AND (public_key IS NOT NULL))))
);


ALTER TABLE public.collectivites OWNER TO idelibre;

--
-- Name: collectivites_srvusers; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE collectivites_srvusers (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    srvuser_id uuid NOT NULL,
    collectivite_id uuid NOT NULL,
    created timestamp without time zone,
    modified timestamp without time zone
);


ALTER TABLE public.collectivites_srvusers OWNER TO idelibre;

--
-- Name: mandats; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE mandats (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    user_id uuid NOT NULL,
    collectivite_id uuid NOT NULL,
    created timestamp without time zone DEFAULT now() NOT NULL,
    modified timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE public.mandats OWNER TO idelibre;

--
-- Name: srvroles; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE srvroles (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    name character varying(255) NOT NULL,
    created timestamp without time zone,
    modified timestamp without time zone
);


ALTER TABLE public.srvroles OWNER TO idelibre;

--
-- Name: srvusers; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE srvusers (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    firstname character varying(255) NOT NULL,
    lastname character varying(255) NOT NULL,
    username character varying(255) NOT NULL,
    password character varying(255) NOT NULL,
    last_login timestamp without time zone,
    srvrole_id uuid NOT NULL,
    created timestamp without time zone,
    modified timestamp without time zone,
    active boolean DEFAULT true NOT NULL,
    last_logout timestamp without time zone,
    mail character varying(255),
    lang character varying(10)
);


ALTER TABLE public.srvusers OWNER TO idelibre;

--
-- Name: srvusers_mandats; Type: TABLE; Schema: public; Owner: idelibre; Tablespace:
--

CREATE TABLE srvusers_mandats (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    srvuser_id uuid,
    mandat_id uuid NOT NULL,
    created timestamp without time zone DEFAULT now() NOT NULL,
    modified timestamp without time zone DEFAULT now() NOT NULL
);


ALTER TABLE public.srvusers_mandats OWNER TO idelibre;

--
-- Name: cake_sessions_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY cake_sessions
    ADD CONSTRAINT cake_sessions_pkey PRIMARY KEY (id);


--
-- Name: collectivites_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY collectivites
    ADD CONSTRAINT collectivites_pkey PRIMARY KEY (id);


--
-- Name: collectivites_srvusers_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY collectivites_srvusers
    ADD CONSTRAINT collectivites_srvusers_pkey PRIMARY KEY (id);


--
-- Name: conn_unique_idx; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY collectivites
    ADD CONSTRAINT conn_unique_idx UNIQUE (conn);


--
-- Name: mandats_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY mandats
    ADD CONSTRAINT mandats_pkey PRIMARY KEY (id);


--
-- Name: name_unique_idx; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY collectivites
    ADD CONSTRAINT name_unique_idx UNIQUE (name);


--
-- Name: srvroles_name_unique_key; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvroles
    ADD CONSTRAINT srvroles_name_unique_key UNIQUE (name);


--
-- Name: srvroles_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvroles
    ADD CONSTRAINT srvroles_pkey PRIMARY KEY (id);


--
-- Name: srvusers_mail_unique_key; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvusers
    ADD CONSTRAINT srvusers_mail_unique_key UNIQUE (mail);


--
-- Name: srvusers_mandats_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvusers_mandats
    ADD CONSTRAINT srvusers_mandats_pkey PRIMARY KEY (id);


--
-- Name: srvusers_pkey; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvusers
    ADD CONSTRAINT srvusers_pkey PRIMARY KEY (id);


--
-- Name: srvusers_username_unique_key; Type: CONSTRAINT; Schema: public; Owner: idelibre; Tablespace:
--

ALTER TABLE ONLY srvusers
    ADD CONSTRAINT srvusers_username_unique_key UNIQUE (username);


--
-- Name: login_suffix_unique_idx; Type: INDEX; Schema: public; Owner: idelibre; Tablespace:
--

CREATE UNIQUE INDEX login_suffix_unique_idx ON collectivites USING btree (login_suffix) WHERE ((login_suffix)::text <> ''::text);


--
-- Name: public_key_unique_idx; Type: INDEX; Schema: public; Owner: idelibre; Tablespace:
--

CREATE UNIQUE INDEX public_key_unique_idx ON collectivites USING btree (public_key) WHERE (public_key <> '\x'::bytea);


--
-- Name: collectivites_srvusers_collectivite_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: idelibre
--

ALTER TABLE ONLY collectivites_srvusers
    ADD CONSTRAINT collectivites_srvusers_collectivite_id_fkey FOREIGN KEY (collectivite_id) REFERENCES collectivites(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: collectivites_srvusers_srvuser_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: idelibre
--

ALTER TABLE ONLY collectivites_srvusers
    ADD CONSTRAINT collectivites_srvusers_srvuser_id_fkey FOREIGN KEY (srvuser_id) REFERENCES srvusers(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: srvusers_mandats_mandat_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: idelibre
--

ALTER TABLE ONLY srvusers_mandats
    ADD CONSTRAINT srvusers_mandats_mandat_id_fkey FOREIGN KEY (mandat_id) REFERENCES mandats(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: srvusers_mandats_srvuser_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: idelibre
--

ALTER TABLE ONLY srvusers_mandats
    ADD CONSTRAINT srvusers_mandats_srvuser_id_fkey FOREIGN KEY (srvuser_id) REFERENCES srvusers(id) ON UPDATE CASCADE ON DELETE SET NULL;


--
-- Name: srvusers_srvrole_id_fkey; Type: FK CONSTRAINT; Schema: public; Owner: idelibre
--

ALTER TABLE ONLY srvusers
    ADD CONSTRAINT srvusers_srvrole_id_fkey FOREIGN KEY (srvrole_id) REFERENCES srvroles(id) ON UPDATE CASCADE ON DELETE CASCADE;


--
-- Name: public; Type: ACL; Schema: -; Owner: postgres
--

REVOKE ALL ON SCHEMA public FROM PUBLIC;
REVOKE ALL ON SCHEMA public FROM postgres;
GRANT ALL ON SCHEMA public TO postgres;
GRANT ALL ON SCHEMA public TO PUBLIC;


--
-- PostgreSQL database dump complete
--

