-- Correction de la gestion des identifiants des annotations
--
--
-- i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
--
-- @author Stéphane Sampaio
-- @copyright Adullact Projet
-- @link http://adullact.org/
-- @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
--
-- SVN Informations
-- $Date: 2013-10-21 17:57:34 +0200 (lun. 21 oct. 2013) $
-- $Revision: 302 $
-- $Author: ssampaio $
-- $HeadURL: svn+ssh://ssampaio@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Config/sql/999_utils_check_annotations.sql $
-- $Id: 999_utils_check_annotations.sql 302 2013-10-21 15:57:34Z ssampaio $

-- Attention, il faut au préalable exporter les données de ces deux tables pour pouvoir les réimporter



BEGIN;

DROP TABLE IF EXISTS annotations_users ;
DROP TABLE IF EXISTS annotations;

CREATE TABLE annotations (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    annot_client_id uuid,
    imgpage_id uuid NOT NULL,
    content bytea NOT NULL,
    created timestamp without time zone DEFAULT now(),
    modified timestamp without time zone,
    user_id uuid NOT NULL,
    shared boolean DEFAULT false NOT NULL,
    rank integer DEFAULT 0 NOT NULL,
    date timestamp without time zone,
    date_modif timestamp without time zone,
    height character varying(20),
    width character varying(20),
    x character varying(20),
    y character varying(20),
    comment character varying(255)
);

CREATE TABLE annotations_users (
    id uuid DEFAULT uuid_generate_v4() NOT NULL,
    user_id uuid NOT NULL,
    created timestamp without time zone DEFAULT now(),
    modified timestamp without time zone,
    annotation_id uuid NOT NULL,
    read boolean DEFAULT false NOT NULL
);

COMMIT;