<?php

App::uses('AppController', 'Controller');
App::uses('DevTools', 'Utility');
App::uses('ArrayTools', 'Utility');
App::uses('Horodatage', 'Utility');
App::import('Vendor', 'ElephantIOClient', array('file' => 'ElephantIO/Client.php'));

/**
 * Clients Controller
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-12-17 18:59:13 +0100 (mer. 17 déc. 2014) $
 * $Revision: 561 $
 * $Author: rdubourget $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Controller/ClientsController.php $
 * $Id: ClientsController.php 561 2014-12-17 17:59:13Z rdubourget $
 *
 * @property Client $Client
 */
class ClientsController extends AppController {

    /**
     *
     * @var type
     */
    public $uses = null;

    /**
     *
     * @var type
     */
    private $elephant;

    /**
     *
     * @var type
     */
    public $Horodatage;

    /**
     *
     * @var type
     */
    public $TSFile;

    /**
     *
     * @var type
     */
    public $TSToken;

    /**
     *  @function beforeFilter
     *  @description Autorise l'accès au contrôleur au public
     * */
    public function beforeFilter() {
        parent::beforeFilter();
        $this->Auth->allow();
    }

    /**
     *  @function getData
     *  @description Vérifie l'identité du client, redirige la demande en fonction du type de la requête et renvoie un résultat en JSON
     * */
    public function getData() {
//$this->log(__FILE__, LOG_ERROR);
        $data = json_encode($this->request->data['json']);
        DevTools::ldebug('data', true);
        DevTools::ldebug($data);
        // die;
        $type = $this->request->data['type'];
        if ($type !== "global auth") {
            //  On vérifie les identifiants donnés par l'appelant
            $cred = $this->_checkCredentials($data);
            //  On précise la base de données concernée par la requête (collectivité concernée)
            Configure::write('conn', $cred->db);
        }
        switch ($type) {
            //  Authentification du super-client (pour associer un portefeuille de mandats à un utilisateur)
            case "global auth":
                $this->globalAuth($data);
                break;
            //  Authentification du client (= un mandat)
            case "auth":
                $this->auth($data, $cred);
                break;
            //  Traitement d'un accusé réception
            case "ar":
                $this->ar($data, $cred);
                break;
            //  Traitement d'une annotation
            case "annot":
                $this->annot($data, $cred);
                break;
            //  Traitement d'une requête de synchronisation de seances
            case "sync seances":
                $this->syncSeances($data, $cred);
                break;
            //  Traitement d'une demande d'image de seances/projets
            case "imgpage":
                $this->imgpage($data, $cred);
                break;
            //  Traitement d'une requête de synchronisation d'annotations
            case "sync annots":
                $this->syncAnnotations($data, $cred);
                break;
            //  Traitement d'une requête de resynchronisation de seance
            case "reSync seances":
                $this->reSyncSeances($data, $cred);
                break;
        }
//$this->log(var_export(ClassRegistry::init('Imgpage')->getDataSource()->getLog(), true), LOG_ERROR);

    }

    /**
     *  @function _checkCredentials
     *  @param type $data
     *  @description Vérification des login/password de l'utilisateur (login/pwd d'un mandat)
     *  @return \stdClass
     */
    private function _checkCredentials($data) {


        $return = new stdClass();

        $json = json_decode($data);
        $loginParts = explode('@', $json->username); //a approfondir

        DevTools::ldebug($loginParts);

        if (count($loginParts) == 2) {
            $Collectivite = ClassRegistry::init(array('class' => 'Collectivite', 'ds' => 'default'));
            $qd = array(
                'fields' => array(
                    'conn'
                ),
                'conditions' => array(
                    'login_suffix' => $loginParts[1],
                    'active' => true
                )
            );
            $resConn = $Collectivite->find('first', $qd);

  //          DevTools::ldebug($resConn);
            // $deb = AuthComponent::password($json->password);
            // DevTools::ldebug($deb);


            if (!empty($resConn)) {
                $User = ClassRegistry::init(array('class' => 'User', 'ds' => $resConn['Collectivite']['conn']));
                $User->useDbConfig = $resConn['Collectivite']['conn'];
                $qd = array(
                    'recursive' => -1,
                    'fields' => array(
                        'id',
                        'firstname',
                        'lastname'
                    ),
                    'conditions' => array(
                        'username' => $loginParts[0],
                        'password' => $json->password
                    )
                );
                $resUser = $User->find('first', $qd);


//                DevTools::ldebug($resUser);

                if (!empty($resUser)) {
                    $return->logged = true;
                    $return->db = $resConn['Collectivite']['conn'];
                    $return->socketId = $json->socketId;
                    $return->userId = $resUser['User']['id'];
                    $return->firstname = $resUser['User']['firstname'];
                    $return->lastname = $resUser['User']['lastname'];
                } else {
                    $return->socketId = $json->socketId;
                }
            }
        } else {
            $return->socketId = $json->socketId;
        }
        return $return;
    }

    /**
     *  @function globalAuth
     *  @param type $data
     *  @description Vérification des identifiants du super-client et récupération de ses mandats associés 
     */
    private function globalAuth($data) {

        //DevTools::ldebug('globalAuth');

        try {

            $return = $this->_getMandats($data);
            if (!empty($return) && !empty($return->logged)) {

                $this->set('data', json_encode(array('name' => 'global auth feedback', 'args' => $return)));
            } else {
                //$this->set('data', json_encode(array('name' => 'logout', 'args' => $return)));
                $this->set('data', json_encode(array('name' => 'global auth feedback', 'args' => $return)));
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    /**
     *  @function auth
     *  @param type $data
     *  @param type $cred
     *  @description Renvoie le résultat de la vérification des identifiants d'un mandat
     *  @todo Factoriser (la fonction fait doublon avec checkCredentials)
     */
    private function auth($data, $cred) {
        $this->set('data', json_encode(array('name' => 'auth feedback', 'args' => $cred)));
    }

    /**
     *  @function ar
     *  @param type $data
     *  @param type $cred
     *  @description Informe le client et la base de données que la convocation est lue
     */
    private function ar($data, $cred) {
$this->log(var_export($data, true), LOG_ERROR);        
	try {
$this->log(__LINE__, LOG_ERROR);

            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);
                $toSend = new stdClass();
                $toSend->data = $this->_setConvocationRed($json->seanceId, $cred->userId, $cred->db);
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = true; //FIXME: résultat du traitement
                $toSend->from = 'srv';

                $this->set('data', json_encode(array('name' => 'ar feedback', 'args' => $toSend)));
            }
        } catch (Exception $exc) {
$this->log(__LINE__, LOG_ERROR);

            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    /**
     *  @function _setConvocationRed
     *  @param type $seanceId
     *  @param type $userId
     *  @param type $conn
     *  @description Valide la lecture de la convocation et attache un jeton d'horodatage
     *  @return string
     *  @throws NotFoundException
     */
    private function _setConvocationRed($seanceId, $userId, $conn) {

        $return = array(
            'success' => false,
            'errorMsg' => __d('convocation', 'setRead.error')
        );

        $Convocation = ClassRegistry::init('Convocation');

        $User = ClassRegistry::init('User');

        $Collectivite = ClassRegistry::init(array('class' => 'Collectivite', 'ds' => 'default'));


        //        $this->Horodatage = & new HorodatageComponent(new ComponentCollection());

        if (!$Convocation->User->exists($userId) || !$Convocation->Seance->exists($seanceId)) {
            throw new NotFoundException();
        }

        $convoc = $Convocation->find('first', array('conditions' => array('Convocation.seance_id' => $seanceId, 'Convocation.user_id' => $userId)));

        if (empty($convoc)) {
            throw new NotFoundException();
        }

        $convoc['Convocation']['read'] = true;
        $convoc['Convocation']['ar_received'] = date('Y-m-d H:i:s');

        $baseFileName = Security::hash($convoc['Convocation']['id'] . $convoc['Convocation']['ar_horodatage']);
        $this->TSFile = new File(TMP . DS . 'horodatage' . $baseFileName);

        $tsFileContent = "i-delibRE - Timestamp\n" .
                "controller : ElephantIOShell\n" .
                "action : ar\n" .
                "organisation : " . $Collectivite->field('name', array('conn' => $conn)) . " : " . $Collectivite->field('id', array('conn' => $conn)) . "\n" .
                "user : " . $User->field('name', array('id' => $userId)) . " : " . $userId . "\n" .
                "seance : " . $seanceId . "\n" .
                "convocation : " . $convoc['Convocation']['id'] . "\n" .
                "server timestamp : " . $convoc['Convocation']['ar_received'];
        $this->TSFile->write($tsFileContent);

        try {
            if (Horodatage::check()) {
                $resp = Horodatage::horodateFichier($this->TSFile->path);
                if ($resp['responseToText']) {
                    for ($i = 0; $i < count($resp['responseToText']); $i++) {
                        $matches = array();
                        if (preg_match("#Time stamp: (.*)#", $resp['responseToText'][$i], $matches)) {
                            if (count($matches) > 1) {
                                $date = DateTime::createFromFormat('M j H:i:s Y O', $matches[1]);
                                $convoc['Convocation']['ar_horodatage'] = date('Y-m-d H:i:s', CakeTime::convert($date->getTimestamp(), null));
                            }
                        }
                    }
                    $convoc['Convocation']['ar_horodatage_file'] = $this->TSFile->read();
                    $this->TSToken = new File($this->TSFile->path . '.rep.tsa');
                    $convoc['Convocation']['ar_horodatage_token'] = $this->TSToken->read();
                } else {
                    $convoc['Convocation']['ar_received'] = null;
                    $convoc['Convocation']['ar_horodatage'] = date('Y-m-d H:i:s');
                }
            } else {
                $convoc['Convocation']['ar_received'] = null;
                $convoc['Convocation']['ar_horodatage'] = date('Y-m-d H:i:s');
            }

            $Convocation->create();
            if ($Convocation->save($convoc)) {
                $return['success'] = true;
                $return['errorMsg'] = "";
            }

            if (!empty($this->TSFile)) {
                $this->TSFile->delete();
            }
            if (Horodatage::check() && !empty($this->TSToken)) {
                $this->TSToken->delete();
            }
        } catch (Exception $exc) {
            $data['errorMsg'] = __d('convocation', 'setRead.error:' + ' ' + var_export($exc, true));
        }
        return $return;
    }

    /**
     *  @function annot
     *  @param type $data
     *  @param type $cred
     *  @description Enregistre/edite/supprime une annotation envoyée par le client, confirme l'opération au client concerné et envoie la modification aux autres clients concernés (si annotation partagée)
     */
    private function annot($data, $cred) {
    //    DevTools::ldebug($data);
    //    DevTools::ldebug($cred);
        try {
            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);
                $conn = $cred->db;
                $Annotation = ClassRegistry::init('Annotation');

                $result = array();

                $users = array(
                    'push' => array(),
                    'delete' => array()
                );

                $annot = null;
                if ($json->action == "erase") {
                    $shared = $Annotation->getSharedUsers($json->annot->id);
                    $Annotation->begin();

                    $resultDelete = array();
                    foreach ($shared as $link => $user) {
                        $resultDelete[$user] = $Annotation->AnnotationsUser->delete($link);
                    }

                    if (!in_array(false, $resultDelete, true)) {
                        $result = $Annotation->delete($json->annot->id);
                    }

                    if (!empty($result)) {
                        $users['delete'] = array_keys($resultDelete);
                        $Annotation->commit();
                    } else {
                        $Annotation->rollback();
                    }
                } else if ($json->action == 'read') {
                    $result = $Annotation->setRead($json->client->userId, $json->annot->id);
                } else if ($json->action == 'edit') {
                    $result = $Annotation->updateJsonAnnot($json->annot);
                    $annot = $this->_convertAnnotation($result['Annotation'], $json->annot->page, $json->annot->lue);

                    $resultUnshare = $Annotation->unshare($result['Annotation']['id'], $json->annot->listePartage);
                    if (!empty($resultUnshare)) {
                        $users['delete'] = $resultUnshare;
                    }

                    $resultShare = $Annotation->share($result['Annotation']['id'], $json->annot->listePartage);
                    if (!empty($resultShare)) {
                        foreach ($resultShare as $user) {
                            if ($user[2]) {
                                $users['push'][] = $user[1];
                            }
                        }
                    }

                    $annot['listePartage'] = $json->annot->listePartage;

                    $qdAnnotFromDb = array(
                        'contain' => array(
                            'Imgpage' => array(
                                'fields' => array(
                                    'Imgpage.id',
                                    'Imgpage.imgpagenum'
                                ),
                                'Document' => array(
                                    'fields' => array(
                                        'Document.id'
                                    )
                                )
                            ),
                            'AnnotationsUser'
                        ), 'conditions' => array(
                            'Annotation.id' => $result['Annotation']['id']
                        )
                    );

                    $annotFromDb = $Annotation->find('first', $qdAnnotFromDb);
                    $annot['document_id'] = $annotFromDb['Imgpage']['Document']['id'];
                    $annot['imgpage_id'] = $annotFromDb['Imgpage']['id'];
                    $annot['imgpagenum'] = $annotFromDb['Imgpage']['imgpagenum'];
                    $annot['read'] = !empty($annotFromDb['AnnotationsUser']) && isset($annotFromDb['AnnotationsUser']['read']) ? $annotFromDb['AnnotationsUser']['read'] : true;
                } else if ($json->action == 'create') {
                    $result = $Annotation->createJsonAnnot($json->annot);
                    $annot = $this->_convertAnnotation($result['Annotation'], $json->annot->page, $json->annot->lue);

                    $resultShare = $Annotation->share($result['Annotation']['id'], $json->annot->listePartage);
                    if (!empty($resultShare)) {
                        foreach ($resultShare as $user) {
                            if ($user[2]) {
                                $users['push'][] = $user[1];
                            }
                        }
                    }

                    $annot['listePartage'] = $json->annot->listePartage;
                    $qdAnnotFromDb = array(
                        'contain' => array(
                            'Imgpage' => array(
                                'fields' => array(
                                    'Imgpage.id',
                                    'Imgpage.imgpagenum'
                                ),
                                'Document' => array(
                                    'fields' => array(
                                        'Document.id'
                                    )
                                )
                            ),
                            'AnnotationsUser'
                        ), 'conditions' => array(
                            'Annotation.id' => $result['Annotation']['id']
                        )
                    );

                    $annotFromDb = $Annotation->find('first', $qdAnnotFromDb);
                    $annot['document_id'] = $annotFromDb['Imgpage']['Document']['id'];
                    $annot['imgpage_id'] = $annotFromDb['Imgpage']['id'];
                    $annot['imgpagenum'] = $annotFromDb['Imgpage']['imgpagenum'];
                    $annot['read'] = !empty($annotFromDb['AnnotationsUser']) && isset($annotFromDb['AnnotationsUser']['read']) ? $annotFromDb['AnnotationsUser']['read'] : true;
                }

                $toSend = new stdClass();
                $toSend->data = !empty($annot) ? $annot : $result;
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = !empty($result); //FIXME: résultat du traitement
                $toSend->action = $json->action;
                $toSend->from = 'srv';
                $toSend->type = 'annot feedback';

                $this->set('data', json_encode(array('name' => 'annot feedback', 'args' => $toSend)));

                if (!empty($users['push'])) {
                    $toSend->users = $users['push'];
                    $toSend->data['lue'] = false;
                    $toSend->type = 'annot push';
                    $toSend->socketId = $cred->socketId;
                    $this->set('data', json_encode(array('name' => 'annot push', 'args' => $toSend)));
                }

                if (!empty($users['delete'])) {
                    $toSend->users = $users['delete'];
                    $toSend->data = $json->annot->id;
                    $toSend->type = 'annot push delete';
                    $toSend->socketId = $cred->socketId;
                    $this->set('data', json_encode(array('name' => 'annot push delete', 'args' => $toSend)));
                }
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    /**
     *  @function _getSeances
     *  @param type $userId
     *  @param type $conn
     *  @param type $escapeSeances
     *  @description Récupération de l'ensemble des séances et de ses dépendances dans un format JSON (tableau PHP)
     *  @return type
     */
    private function _getSeances($userId, $conn, $escapeSeances) {
        $Seance = ClassRegistry::init('Seance');


        //récupération des identifiants de convocation et de séance concernant l'identifiant de l'utilisateur donné
        $qdConvocations = array(
            'fields' => array(
                'Convocation.id',
                'Convocation.seance_id'
            ),
            'conditions' => array(
                'Convocation.user_id' => $userId,
                'Convocation.active' => true,
                array('not' => array('Convocation.seance_id' => $escapeSeances))
            ),
            'recursive' => -1
        );
        $convocs = $Seance->Convocation->find('list', $qdConvocations);

        //récupération des informations concernant les séances auxquelles est convoqué l'utilisateur désigné par l'identifiant donné
        $qd = array(
            'fields' => array(
                'Seance.id',
                'Seance.name',
                'Seance.date_seance',
                'Seance.document_id',
                'Seance.rev'
            ),
            'contain' => array(
                'Document' => array(
                    'fields' => array(
                        'Document.id',
                        'Document.name'
                    ),
                    'Imgpage' => array(
                        'fields' => array(
                            'Imgpage.id',
                            'Imgpage.name',
                            'Imgpage.imgpagenum',
                            'Imgpage.document_id'
                        )
                    ),
                ),
                'Convocation' => array(
                    'fields' => array(
                        'Convocation.id',
                        'Convocation.read',
                        'Convocation.seance_id'
                    ),
                    'User' => array(
                        'fields' => array(
                            "User.id",
                            "User.firstname",
                            "User.lastname"
                        )
                    )
                ),
                'Projet' => array(
		'order' => array("Projet.rank"),
                    'fields' => array(
                        "Projet.id",
                        "Projet.name",
                        "Projet.document_id",
                        "Projet.seance_id",
                        "Projet.vote",
                        "Projet.ptheme_id",
                        "Projet.rank"
                    ),
                    'Annex' => array(
                        'fields' => array(
                            'Annex.id',
                            'Annex.name'
                        )
                    ),
                    'Document' => array(
                        'fields' => array(
                            'Document.id',
                            'Document.name'
                        ),
                        'Imgpage' => array(
                            'fields' => array(
                                "Imgpage.id",
                                "Imgpage.name",
                                "Imgpage.imgpagenum",
                                "Imgpage.document_id"
                            )
                        )
                    )
                )
            ),
            'conditions' => array(
                'Seance.id' => $convocs
            ),
            'order' => array(
                'Seance.date_seance DESC'
            )
        );
        $return = $Seance->find('all', $qd);

        //traitements après récupération des informations pour transfert vers client
        for ($i = 0; $i < count($return); $i++) {
            //recupération des branches complètes de pthemes pour chaque projet de chaque seance
            for ($j = 0; $j < count($return[$i]['Projet']); $j++) {

                // try catch pour le cas d'absence de theme
                try {
                    $return[$i]['Projet'][$j]['theme'] = trim(implode(', ', Hash::extract($Seance->Projet->Ptheme->getPath($return[$i]['Projet'][$j]['ptheme_id']), "{n}.Ptheme.name")));
                } catch (Exception $e) {

                    $this->log(var_export($e->getMessage(), true), LOG_ERROR);
                }
            }
            
            
            
            
 //           $this->log('milieu', LOG_ERROR);
            //préparation de la liste des utilisateurs pour les annotations partagées
            //FIXME: faire en sorte que le client sache lire  lui-même les utilisateurs
            $return[$i]['Users'] = array();
            foreach ($return[$i]['Convocation'] as $key => $convoc) {
                $return[$i]['Users'][] = $convoc['User'];
  
  // ajouter pour supprimer la liste de toute les convocation pour chaque user              
 //               if($key != 0){
 //                   $this->log(var_export($return[$i]['Convocation'][$key],true), LOG_ERROR);
 //                  unset($return[$i]['Convocation'][$key]);
 //               }
                
                

            }

        }
        
        //        Configure::write('conn', 'default');
        return $return;
    }

    
    
    private function _reGetSeances($userId, $conn, $escapeSeances) {
        $Seance = ClassRegistry::init('Seance');


        //récupération des identifiants de convocation et de séance concernant l'identifiant de l'utilisateur donné
        $qdConvocations = array(
            'fields' => array(
                'Convocation.id',
                'Convocation.seance_id'
            ),
            'conditions' => array(
                'Convocation.user_id' => $userId,
                'Convocation.active' => true,
            //    array('not' => array('Convocation.seance_id' => $escapeSeances))
            ),
            'recursive' => -1
        );
        $convocs = $Seance->Convocation->find('list', $qdConvocations);

        //récupération des informations concernant les séances auxquelles est convoqué l'utilisateur désigné par l'identifiant donné
        $qd = array(
            'fields' => array(
                'Seance.id',
                'Seance.name',
                'Seance.date_seance',
                'Seance.document_id',
                'Seance.rev'
            ),
            'contain' => array(
                'Document' => array(
                    'fields' => array(
                        'Document.id',
                        'Document.name'
                    ),
                    'Imgpage' => array(
                        'fields' => array(
                            'Imgpage.id',
                            'Imgpage.name',
                            'Imgpage.imgpagenum',
                            'Imgpage.document_id'
                        )
                    ),
                ),
                'Convocation' => array(
                    'fields' => array(
                        'Convocation.id',
                        'Convocation.read',
                        'Convocation.seance_id'
                    ),
                    'User' => array(
                        'fields' => array(
                            "User.id",
                            "User.firstname",
                            "User.lastname"
                        )
                    )
                ),
                'Projet' => array(
                    'fields' => array(
                        "Projet.id",
                        "Projet.name",
                        "Projet.document_id",
                        "Projet.seance_id",
                        "Projet.vote",
                        "Projet.ptheme_id",
                        "Projet.rank"
                    ),
                    'Annex' => array(
                        'fields' => array(
                            'Annex.id',
                            'Annex.name'
                        )
                    ),
                    'Document' => array(
                        'fields' => array(
                            'Document.id',
                            'Document.name'
                        ),
                        'Imgpage' => array(
                            'fields' => array(
                                "Imgpage.id",
                                "Imgpage.name",
                                "Imgpage.imgpagenum",
                                "Imgpage.document_id"
                            )
                        )
                    )
                )
            ),
            'conditions' => array(
                'Seance.id' => $convocs
            ),
            'order' => array(
                'Seance.date_seance DESC'
            )
        );
        $return = $Seance->find('all', $qd);


        //traitements après récupération des informations pour transfert vers client
        for ($i = 0; $i < count($return); $i++) {
            //recupération des branches complètes de pthemes pour chaque projet de chaque seance
            for ($j = 0; $j < count($return[$i]['Projet']); $j++) {
                $return[$i]['Projet'][$j]['theme'] = trim(implode(', ', Hash::extract($Seance->Projet->Ptheme->getPath($return[$i]['Projet'][$j]['ptheme_id']), "{n}.Ptheme.name")));
            }

            //préparation de la liste des utilisateurs pour les annotations partagées
            //FIXME: faire en sorte que le client sache lire  lui-même les utilisateurs
            $return[$i]['Users'] = array();
            foreach ($return[$i]['Convocation'] as $convoc) {
                $return[$i]['Users'][] = $convoc['User'];
            }
        }
        //        Configure::write('conn', 'default');
        return $return;
    }

    private function _getProjet($userId, $conn, $seance_id) {
        $Seance = ClassRegistry::init('Seance');

        //récupération des informations concernant les séances auxquelles est convoqué l'utilisateur désigné par l'identifiant donné


        $qd = array(
            'fields' => array(
                'Seance.id',
                'Seance.name',
            //'Seance.date_seance',
            //'Seance.document_id'
            ),
            'contain' => array(
                /* 'Document' => array(
                  'fields' => array(
                  'Document.id',
                  'Document.name'
                  ),
                  'Imgpage' => array(
                  'fields' => array(
                  'Imgpage.id',
                  'Imgpage.name',
                  'Imgpage.imgpagenum',
                  'Imgpage.document_id'
                  )
                  ),
                  ), */
                /* 'Convocation' => array(
                  'fields' => array(
                  'Convocation.id',
                  'Convocation.read',
                  'Convocation.seance_id'
                  ),
                  'User' => array(
                  'fields' => array(
                  "User.id",
                  "User.firstname",
                  "User.lastname"
                  )
                  )
                  ), */
                'Projet' => array(
                    'fields' => array(
                        "Projet.id",
                        "Projet.name",
                        "Projet.document_id",
                        "Projet.seance_id",
                        "Projet.vote",
                        "Projet.ptheme_id",
                        "Projet.rank"
                    // projet annule
                    ),
                    'Annex' => array(
                        'fields' => array(
                            'Annex.id',
                            'Annex.name'
                        )
                    ),
                    'Document' => array(
                        'fields' => array(
                            'Document.id',
                            'Document.name'
                        ),
                        'Imgpage' => array(
                            'fields' => array(
                                "Imgpage.id",
                                "Imgpage.name",
                                "Imgpage.imgpagenum",
                                "Imgpage.document_id"
                            )
                        )
                    )
                )
            ),
            'conditions' => array(
                'Seance.id' => $seance_id
            ),
        );
        $return = $Seance->find('first', $qd);






        //traitements après récupération des informations pour transfert vers client
        //recupération des branches complètes de pthemes pour chaque projet de la seance
        for ($j = 0; $j < count($return['Projet']); $j++) {
            $return['Projet'][$j]['theme'] = trim(implode(', ', Hash::extract($Seance->Projet->Ptheme->getPath($return['Projet'][$j]['ptheme_id']), "{n}.Ptheme.name")));
        }


        //préparation de la liste des utilisateurs pour les annotations partagées
        //FIXME: faire en sorte que le client sache lire  lui-même les utilisateurs
        // normalement deja present car il s'agit d'une modif d'une convocation deja existante sans modification de la listes des elus
        /* $return[$i]['Users'] = array();
          foreach ($return[$i]['Convocation'] as $convoc) {
          $return[$i]['Users'][] = $convoc['User'];
          } */
        //}
        //        Configure::write('conn', 'default');


        return $return;
    }

    /**
     *  @function _getMandats
     *  @param type $data
     *  @description Récupération de l'ensemble des mandats appartement à un super-client
     */
    /*   private function _getMandats($data) {
      $return = new stdClass();
      $json = json_decode($data);


      $this->loadModel("Srvuser");


      //recherche de l'utilisateur trousseau
      $qd = array(
      'recursive' => -1,
      'fields' => array(
      'id',
      'firstname',
      'lastname'
      ),
      'conditions' => array(
      'username' => $json->login,
      'password' => AuthComponent::password($json->password)
      )
      );
      $resSrvuser = $this->Srvuser->find('first', $qd);


      //recherche des mandats associés à l'utilisateur trousseau
      $qdMandats = array(
      'contain' => false,
      'joins' => array(
      $this->Srvuser->Mandat->join($this->Srvuser->Mandat->SrvusersMandat->alias)
      ),
      'conditions' => array(
      'SrvusersMandat.srvuser_id' => $resSrvuser['Srvuser']['id']
      ),
      'fields' => array(
      'Mandat.user_id',
      'Mandat.collectivite_id'
      )
      );
      $mandats = $this->Srvuser->Mandat->find('all', $qdMandats);

      //recupération des infos de chaque mandat
      $this->loadModel('Collectivite');
      $this->loadModel('User');
      $accounts = array();

      foreach ($mandats as $mandat) {
      //recuperation des infos de la collectivité relative au mandat
      $currentColl = $this->Collectivite->find('first', array('fields' => array('conn', 'login_suffix'), 'conditions' => array('id' => $mandat['Mandat']['collectivite_id'])));
      $this->User->setDataSource($currentColl['Collectivite']['conn']); //pour choisir la bonne connexion a la base de données

      //recherche de l'utilisateur de la collectivité
      $qdUser = array(
      'conditions' => array(
      'id' => $mandat['Mandat']['user_id']
      ),
      'fields' => array(
      'firstname',
      'lastname',
      'username',
      'password',
      'id'
      )
      );
      $user = $this->User->find('first', $qdUser);

      if (!empty($user)) { // si on trouve un utilisateur on renvoi ses infos
      $user['User']['login_suffix'] = $currentColl['Collectivite']['login_suffix'];
      $user['User']['fullname'] = ucfirst($user['User']['firstname']) . ' ' . ucfirst($user['User']['lastname']);
      $user['User']['login'] = $user['User']['username'] . '@' . $user['User']['login_suffix'];
      $accounts[] = $user;
      }
      }


      if (!empty($resSrvuser)) {
      DevTools::ldebug('avant le return du get mandat');
      $return->logged = true;
      $return->socketId = $json->socketId;
      $return->userId = $resSrvuser['Srvuser']['id'];
      $return->accounts = $accounts;
      $return->firstname = $resSrvuser['Srvuser']['firstname'];
      $return->lastname = $resSrvuser['Srvuser']['lastname'];
      } else {
      $return->socketId = $json->socketId;
      }

      return $return;
      } */







    private function _getMandats($data) {
        $return = new stdClass();
        $json = json_decode($data);


        $this->loadModel("Srvuser");


        //recherche de l'utilisateur trousseau
        $qd = array(
            'recursive' => -1,
            'fields' => array(
                'id',
                'firstname',
                'lastname'
            ),
            'conditions' => array(
                'username' => $json->login,
                'password' => AuthComponent::password($json->password)
            )
        );
        $resSrvuser = $this->Srvuser->find('first', $qd);

        if (!empty($resSrvuser)) {
            //recherche des mandats associés à l'utilisateur trousseau
            $qdMandats = array(
                'contain' => false,
                'joins' => array(
                    $this->Srvuser->Mandat->join($this->Srvuser->Mandat->SrvusersMandat->alias)
                ),
                'conditions' => array(
                    'SrvusersMandat.srvuser_id' => $resSrvuser['Srvuser']['id']
                ),
                'fields' => array(
                    'Mandat.user_id',
                    'Mandat.collectivite_id'
                )
            );
            $mandats = $this->Srvuser->Mandat->find('all', $qdMandats);

            //recupération des infos de chaque mandat
            $this->loadModel('Collectivite');
            $this->loadModel('User');
            $accounts = array();

            foreach ($mandats as $mandat) {
                //recuperation des infos de la collectivité relative au mandat
                $currentColl = $this->Collectivite->find('first', array('fields' => array('conn', 'login_suffix'), 'conditions' => array('id' => $mandat['Mandat']['collectivite_id'])));
                $this->User->setDataSource($currentColl['Collectivite']['conn']); //pour choisir la bonne connexion a la base de données
                //recherche de l'utilisateur de la collectivité
                $qdUser = array(
                    'conditions' => array(
                        'id' => $mandat['Mandat']['user_id']
                    ),
                    'fields' => array(
                        'firstname',
                        'lastname',
                        'username',
                        'password',
                        'id'
                    )
                );
                $user = $this->User->find('first', $qdUser);

                if (!empty($user)) { // si on trouve un utilisateur on renvoi ses infos
                    $user['User']['login_suffix'] = $currentColl['Collectivite']['login_suffix'];
                    $user['User']['fullname'] = ucfirst($user['User']['firstname']) . ' ' . ucfirst($user['User']['lastname']);
                    $user['User']['login'] = $user['User']['username'] . '@' . $user['User']['login_suffix'];
                    $accounts[] = $user;
                }
            }


            //if (!empty($resSrvuser)) {
            DevTools::ldebug('avant le return du get mandat');
            $return->logged = true;
            $return->socketId = $json->socketId;
            $return->userId = $resSrvuser['Srvuser']['id'];
            $return->accounts = $accounts;
            $return->firstname = $resSrvuser['Srvuser']['firstname'];
            $return->lastname = $resSrvuser['Srvuser']['lastname'];
        } else {
            $return->socketId = $json->socketId;
        }

        return $return;
    }

    /**
     *  @function _getDeletedSeances
     *  @param type $userId
     *  @param type $conn
     *  @param type $seanceIds
     *  @description 
     *  @return type
     */
    private function _getDeletedSeances($userId, $conn, $seanceIds) {
        $Seance = ClassRegistry::init('Seance');
        $toRemove = array();
        foreach ($seanceIds as $seanceId) {
            if (!$Seance->exists($seanceId)) {
                $toRemove[] = $seanceId;
            }
        }
        return $toRemove;
    }

    /**
     *  @function syncSeances
     *  @param type $data
     *  @param type $cred
     *  @description Récupération de l'ensemble des séances disponibles pour l'appelant et dont l'appelant ne dispose pas déjà
     */
    private function syncSeances($data, $cred) {
        try {
            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);

                $toSend = new stdClass();

                $toSend->data = array('new' => $this->_getSeances($cred->userId, $cred->db, $json->seances), 'toRemove' => $this->_getDeletedSeances($cred->userId, $cred->db, $json->seances));
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = true;
                $toSend->from = 'srv';
                $toSend->type = 'sync seances feedback';
                $this->set('data', json_encode(array('name' => 'sync seances feedback', 'args' => $toSend)));
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    private function reSyncSeances($data, $cred) {
        DevTools::ldebug('dans le resyncseances du ws');
        try {
            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);

                $toSend = new stdClass();

                $toSend->data = array('new' => $this->_reGetSeances($cred->userId, $cred->db, $json->seances)); //, 'toRemove' => $this->_getDeletedSeances($cred->userId, $cred->db, $json->seances));
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = true;
                $toSend->from = 'srv';
                $toSend->type = 'reSync seances feedback';
                $this->set('data', json_encode(array('name' => 'reSync seances feedback', 'args' => $toSend)));
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    /**
     *  @function _getAnnotations
     *  @param type $userId
     *  @param type $conn
     *  @param type $escapeAnnotations
     *  @return type
     *  @description Récupération de l'ensemble des annotations du l'utilisateur concerné moins les annotations dont il dispose déjà
     */
    private function _getAnnotations($userId, $conn, $escapeAnnotations) {
        //        Configure::write('conn', $conn);
        $Document = ClassRegistry::init('Document');

        //        $this->loadModel('Document');
        $Document->Behaviors->attach('DatabaseTable', array('forceSameDatasource' => true));

        $own = $this->_process($Document, $this->_getOwn($Document, $userId, $escapeAnnotations, $conn), $conn);
        $shared = $this->_process($Document, $this->_getShared($Document, $userId, $escapeAnnotations, $conn), $conn);

        //        Configure::write('conn', 'default');
        return array_merge($own, $shared);
    }

    /**
     *  @function _getOwn
     *  @param type $model
     *  @param type $userId
     *  @param type $escapeAnnotations
     *  @param type $conn
     *  @description Récupération des annotation personnelles de l'utlisateur connecté
     *  @return array
     */
    private function _getOwn($model, $userId, $escapeAnnotations, $conn) {
        $qd = array(
            'recursive' => -1,
            'contain' => false,
            'joins' => array(
                $model->join($model->Seance->alias),
                $model->Seance->join($model->Seance->Convocation->alias),
                $model->join($model->Imgpage->alias),
                $model->Imgpage->join($model->Imgpage->Annotation->alias),
                $model->Imgpage->Annotation->join($model->Imgpage->Annotation->Owner->alias)
            ),
            'fields' => array(
                'Document.id',
                'Imgpage.id',
                'Imgpage.imgpagenum',
                'Owner.id',
                'Owner.firstname',
                'Owner.lastname',
                'Annotation.id',
                'Annotation.user_id',
                'Annotation.shared',
                'Annotation.x',
                'Annotation.y',
                'Annotation.y',
                'Annotation.height',
                'Annotation.width',
                'Annotation.date',
                'Annotation.date_modif',
                'Annotation.comment',
                'Annotation.annot_client_id',
                'Annotation.content'
            ),
            'conditions' => array(
                'Annotation.user_id' => $userId,
                array('not' => array('Annotation.id' => $escapeAnnotations))
            ),
            'order' => array(
                'Document.id',
                'Imgpage.imgpagenum'
            )
        );

        return $model->find('all', $qd);
    }

    /**
     *  @function _getShared
     *  @param type $model
     *  @param type $userId
     *  @param type $escapeAnnotations
     *  @param type $conn
     *  @description Récupération des annotations partagées de l'utlisateur connecté
     *  @return array
     */
    private function _getShared($model, $userId, $escapeAnnotations, $conn) {
        $annotationsUser = ClassRegistry::init('AnnotationsUser');

        $qd = array(
            'recursive' => -1,
            'contain' => false,
            'joins' => array(
                $model->join($model->Seance->alias),
                $model->Seance->join($model->Seance->Convocation->alias),
                $model->join($model->Imgpage->alias),
                $model->Imgpage->join($model->Imgpage->Annotation->alias),
                $annotationsUser->Annotation->join($annotationsUser->alias),
                $annotationsUser->join($annotationsUser->User->alias),
            ),
            'fields' => array(
                'Document.id',
                'Imgpage.id',
                'Imgpage.imgpagenum',
                'User.id',
                'User.username',
                'User.firstname',
                'User.lastname',
                'Annotation.id',
                'Annotation.user_id',
                'Annotation.shared',
                'Annotation.x',
                'Annotation.y',
                'Annotation.y',
                'Annotation.height',
                'Annotation.width',
                'Annotation.date',
                'Annotation.date_modif',
                'Annotation.comment',
                'Annotation.content',
                'Annotation.annot_client_id',
                'AnnotationsUser.read'
            ),
            'conditions' => array(
                'AnnotationsUser.user_id' => $userId,
                array('not' => array('Annotation.id' => $escapeAnnotations))
            ),
            'order' => array(
                'Document.id',
                'Imgpage.imgpagenum'
            )
        );

        return $model->find('all', $qd);
    }

    /**
     *  @function _process
     *  @param type $model
     *  @param type $annots
     *  @param type $conn
     *  @description Conversion des données relative aux annotations récupérées par $this->_getShared et $this->_getOwn
     */
    private function _process($model, $annots, $conn) {
        $return = array();
        if (!empty($annots)) {
            for ($i = 0; $i < count($annots); $i++) {

                $imgpagenum = $annots[$i]['Imgpage']['imgpagenum'];
                $read = isset($annots[$i]['AnnotationsUser']['read']) ? $annots[$i]['AnnotationsUser']['read'] : true;

                $annot = $this->_convertAnnotation($annots[$i]['Annotation'], $imgpagenum, $read);
                $annot['listePartage'] = $this->_getUsersToShare($model, $annots[$i]['Annotation'], $conn);
                $annot['document_id'] = $annots[$i]['Document']['id'];
                $annot['imgpage_id'] = $annots[$i]['Imgpage']['id'];

                $return[] = $annot;
            }
        }
        return $return;
    }

    /**
     *  @see APP/webroot/js/annotation.json
     *  @function _convertAnnotation
     *  @param array $annotation
     *  @param int $imgpagenum
     *  @description Conversion d'une annotation en base vers une annotation pour le client
     *  @return array
     */
    private function _convertAnnotation($annotation, $imgpagenum, $read = true) {
        return array(
            "id" => $annotation['id'],
            "id_utilisateur" => $annotation['user_id'],
            "page" => $imgpagenum,
            "type" => $annotation['shared'],
            "x" => $annotation['x'],
            "y" => $annotation['y'],
            "largeur" => $annotation['width'],
            "hauteur" => $annotation['height'],
            "date" => !empty($annotation['date']) ? $this->_postgres2JsTimestamp($annotation['date']) : (!empty($annotation['created']) ? $this->_postgres2JsTimestamp($annotation['created']) : $this->_postgres2JsTimestamp('') ),
            "date_modif" => !empty($annotation['date_modif']) ? $this->_postgres2JsTimestamp($annotation['date_modif']) : (!empty($annotation['modified']) ? $this->_postgres2JsTimestamp($annotation['modified']) : $this->_postgres2JsTimestamp('') ),
            "lue" => $read,
            "texteInformations" => $annotation['comment'],
            "texteChamps" => $annotation['content'],
            "annot_client_id" => !empty($annotation['annot_client_id']) ? $annotation['annot_client_id'] : '',
                //            "imgpage_id" => $annotation['imgpage_id']
        );
    }

    /**
     *  @todo enlever le parametre $model
     *  @function _getUsersToShare
     *  @param type $model
     *  @param array $annotation
     *  @param type $conn
     *  @description Récupère les utilisateurs concernés par le partage d'une annotation
     *  @return array
     */
    private function _getUsersToShare($model, $annotation, $conn) {
        $return = array();
        $AnnotationsUser = ClassRegistry::init('AnnotationsUser');


        $qd = array(
            'conditions' => array(
                'AnnotationsUser.annotation_id' => $annotation['id']
            ),
            'joins' => array(
                $AnnotationsUser->join($AnnotationsUser->User->alias)
            ),
            'fields' => array(
                '("User"."firstname" || \' \' || "User"."lastname") AS "User__fullname"',
                'User.id',
                '1 AS "User__sharedstatus"'
            )
        );
        $results = $AnnotationsUser->find('all', $qd);

        foreach ($results as $result) {
            $return[] = array_values($result['User']);
        }

        return $return;
    }

    /**
     *  @function _postgres2JsTimestamp
     *  @param type $pgTimestamp
     *  @description 
     *  @return type
     */
    private function _postgres2JsTimestamp($pgTimestamp) {
        $return = intval(time()) * 1000;
        if (!empty($pgTimestamp) && $pgTimestamp != 'now()') {
            $tmp = explode(' ', $pgTimestamp);
            $date = explode('-', $tmp[0]);
            $time = explode(':', $tmp[1]);
            $return = intval(time(intval($time[0]), intval($time[1]), intval($time[2]), intval($date[1]), intval($date[2]), intval($date[0]))) * 1000;
        }
        return $return;
    }

    /**
     *  @function syncAnnotations
     *  @param type $data
     *  @param type $cred
     *  @description Retourne l'ensemble des annotations trouvées par _getAnnotations à l'appelant
     */
    private function syncAnnotations($data, $cred) {
        try {
            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);
                $toSend = new stdClass();
                $toSend->data = $this->_getAnnotations($cred->userId, $cred->db, $json->annotations);
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = true;
                $toSend->from = 'srv';
                $this->set('data', json_encode(array('name' => 'sync annots feedback', 'args' => $toSend)));
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
            var_export($exc);
        }
    }

    /**
     *  @function imgpage
     *  @param type $data
     *  @param type $cred
     *  @description Retourne l'imgpage trouvée par _getImgPage à l'appelant
     */
    private function imgpage($data, $cred) {
        try {
            if (!empty($cred) && !empty($cred->logged)) {
                $json = json_decode($data);
                $toSend = new stdClass();
                $toSend->data = $this->_getImgpage($cred->db, $json->imgpageId);
                $toSend->user_id = $cred->userId;
                $toSend->socketId = $cred->socketId;
                $toSend->success = true;
                $toSend->from = 'srv';
                $toSend->type = 'imgpage feedback';
                $this->set('data', json_encode(array('name' => 'imgpage feedback', 'args' => $toSend)));
            }
        } catch (Exception $exc) {
            DevTools::ldebug($exc->getTraceAsString());
        }
    }

    /**
     *  @function _getImgpage
     *  @param type $conn
     *  @param type $imgpageId
     *  @description Récupère l'imgpage dans la base de données associée à "$imgpageId"
     *  @return \stdClass
     */
    private function _getImgpage($conn, $imgpageId) {
        $return = new stdClass();
        $Imgpage = ClassRegistry::init('Imgpage');

        try {
            $qd = array(
                'fields' => array(
                    'Imgpage.id',
                    'Imgpage.name',
                    'Imgpage.content',
                    'Imgpage.type'
                ),
                'recursive' => -1,
                'conditions' => array(
                    'Imgpage.id' => $imgpageId
                )
            );
            $imgpage = $Imgpage->find('first', $qd);

            if (!empty($imgpage)) {
                $return = new stdClass();
                $return->id = $imgpageId;
                $return->name = substr($imgpage['Imgpage']['name'], 0, strrpos($imgpage['Imgpage']['name'], '.'));
                $return->ext = substr($imgpage['Imgpage']['name'], strrpos($imgpage['Imgpage']['name'], '.') + 1);
                $return->content = base64_encode($imgpage['Imgpage']['content']);
                $return->mimetype = $imgpage['Imgpage']['type'];
            }
        } catch (ErrorException $err) {
            if (Configure::read('debug') > 0) {
                DevTools::ldebug($err);
            }
        }
        return $return;
    }

}
