<?php

App::uses('AppController', 'Controller');

/**
 * Collectivites Controller
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-12-17 18:59:13 +0100 (mer. 17 déc. 2014) $
 * $Revision: 561 $
 * $Author: rdubourget $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Controller/CollectivitesController.php $
 * $Id: CollectivitesController.php 561 2014-12-17 17:59:13Z rdubourget $
 *
 * @property Collectivite $Collectivite
 */
class CollectivitesController extends AppController {
    
    // a changer, gérer cela avec les acl
/*    public function beforeFilter() {
        parent::beforeFilter();
        if($this->Session->read('Auth.env') !== 'superadmin'){
            throw new NotFoundException('acces interdit');
        }
    }
*/
    /**
     * Components
     *
     * @var array
     */
    public $components = array('Dataview');

    /**
     * index method
     *
     * @return void
     */
    public function index($cancel = false) {


 if($this->Session->read('Auth.env') !== 'superadmin'){
            throw new NotFoundException('acces interdit');
        }


        if ($cancel) {
            $this->Dataview->cancelSearch();
        }

        $this->Dataview->keepShowStyle();

        $dataviewInfos = $this->Dataview->processFilters();
        $this->set('critere', $dataviewInfos['critere']);

        $this->Collectivite->recursive = -1;
        $this->paginate = array_merge($this->paginate, array('conditions' => $dataviewInfos['conditions']));

        $this->set('controller', Inflector::camelize($this->name));
        $this->set('action', Inflector::camelize($this->action));
        $this->set('title', __d('collectivite', 'Collectivite.list'));
        $this->set('addurl', Router::url(array('action' => 'add')));
        $this->set('addtitle', __d('collectivite', 'Collectivite.add'));
        $this->set('deleteUrl', Router::url(array('controller' => 'Collectivites', 'action' => 'delete')));
        $this->set('model', $this->modelClass);
        $fields = array(
            'id' => array('label' => __d('collectivite', 'Collectivite.id')),
            'name' => array('label' => __d('collectivite', 'Collectivite.name')),
            'conn' => array('label' => __d('collectivite', 'Collectivite.conn')),
            'login_suffix' => array('label' => __d('collectivite', 'Collectivite.login_suffix')),
            'active' => array('boolean' => true, 'label' => __d('collectivite', 'Collectivite.active')),
            'created' => array('datetime' => true, 'label' => __d('collectivite', 'Collectivite.created')),
            'modified' => array('datetime' => true, 'label' => __d('collectivite', 'Collectivite.modified'))
        );
        $this->set('fields', $this->Dataview->processFields($fields));
        $this->set('data', $this->paginate());
    }

    /**
     * add method
     *
     * @return void
     */
    public function add() {


 if($this->Session->read('Auth.env') !== 'superadmin'){
            throw new NotFoundException('acces interdit');
        }



        if ($this->request->is('post')) {
            
            
            
            $valid = array(
                'success' => false,
                'msg' => __d('collectivite', 'Collectivite.add.error'),
                'class' => 'alert-danger'
            );
            $this->Collectivite->create();


            $conns = ConnectionManager::enumConnectionObjects();
            try {
                $this->Collectivite->query('create database ' . $conns[$this->request->data['Collectivite']['conn']]['database'] . ' template ' . $conns['template']['database'] . ';');
                $this->Collectivite->begin();


                //on force la collectivité à être active par défaut
                $this->request->data['Collectivite']['active'] = true;

                if ($this->Collectivite->save($this->request->data)) {
                    //init model
                    $this->loadmodel('User');
                    $this->User->setDataSource($this->request->data['Collectivite']['conn']);
                    $this->loadmodel('Aro');
                    $this->Aro->setDataSource($this->request->data['Collectivite']['conn']);

                    //hash password
                    $this->request->data['User']['password'] = AuthComponent::password($this->request->data['User']['password']);
                    //recup id admin
                    $this->request->data['User']['id'] = $this->User->field('id', array('username' => 'Administrateur'));

                    if ($this->User->save($this->request->data)) {
                        $valid['success'] = true;
                        $valid['msg'] = __d('collectivite', 'Collectivite.add.ok');
                        $valid['class'] = 'alert-success';
                    } else {
                        $valid['msg'] .= '<br /><br />' . __d('collectivite', 'Collectivite.add.error.admin_edit');
                    }
                }
            } catch (Exception $exc) {
                $valid['msg'] .= '<br /><br />' . __d('collectivite', 'Collectivite.add.error.db') . '<hr />' . (Configure::read('debug') > 0 ? $exc->getTraceAsString() : '');
            }

            $this->Session->setFlash($valid['msg'], 'bootstrap_flash', array('class' => 'alert ' . $valid['class']));
            if ($valid['success']) {
                $this->Collectivite->commit();
                $this->redirect(array('action' => 'index'));
            } else {
                $this->Collectivite->rollback();
                //TODO: demander la confirmation pour la suppression de la base
//				$this->Collectivite->query('drop database ' . $conns[$this->request->data['Collectivite']['conn']]['database'] . ';');
            }
        }
        $srvusers = $this->Collectivite->Srvuser->find('list');
        $this->set(compact('srvusers'));

        //récupération des connections définies dans database.php
        $conns = ConnectionManager::enumConnectionObjects();


        $tmpConns = array();

        //suppression de la connexion admin (default)
//		unset($conns['default']);

        /**
         *
         */
        foreach ($conns as $key => $conn) {
            if (!empty($conn['inMenu'])) {
                $tmpConns[$key] = $conn;
            }
        }
        $conns = $tmpConns;
        /**
         *
         */
        //suppression des connexion dèjà paramétrées pour une collectivite
        $listCollectiviteConn = $this->Collectivite->find('list', array('fields' => array('Collectivite.id', 'Collectivite.conn')));
        foreach ($listCollectiviteConn as $key => $val) {
            unset($conns[$val]);
        }

        //transformation pour le select
        $connsToSend = array();
        foreach (array_keys($conns) as $conn) {
            $connsToSend[$conn] = $conn;
        }
        $this->set('conns', $connsToSend);
    }

    /**
     * edit method
     *
     * @throws NotFoundException
     * @param string $id
     * @return void
     */
    public function edit($id = null) {

 if($this->Session->read('Auth.env') !== 'superadmin'){
            throw new NotFoundException('acces interdit');
        }



        if (!$this->Collectivite->exists($id)) {
            throw new NotFoundException(__d('collectivite', 'Collectivite.notfound'));
        }

        if ($this->request->is('post') || $this->request->is('put')) {
            if ($this->Collectivite->save($this->request->data)) {
                $this->Session->setFlash(__d('collectivite', 'Collectivite.edit.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
                $this->redirect(array('action' => 'index'));
            } else {
                $this->Session->setFlash(__d('collectivite', 'Collectivite.edit.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
            }
        }
        $qd = array('conditions' => array('Collectivite.' . $this->Collectivite->primaryKey => $id));
        $this->request->data = $this->Collectivite->find('first', $qd);
    }

    /**
     * delete method
     *
     * @throws NotFoundException
     * @throws MethodNotAllowedException
     * @param string $id
     * @return void
     */
    public function delete($id = null) {


 if($this->Session->read('Auth.env') !== 'superadmin'){
            throw new NotFoundException('acces interdit');
        }


        $this->Collectivite->id = $id;
        if (!$this->Collectivite->exists()) {
            throw new NotFoundException(__d('collectivite', 'Collectivite.notfound'));
        }

        if ($this->Collectivite->delete()) {
            $this->Session->setFlash(__d('collectivite', 'Collectivite.delete.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
            $this->redirect(array('action' => 'index'));
        }

        $this->Session->setFlash(__d('collectivite', 'Collectivite.delete.error'), 'bootstrap_flash', array('class' => 'alert alert-warning'));
        $this->redirect(array('action' => 'index'));
    }

    /**
     *
     */
    public function info() {
        if (!empty($this->request->data)) {
            $collectivite = $this->Collectivite->create($this->request->data);
            $success = $this->Collectivite->save($collectivite);
            $this->Session->setFlash(__d('collectivite', 'Collectivite.edit.' . ($success ? 'ok' : 'error')), 'bootstrap_flash', array('class' => 'alert alert-' . ($success ? 'success' : 'danger')));
        }
        $qd = array(
            'fields' => array(
                'Collectivite.id',
                'Collectivite.name',
                'Collectivite.conn',
                'Collectivite.login_suffix',
                'Collectivite.created',
                'Collectivite.active'
            ),
            'conditions' => array(
                'Collectivite.id' => $this->Session->read('Auth.collectivite.id')
            )
        );

        $this->request->data = $this->Collectivite->find('first', $qd);
    }

}
