<?php

App::uses('Security', 'Component');

/**
 *
 * DbFile component class.
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-07-10 14:02:20 +0200 (jeu. 10 juil. 2014) $
 * $Revision: 505 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Controller/Component/DbFileComponent.php $
 * $Id: DbFileComponent.php 505 2014-07-10 12:02:20Z genot $
 *
 */
class DbFileComponent extends Component {

    /**
     * Components
     *
     * @var array
     */
    public $components = array('Security');

    /**
     * Controller
     *
     * @access public
     * @var Controller
     */
    public $controller;

    /**
     * * Component initialization
     *
     * @access public
     * @param Controller $controller
     * @return void
     */
    public function initialize(Controller $controller) {
        $this->controller = $controller;
    }

    /**
     * Récupération de l'image stockée en base
     *
     * @param type $id
     * @throws NotFoundException
     */
    public function getFile($id = null, $base64 = false) {
        $blackHole = true;

        if (!empty($id)) {
            try {
                $qd = array(
                    'recursive' => -1,
                    'conditions' => array(
                        $this->controller->modelClass . '.id' => $id
                    )
                );
                $file = $this->controller->{$this->controller->modelClass}->find('first', $qd);
                if (!empty($file)) {
                    $fileInfos = $file[$this->controller->modelClass];

                    //preparation du fichier temporaire
                    $name = substr($fileInfos['name'], 0, strrpos($fileInfos['name'], '.'));
                    $ext = substr($fileInfos['name'], strrpos($fileInfos['name'], '.') + 1);
                    $tmpPath = '/tmp';
                    $tmpFileName = time() . '_' . $fileInfos['name'];
                    file_put_contents($tmpPath . DS . $tmpFileName, $base64 ? base64_encode($fileInfos['content']) : $fileInfos['content']);

                    //utilisation de la vue media
                    $this->controller->set('cache', '3 months');
//                    $this->controller->set('download', false);
                    $this->controller->set('download', true);
                    $this->controller->set('id', $tmpFileName);
                    $this->controller->set('name', $name);
                    $this->controller->set('path', $tmpPath . DS);
                    $this->controller->set('modified', $fileInfos['modified']);
                    $this->controller->set('mimeType', $fileInfos['type']);
//                    $this->controller->set('mimeType', 'octet/stream');
                    $this->controller->set('extension', $ext);

                    $this->controller->viewClass = 'Media';
                    $this->controller->autoLayout = false;

                    unlink($tmpFileName);

                    if ($this->controller->render() !== false) {
                        $blackHole = false;
                    }
                }
            } catch (ErrorException $err) {
                //log debug
                if (Configure::read('debug') > 0) {
                    $this->controller->ldebug($err);
                }
            }
        }

        //suppression du fichier temporaire
        if (file_exists($tmpPath . DS . $tmpFileName)) {
            unlink($tmpPath . DS . $tmpFileName);
        }

        //si erreur on n'envoie rien
        if ($blackHole) {
            $this->Security->blackHole($this->controller);
        }
    }

}

?>
