<?php

App::uses('AppController', 'Controller');

/**
 * Groups Controller
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-08-07 10:57:05 +0200 (jeu. 07 août 2014) $
 * $Revision: 551 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Controller/GroupsController.php $
 * $Id: GroupsController.php 551 2014-08-07 08:57:05Z ssampaio $
 *
 * @property Group $Group
 */
class GroupsController extends AppController {

	/**
	 * Components
	 *
	 * @var array
	 */
	public $components = array('Dataview');

	/**
	 * index method
	 *
	 * @return void
	 */
	public function index($cancel = false) {

		if ($cancel) {
			$this->Dataview->cancelSearch();
		}

		$this->Dataview->keepShowStyle();

		$dataviewInfos = $this->Dataview->processFilters();
		$this->set('critere', $dataviewInfos['critere']);

		$this->Group->recursive = -1;
		$this->paginate = array_merge($this->paginate, array('conditions' => $dataviewInfos['conditions']));

		$this->set('controller', Inflector::camelize($this->name));
		$this->set('action', Inflector::camelize($this->action));
		$this->set('title', __d('group', 'Group.list'));
		$this->set('addurl', Router::url(array('action' => 'add')));
		$this->set('deleteUrl', Router::url(array('controller' => 'Groups', 'action' => 'delete')));
		$this->set('addtitle', __d('group', 'Group.add'));
		$this->set('model', $this->modelClass);
		$fields = array(
			'id' => array('label' => __d('group', 'Group.id')),
			'name' => array('label' => __d('group', 'Group.name')),
			'admin' => array('boolean' => true, 'label' => __d('group', 'Group.admin')),
			'superuser' => array('boolean' => true, 'label' => __d('group', 'Group.superuser')),
			'baseuser' => array('boolean' => true, 'label' => __d('group', 'Group.baseuser')),
			'inseance' => array('boolean' => true, 'label' => __d('group', 'Group.inseance')),
			'created' => array('datetime' => true, 'label' => __d('group', 'Group.created')),
			'modified' => array('datetime' => true, 'label' => __d('group', 'Group.modified'))
		);
		$this->set('fields', $this->Dataview->processFields($fields));
		$this->set('data', $this->paginate());

        $this->set('forbiddenActions', array('add' => true, 'edit' => true, 'delete' => true));

	}


    /**
     * add method
     *
     * @return void
     */
    public function add() {
        $this->redirect(array('controller' => 'Groups', 'action' => 'index'));
//		if ($this->request->is('post')) {
//			$this->Group->create();
//			if ($this->Group->save($this->request->data)) {
//				$this->Session->setFlash(__d('group', 'Group.add.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//				$this->redirect(array('action' => 'index'));
//			} else {
//				$this->Session->setFlash(__d('group', 'Group.add.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//			}
//		}
    }

    /**
     * edit method
     *
     * @throws NotFoundException
     * @param string $id
     * @return void
     */
    public function edit($id = null) {
        $this->redirect(array('controller' => 'Groups', 'action' => 'index'));
//        if (!$this->Group->exists($id)) {
//            throw new NotFoundException(__('Invalid group'));
//        }
//        if ($this->request->is('post') || $this->request->is('put')) {
//            if ($this->Group->save($this->request->data)) {
//                $this->Session->setFlash(__d('group', 'Group.edit.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//                $this->redirect(array('action' => 'index'));
//            } else {
//                $this->Session->setFlash(__d('group', 'Group.edit.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//            }
//        } else {
//            $options = array('conditions' => array('Group.' . $this->Group->primaryKey => $id));
//            $this->request->data = $this->Group->find('first', $options);
//        }
    }

    /**
     * delete method
     *
     * @throws NotFoundException
     * @param string $id
     * @return void
     */
    public function delete($id = null) {
        $this->redirect(array('controller' => 'Groups', 'action' => 'index'));
//        $this->Group->id = $id;
//        if (!$this->Group->exists()) {
//            throw new NotFoundException(__('Invalid group'));
//        }
//        if ($this->Group->delete()) {
//            $this->Session->setFlash(__d('group', 'Group.delete.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//            $this->redirect(array('action' => 'index'));
//        }
//        $this->Session->setFlash(__d('group', 'Group.delete.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//        $this->redirect(array('action' => 'index'));
    }

}
