<?php

App::uses('AppController', 'Controller');
App::uses('Appchecks', 'Utility');

/**
 * Monitor Controller
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Jean Genot
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-03-18 16:30:20 +0100 (mar. 18 mars 2014) $
 * $Revision: 363 $
 * $Author: jgenot $
 * $HeadURL: svn+ssh://ssampaio@scm.adullact.net/scmrepos/svn/idelibre/branches/1.0.x/app/Controller/ImgpagesController.php $
 * $Id: ImgpagesController.php 363 2014-03-18 15:30:20Z ssampaio $
 *
 * @property Imgpage $Imgpage
 */
class MonitorController extends AppController {

    /**
     * No model
     *
     * @var type
     */
    public $uses = null;

    /**
     * Gets monitor proof token
     *
     * @return type
     */
    private function _getCDebugUUID() {
        return file_get_contents(IDELIBRE_WS_CDEBUGUUID);
    }

    /**
     * Trigger start/stop events to websocket server
     *
     * @param String $instruction (start / stop)
     * @return array() ElephantIO feedback
     * @throws RuntimeException
     */
    private function _sendToSocketIO($instruction) {
        $proof = $this->_getCDebugUUID();

        App::import('Vendor', 'ElephantIOClient', array('file' => 'ElephantIO/Client.php'));

        if (!class_exists('ElephantIO\Client')) {
            throw new RuntimeException(__d('websocket', 'ElephantIO.load.error'));
        }

        //connexion au serveur websocket
        $elephantConfig = array(
            'url' => IDELIBRE_WS_PROTOCOL . '://' . IDELIBRE_WS_HOST . ':' . IDELIBRE_WS_PORT,
            'path' => 'socket.io',
            'protocol' => 1,
            'read' => false,
            'checkSSL' => false,
            'debug' => Configure::read('debug') > 0
        );

        $this->elephant = new ElephantIO\Client($elephantConfig['url'], $elephantConfig['path'], $elephantConfig['protocol'], $elephantConfig['read'], $elephantConfig['checkSSL'], $elephantConfig['debug']);
        $this->elephant->init();

        $toSend = new stdClass();
        $toSend->name = 'auth client debug'; //FIXME: Donnée du traitement
        $toSend->data = $proof; //FIXME: Donnée du traitement
        $toSend->instructions = $instruction;

        $return = $this->elephant->send(ElephantIO\Client::TYPE_EVENT, null, null, json_encode(array('name' => 'auth client debug', 'args' => json_encode($toSend))));

        $this->elephant->close();
        return $return;
    }

    /**
     *
     * @return type
     */
    private function _checkWs() {
        $wschecks = Appchecks::checkWebsocket();
        $wschecks['global'] = !in_array(false, Set::flatten($wschecks), true);
        return $wschecks;
    }

    /**
     * Main page
     */
    public function index() {
        $this->set('wschecks', $this->_checkWs());
    }

    /**
     * Ajax action to start websocket monitoring
     */
    public function start() {
        DevTools::ldebug('test',true);
        //preparation de start
        $this->layout = null;
        $this->set('response', $this->_sendToSocketIO('start'));
    }

    /**
     * Ajax action to stop websocket monitoring
     */
    public function stop() {
        //preparation de stop
        $this->layout = null;
        $this->set('response', $this->_sendToSocketIO('stop'));
    }

    /**
     * Ajax action to read websocket logfile
     */
    public function display() {
        if ($this->request->is('Ajax')) {
            $sessionKey = 'Monitors.offset';
//            $handle = fopen(TMP . '/logs/ws-monitor.log', 'r'); // FIXME: une variable / un configure

            $handle = fopen(IDELIBRE_WS_MONITOR_LOG, 'r'); // FIXME: une variable / un configure
            $offset = $this->Session->read($sessionKey);
            $this->log($offset);
            if ($offset !== null) {
                $data = stream_get_contents($handle, -1, $offset);
                echo json_encode($data);
            }
            fseek($handle, 0, SEEK_END);
            $this->Session->write($sessionKey, ftell($handle));
            exit();
        }
    }


}
