<?php

App::uses('AppController', 'Controller');

/**
 * Srvroles Controller
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-08-11 15:26:57 +0200 (lun. 11 août 2014) $
 * $Revision: 553 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Controller/SrvrolesController.php $
 * $Id: SrvrolesController.php 553 2014-08-11 13:26:57Z ssampaio $
 *
 * @property Srvrole $Srvrole
 */
class SrvrolesController extends AppController {

    /**
     * Controller components
     *
     * @access public
     * @var array
     */
    public $components = array('Dataview');

    /**
     * index method
     *
     * @return void
     */
    public function index($cancel = false) {
        if ($cancel) {
            $this->Dataview->cancelSearch();
        }

        $this->Dataview->keepShowStyle();

        $dataviewInfos = $this->Dataview->processFilters();
        $this->set('critere', $dataviewInfos['critere']);

        $this->Srvrole->recursive = -1;
        $this->paginate = array_merge($this->paginate, array('conditions' => $dataviewInfos['conditions']));

        $this->set('controller', Inflector::camelize($this->name));
        $this->set('action', Inflector::camelize($this->action));
        $this->set('title', __d('srvrole', 'Srvrole.list'));
        $this->set('addurl', Router::url(array('action' => 'add')));
        $this->set('deleteUrl', Router::url(array('controller' => 'Srvroles', 'action' => 'delete')));
        $this->set('addtitle', __d('srvrole', 'Srvrole.add'));
        $this->set('model', $this->modelClass);
        $fields = array(
            'id' => array(
                'label' => __d('srvrole', 'Srvrole.id'),
                'class' => 'uuid',
            ),
            'name' => array(
                'label' => __d('srvrole', 'Srvrole.name')
            ),
            'created' => array(
                'datetime' => true,
                'label' => __d('srvrole', 'Srvrole.created'),
                'class' => 'datetime'
            ),
            'modified' => array(
                'datetime' => true,
                'label' => __d('srvrole', 'Srvrole.modified'),
                'class' => 'datetime'
            )
        );
        $this->set('fields', $this->Dataview->processFields($fields));
        $this->set('data', $this->paginate());

        $this->set('forbiddenActions', array('add' => true, 'edit' => true, 'delete' => true));
    }

    /**
     * add method
     *
     * @return void
     */
    public function add() {
        $this->redirect(array('action' => 'index'));
//		if ($this->request->is('post')) {
//			$this->Srvrole->create();
//			if ($this->Srvrole->save($this->request->data)) {
//				$this->Session->setFlash(__d('srvrole', 'Srvrole.add.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//				$this->redirect(array('action' => 'index'));
//			} else {
//				$this->Session->setFlash(__d('srvrole', 'Srvrole.add.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//			}
//		}
    }

    /**
     * edit method
     *
     * @throws NotFoundException
     * @param string $id
     * @return void
     */
    public function edit($id = null) {
        $this->redirect(array('action' => 'index'));
//		if (!$this->Srvrole->exists($id)) {
//			throw new NotFoundException(__('Invalid srvrole'));
//		}
//		if ($this->request->is('post') || $this->request->is('put')) {
//			if ($this->Srvrole->save($this->request->data)) {
//				$this->Session->setFlash(__d('srvrole', 'Srvrole.edit.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//				$this->redirect(array('action' => 'index'));
//			} else {
//				$this->Session->setFlash(__d('srvrole', 'Srvrole.edit.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//			}
//		} else {
//			$options = array('conditions' => array('Srvrole.' . $this->Srvrole->primaryKey => $id));
//			$this->request->data = $this->Srvrole->find('first', $options);
//		}
    }

    /**
     * delete method
     *
     * @throws NotFoundException
     * @throws MethodNotAllowedException
     * @param string $id
     * @return void
     */
    public function delete($id = null) {
        $this->redirect(array('action' => 'index'));
//		$this->Srvrole->id = $id;
//		if (!$this->Srvrole->exists()) {
//			throw new NotFoundException(__('Invalid srvrole'));
//		}
//
//		if ($this->Srvrole->delete()) {
//			$this->Session->setFlash(__d('srvrole', 'Srvrole.delete.ok'), 'bootstrap_flash', array('class' => 'alert alert-success'));
//			$this->redirect(array('action' => 'index'));
//		}
//		$this->Session->setFlash(__d('srvrole', 'Srvrole.delete.error'), 'bootstrap_flash', array('class' => 'alert alert-danger'));
//		$this->redirect(array('action' => 'index'));
    }

}
