<?php

/**
 * Application model for Cake.
 *
 * This file is application-wide model file. You can put all
 * application-wide model-related methods here.
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-06-27 10:29:36 +0200 (ven. 27 juin 2014) $
 * $Revision: 477 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/AppModel.php $
 * $Id: AppModel.php 477 2014-06-27 08:29:36Z ssampaio $
 */
App::uses('Model', 'Model');
App::uses('DevTools', 'Utility');

/**
 * Application model for Cake.
 *
 * Add your application-wide methods in the class below, your models
 * will inherit them.
 *
 * @package       app.Model
 */
class AppModel extends Model {

    /**
     *
     * @var type
     */
    public $actsAs = array('Containable', 'DatabaseTable');

    /**
     *
     * @var type
     */
    public $recursive = -1;

    /**
     *
     * @var type
     */
    public $adminModels = array('Srvuser', 'Srvrole', 'Collectivite', 'CollectiviteSrvuser', 'SrvusersMandat', 'Mandat');

    /**
     * Override of the Model's __construct method.
     *
     *
     * @param mixed $id Set this ID for this model on startup, can also be an array of options, see above.
     * @param string $table Name of database table to use.
     * @param string $ds DataSource connection name.
     * @link http://bakery.cakephp.org/articles/doze/2010/03/12/use-multiple-databases-in-one-app-based-on-requested-url
     */
    public function __construct($id = false, $table = null, $ds = null) {
        parent::__construct($id, $table, $ds);
        $conn = Configure::read('conn');
        if (!empty($conn) && !in_array($this->name, $this->adminModels)) {
            $this->setDataSource($conn);
        }
    }

    /**
     *
     * @param type $var
     */
    public function ldebug($var) {
        $this->log(var_export($var, true), 'debug');
    }

    /**
     * Débute une transaction.
     *
     * @return boolean
     */
    public function begin() {
        return $this->getDataSource()->begin();
    }

    /**
     * Valide une transaction.
     *
     * @return boolean
     */
    public function commit() {
        return $this->getDataSource()->commit();
    }

    /**
     * Annule une transaction.
     *
     * @return boolean
     */
    public function rollback() {
        return $this->getDataSource()->rollback();
    }

    /**
     *
     * @return type
     */
    public function getQueries() {
        $db = ConnectionManager::getDataSource(Configure::read('conn'));

        if (method_exists($db, 'getLog')) {
            return array();
        }

        $log = $db->getLog();
        return $log;
    }

}
