<?php

/**
 * Password behavior class.
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2013-10-21 17:57:34 +0200 (lun. 21 oct. 2013) $
 * $Revision: 302 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Behavior/PasswordBehavior.php $
 * $Id: PasswordBehavior.php 302 2013-10-21 15:57:34Z ssampaio $
 *
 *
 * @package			app
 * @subpackage		app.Model.Behavior
 *
 */
class PasswordBehavior extends ModelBehavior {

	/**
	 * Vérification que la valeur du champ soit égale à la valeur de référence.
	 *
	 * @param mixed $check Les valeurs à vérifier.
	 * @param string $referenceField Le nom du champ de référence.
	 * @return boolean
	 */
	public function checkIdenticalValues(Model $model, $check, $referenceField) {
		if (!is_array($check) || empty($model->data[$model->alias][$referenceField])) {
			return false;
		}
		$result = true;
		foreach (Set::normalize($check) as $value) {
			$result = ( $value == AuthComponent::password($model->data[$model->alias][$referenceField]));
		}
		return $result;
	}

}

?>
