<?php

/**
 * Convocation Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-12-17 18:59:13 +0100 (mer. 17 déc. 2014) $
 * $Revision: 561 $
 * $Author: rdubourget $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Convocation.php $
 * $Id: Convocation.php 561 2014-12-17 17:59:13Z rdubourget $
 *
 * @property Seance $Seance
 * @property User $User
 */
App::uses('AppModel', 'Model');
App::uses('CakeEmail', 'Network/Email');
App::uses('Horodatage', 'Utility');
App::uses('Security', 'Utility');

class Convocation extends AppModel {

    /**
     *
     * @var type
     */
    public $Horodatage;

    /**
     *
     * @var File
     */
    public $TSFile;

    /**
     *
     * @var File
     */
    public $TSToken;

    /**
     *
     * @var array
     */
    public $return = array(
        'horodatage' => array(
            'success' => false,
            'message' => ''
        ),
        'save' => array(
            'success' => false,
            'message' => ''
        ),
        'mail' => array(
            'success' => false,
            'message' => ''
        ),
        'TSFile' => array(
            'exists' => false,
            'delete' => false
        ),
        'TSToken' => array(
            'exists' => false,
            'delete' => false
        )
    );

    /**
     *
     * @var array
     */
    public $convocToSend = array();

    /**
     * Validation rules
     *
     * @var array
     */
    public $validate = array(
        'seance_id' => array(
            'uuid' => array(
                'rule' => array('uuid'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'user_id' => array(
            'uuid' => array(
                'rule' => array('uuid'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'read' => array(
            'boolean' => array(
                'rule' => array('boolean'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'presence' => array(
            'boolean' => array(
                'rule' => array('boolean'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'delegation' => array(
            'boolean' => array(
                'rule' => array('boolean'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
        'procuration' => array(
            'boolean' => array(
                'rule' => array('boolean'),
            //'message' => 'Your custom message here',
            //'allowEmpty' => false,
            //'required' => false,
            //'last' => false, // Stop validation after this rule
            //'on' => 'create', // Limit validation to 'create' or 'update' operations
            ),
        ),
    );

    //The Associations below have been created with all possible keys, those that are not needed can be removed

    /**
     * belongsTo associations
     *
     * @var array
     */
    public $belongsTo = array(
        'Seance' => array(
            'className' => 'Seance',
            'foreignKey' => 'seance_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        ),
        'User' => array(
            'className' => 'User',
            'foreignKey' => 'user_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        ),
    );

    /**
     * Envoyer une convocation à un utilisateur avec horodatage et notification par mail
     *
     * @param string $convocation_id UUID
     * @return array
     * @throws NotFoundException
     */
    public function send($convocation_id) {
        if (empty($convocation_id) || !$this->exists($convocation_id)) {
            throw new NotFoundException(__d('convocation', 'Convocation.notFound'));
        }
        
        //récupération de la convocation
        $this->convocToSend = $this->find('first', array('conditions' => array('Convocation.id' => $convocation_id)));
        //préparation des fichiers nécessaires à l'horodatage
        $this->TSFile = new File(TMP . DS . 'idelibre_horodatage_' . Security::hash($this->convocToSend['Convocation']['id']));


        //préparation des nouvelles informations de la convocation
        $this->convocToSend['Convocation']['active'] = true;
        $this->convocToSend['Convocation']['ae_received'] = date('Y-m-d H:i:s');

        //Ecriture du fichier d'horodatage
        $tsFileContent = "i-delibRE - Timestamp\n" .
                "controller : " . $this->name . "\n" .
                "action : " . $this->action . "\n" .
                "organisation : " . CakeSession::read('Auth.collectivite.name') . " : " . CakeSession::read('Auth.collectivite.id') . "\n" .
                "user : " . CakeSession::read('Auth.User.name') . " : " . CakeSession::read('Auth.User.id') . "\n" .
                "seance : " . $this->convocToSend['Convocation']['seance_id'] . "\n" .
                "convocation : " . $this->convocToSend['Convocation']['id'] . "\n" .
                "server timestamp : " . $this->convocToSend['Convocation']['ae_received'];
        $this->TSFile->write($tsFileContent);

        //Horodatage
        try {
            $this->TSToken = new File($this->TSFile->path . '.rep.tsa');
            if ($this->horodatage()) { //si l horodatage est configuré et fonctionnel
                if ($this->TSToken->exists()) {
                    $this->return['horodatage']['success'] = true;
                    $this->return['horodatage']['message'] = __d('convocation', 'Convocation.horodatage.success');
                } else {
                    $this->return['horodatage']['message'] = __d('convocation', 'Convocation.horodatage.error.file.token.notFound');
                }
            } else { //sinon on utilise la date systeme
                $this->convocToSend['Convocation']['ae_received'] = null;
                $this->convocToSend['Convocation']['ae_sent'] = date('Y-m-d H:i:s');
                $this->return['horodatage']['success'] = true;
            }
        } catch (Exception $exc) {
            $this->return['horodatage']['message'] = __d('convocation', 'Convocation.horodatage.error');
            if (Configure::read('debug') > 0) {
                $this->return['horodatage']['exception'] = $exc->getTraceAsString();
            }
        }

        //Sauvegarde des informations
        if ($this->return['horodatage']['success']) {
            $this->return['save']['success'] = $this->save($this->convocToSend);
            $this->return['save']['message'] = __d('convocation', 'Convocation.save.success');
        } else {
            $this->return['save']['message'] = __d('convocation', 'Convocation.save.error');
        }

        //Envoi du mail
//$this->log('send email', LOG_ERROR);        
if ($this->return['save']['success']) {
//$this->log('send email true', LOG_ERROR);
            try {
                $this->return['mail']['success'] = $this->sendMail();
//$this->log(var_export($return ,true), LOG_ERROR);

                $this->return['mail']['message'] = __d('convocation', 'Convocation.mail.success');
            } catch (Exception $exc) {
                $this->return['mail']['message'] = __d('convocation', 'Convocation.mail.error');
                if (Configure::read('debug') > 0) {
                    $this->return['mail']['exception'] = $exc->getTraceAsString();
                }
            }
        } else {
            $this->return['mail']['message'] = __d('convocation', 'Convocation.mail.error');
        }

        //envoi de l info de sync au client
        try {
            $this->WSTellSync();
        } catch (Exception $exc) {
            if (Configure::read('debug') > 0) {
                DevTools::ldebug($exc->getTraceAsString());
            }
        }

        //Suppression des fichiers temporaires
        if ($this->TSFile->exists()) {
            $this->return['TSFile']['exists'] = true;
            $this->return['TSFile']['delete'] = $this->TSFile->delete();
        }

        if ($this->TSToken->exists()) {
            $this->return['TSToken']['exists'] = true;
            $this->return['TSToken']['delete'] = $this->TSToken->delete();
        }

        //Retour
        return $this->return;
    }

    /**
     * Horodatage du fichier
     *
     * @return boolean
     */
    public function horodatage() {
        $return = false;
        $this->Horodatage = new Horodatage();

        try {
            if (Horodatage::check()) {
                $resp = Horodatage::horodateFichier($this->TSFile->path);
                if ($resp['responseToText']) {
                    for ($i = 0; $i < count($resp['responseToText']); $i++) {
                        $matches = array();
                        if (preg_match("#Time stamp: (.*)#", $resp['responseToText'][$i], $matches)) {
                            if (count($matches) > 1) {
                                $date = DateTime::createFromFormat('M j H:i:s Y O', $matches[1]);
                                $this->convocToSend['Convocation']['ae_horodatage'] = date('Y-m-d H:i:s', CakeTime::convert($date->getTimestamp(), null/* Europe/Paris */));
                            }
                        }
                    }
                    $this->convocToSend['Convocation']['ae_horodatage_file'] = $this->TSFile->read();
//                    $this->TSToken = new File($this->TSFile->path . '.rep.tsa');
                    $this->convocToSend['Convocation']['ae_horodatage_token'] = $this->TSToken->read();
                    $return = true;
                } else {
                    $this->convocToSend['Convocation']['ae_received'] = null;
                    $this->convocToSend['Convocation']['ae_horodatage'] = date('Y-m-d H:i:s');
                }
            } else {
                $this->convocToSend['Convocation']['ae_received'] = null;
                $this->convocToSend['Convocation']['ae_horodatage'] = date('Y-m-d H:i:s');
            }
        } catch (Exception $exc) {
            DevTools::ldebug(__d('convocation', 'setRead.error:' + ' ' + var_export($exc, true)));
        }
    }

    /**
     *
     * @return type
     */
    public function sendMail() {
        $this->User->id = $this->convocToSend['Convocation']['user_id'];
 //      $this->log(var_export($this->User->field('mail'), true), LOG_ERROR);

	$mailto = $this->User->field('mail');
//	$mailto = 'remi.dubourget@adullact-projet.coop';
        // Paramètres mail
        $Email = new CakeEmail('convocation');


        if (!empty($mailto)) {
            if (CakeSession::check('Auth.User.mail')) {
        	$Email->from('noreply@adullact.org');	    
	 //   $Email->from(CakeSession::read('Auth.User.mail'));
	
	//$this->log('usersecretaire', LOG_ERROR);
            }
	//    $Email->from('noreply@adullact.org');
	
            $Email->to(Configure::read('debug') > 0 ? $Email->from() : $mailto);
            $Email->subject(__d('convocation', 'Convocation.send.title'));
        }
//	$this->log(var_export($Email, true), LOG_ERROR);

        //envoi
        $result = null;
        try {
// $this->log(var_export('dans le try', true), LOG_ERROR);

            $result = $Email->send(__d('convocation', 'Convocation.send.message'));
// $this->log(var_export($result, true), LOG_ERROR);

        } catch (Exception $e) {
            $this->log($e->getMessage(), LOG_ERROR);
        }

        //traitement du retour
        return !empty($result);
    }

    /**
     *
     */
    public function WSTellSync() {
//        App::uses('ShellDispatcher', 'Console');
//        $command = '-app ' . APP . ' ElephantIO push "seance push" "need to sync seances" ' . $this->convocToSend['Convocation']['user_id'];
//        $args = explode(' ', $command);
//        $dispatcher = new ShellDispatcher($args, false);
//        if ($dispatcher->dispatch()) {
//            DevTools::ldebug('seance push ok : ' . $command);
//        } else {
//            DevTools::ldebug('seance push error : ' . $command);
//        }

        App::import('Vendor', 'ElephantIOClient', array('file' => 'ElephantIO/Client.php'));

        if (!class_exists('ElephantIO\Client')) {
            throw new RuntimeException(__d('websocket', 'ElephantIO.load.error'));
        }

//        if (!is_file(IDELIBRE_WS_CDUUID)) {
//            throw new RuntimeException(__d('websocket', 'CDUUID.notFound'));
//        }
//
//        if (!is_readable(IDELIBRE_WS_CDUUID)) {
//            throw new RuntimeException(__d('websocket', 'CDUUID.notReadable'));
//        }
//connexion au serveur websocket
        $elephantConfig = array(
            'url' => IDELIBRE_WS_PROTOCOL . '://' . IDELIBRE_WS_HOST . ':' . IDELIBRE_WS_PORT,
            'path' => 'socket.io',
            'protocol' => 1,
            'read' => false,
            'checkSSL' => false,
            'debug' => Configure::read('debug') > 0
        );
        
        
        
        $this->elephant = new ElephantIO\Client($elephantConfig['url'], $elephantConfig['path'], $elephantConfig['protocol'], $elephantConfig['read'], $elephantConfig['checkSSL'], $elephantConfig['debug']);
        $this->elephant->init();

        $toSend = new stdClass();
        $toSend->name = 'seance push'; //FIXME: Donnée du traitement
        $toSend->data = 'need to sync seances'; //FIXME: Donnée du traitement
        $toSend->userId = $this->convocToSend['Convocation']['user_id'];
        $toSend->from = 'srv';

        $this->elephant->send(ElephantIO\Client::TYPE_EVENT, null, null, json_encode(array('name' => 'seance push', 'args' => json_encode($toSend))));
    }
    
    
    
    
    // TODO : doit etre envoyé sur wstellREsync  (on peut aussi virer la seance_id !)
     public function reSend($convocation_id /*, $seance_id*/) {
         DevTools::ldebug('reSend');
         $this->convocToSend = $this->find('first', array('conditions' => array('Convocation.id' => $convocation_id)));
        // $this->WSTellReSync($seance_id);
         $this->WSTellReSync();
     }
    
    
    /*
     * Envoie la demande de resynchro de la séance
     * @param $seance_id numero de la seance
     */
    public function WSTellReSync() {
       
        App::import('Vendor', 'ElephantIOClient', array('file' => 'ElephantIO/Client.php'));

        if (!class_exists('ElephantIO\Client')) {
            throw new RuntimeException(__d('websocket', 'ElephantIO.load.error'));
        }


        
//connexion au serveur websocket
        $elephantConfig = array(
            'url' => IDELIBRE_WS_PROTOCOL . '://' . IDELIBRE_WS_HOST . ':' . IDELIBRE_WS_PORT,
            'path' => 'socket.io',
            'protocol' => 1,
            'read' => false,
            'checkSSL' => false,
            'debug' => Configure::read('debug') > 0
        );
        
        
        DevTools::ldebug($elephantConfig);
        
  $this->elephant = new ElephantIO\Client($elephantConfig['url'], $elephantConfig['path'], $elephantConfig['protocol'], $elephantConfig['read'], $elephantConfig['checkSSL'], $elephantConfig['debug']);
        $this->elephant->init();

        $toSend = new stdClass();
        $toSend->name = 'seance repush'; //FIXME: Donnée du traitement
        $toSend->data = 'need to sync seances'; //FIXME: Donnée du traitement
        $toSend->userId = $this->convocToSend['Convocation']['user_id'];
        $toSend->from = 'srv';

        $this->elephant->send(ElephantIO\Client::TYPE_EVENT, null, null, json_encode(array('name' => 'seance repush', 'args' => json_encode($toSend))));
    }

    
    
}
