<?php

/**
 * Deltarevision Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2013-10-21 17:57:34 +0200 (lun. 21 oct. 2013) $
 * $Revision: 302 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Deltarevision.php $
 * $Id: Deltarevision.php 302 2013-10-21 15:57:34Z ssampaio $
 *
 */
App::uses('AppModel', 'Model');

class Deltarevision extends AppModel {

	/**
	 * Validation rules
	 *
	 * @var array
	 */
	public $validate = array(
		'data' => array(
			'allowEmpty' => false,
		),
		'num' => array(
			'allowEmpty' => false,
		)
	);

	/**
	 * hasMany associations
	 *
	 * @var array
	 */
	public $hasMany = array(
		'Annotaction' => array(
			'className' => 'Annotaction',
			'foreignKey' => 'deltarevision_id',
			'dependent' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'exclusive' => '',
			'finderQuery' => '',
			'counterQuery' => ''
		)
	);

	/**
	 * belongsTo associations
	 *
	 * @var array
	 */
	public $belongsTo = array(
		'User' => array(
			'className' => 'User',
			'foreignKey' => 'user_id',
			'conditions' => '',
			'fields' => '',
			'order' => ''
		)
	);

	/**
	 * Gets last sent delta
	 *
	 * @param string $userId User's UUID
	 * @param string $type Action done for annotation
	 * @return mixed Annotactions from last delat (deltarevision)
	 */
	public function getLastDelta($userId, $type = '') {
		$return = array();
		//recupération de la précédente révision
		$qd = array(
			'fields' => array(
				'Deltarevision.id',
				'Deltarevision.num',
				'Annotaction.type',
				'Annotaction.annotation_id'
			),
			'contain' => false,
			'joins' => array(
				$this->join($this->Annotaction->alias, array('type' => 'inner')),
			),
			'conditions' => array(
				'Deltarevision.user_id' => $userId
			),
			'order' => array(
				'Deltarevision.created DESC'
			),
			'limit' => 1
		);

		if ($type != '' && ( $type == 'C' || $type == 'U' || $type = 'D')) {
			$qd['conditions']['Annotaction.type'] = $type;
		}


		return $this->find('all', $qd);
	}

}
