<?php

/**
 * Group Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2013-10-21 17:57:34 +0200 (lun. 21 oct. 2013) $
 * $Revision: 302 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Group.php $
 * $Id: Group.php 302 2013-10-21 15:57:34Z ssampaio $
 *
 * @property User $User
 */
App::uses('AppModel', 'Model');

class Group extends AppModel {

	/**
	 *
	 * @var type
	 */
	public $actsAs = array('Acl' => array('type' => 'requester'));

	/**
	 *
	 * @var type
	 */
	public $validationDomain = 'group';

	/**
	 *
	 * @return null
	 */
	public function parentNode() {
		return null;
	}

	/**
	 * Validation rules
	 *
	 * @var array
	 */
	public $validate = array(
		'name' => array(
			'notempty' => array(
				'rule' => array('notempty'),
				'message' => 'Group.name.notempty'
			),
			'isUnique' => array(
				'rule' => array('isUnique'),
				'message' => 'Group.name.isUnique'
			),
		),
	);

	//The Associations below have been created with all possible keys, those that are not needed can be removed

	/**
	 * hasMany associations
	 *
	 * @var array
	 */
	public $hasMany = array(
		'User' => array(
			'className' => 'User',
			'foreignKey' => 'group_id',
			'dependent' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'exclusive' => '',
			'finderQuery' => '',
			'counterQuery' => ''
		)
	);

}
