<?php

/**
 * Srvrole Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2013-10-21 17:57:34 +0200 (lun. 21 oct. 2013) $
 * $Revision: 302 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Srvrole.php $
 * $Id: Srvrole.php 302 2013-10-21 15:57:34Z ssampaio $
 *
 * @property Srvuser $Srvuser
 */
App::uses('AppModel', 'Model');

class Srvrole extends AppModel {

	/**
	 *
	 * @var type
	 */
	public $useDbConfig = 'default';

	/**
	 *
	 * @var type
	 */
	public $displayField = 'name';

	/**
	 *
	 * @var type
	 */
	public $validationDomain = 'srvrole';

	/**
	 * Validation rules
	 *
	 * @var array
	 */
	public $validate = array(
		'name' => array(
			'notempty' => array(
				'rule' => array('notempty'),
				'message' => 'Srvrole.name.notempty'
			),
			'isUnique' => array(
				'rule' => array('isUnique'),
				'message' => 'Srvrole.name.isUnique'
			)
		),
	);

	//The Associations below have been created with all possible keys, those that are not needed can be removed

	/**
	 * hasMany associations
	 *
	 * @var array
	 */
	public $hasMany = array(
		'Srvuser' => array(
			'className' => 'Srvuser',
			'foreignKey' => 'srvrole_id',
			'dependent' => false,
			'conditions' => '',
			'fields' => '',
			'order' => '',
			'limit' => '',
			'offset' => '',
			'exclusive' => '',
			'finderQuery' => '',
			'counterQuery' => ''
		)
	);

}
