<?php

/**
 * Srvuser Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-06-25 11:34:14 +0200 (mer. 25 juin 2014) $
 * $Revision: 468 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Srvuser.php $
 * $Id: Srvuser.php 468 2014-06-25 09:34:14Z ssampaio $
 *
 * @property Srvrole $Srvrole
 */
App::uses('AppModel', 'Model');
App::uses('AuthComponent', 'Controller/Component');
App::uses('Password', 'Utility');

class Srvuser extends AppModel {

    /**
     *
     * @var type
     */
    public $useDbConfig = 'default';

    /**
     *
     * @var type
     */
    public $displayField = 'username';

    /**
     *
     * @var type
     */
    public $validationDomain = 'srvuser';

    /**
     *
     * @var type
     */
    public $actsAs = array('Password');

    /**
     * Validation rules
     *
     * @var array
     */
    public $validate = array(
        'firstname' => array(
            'notempty' => array(
                'rule' => array('notempty'),
                'message' => 'Srvuser.firstname.notempty'
            ),
        ),
        'lastname' => array(
            'notempty' => array(
                'rule' => array('notempty'),
                'message' => 'Srvuser.lastname.notempty'
            ),
        ),
        'username' => array(
            'notempty' => array(
                'rule' => array('notempty'),
                'message' => 'Srvuser.username.notempty'
            ),
            'isUnique' => array(
                'rule' => array('isUnique'),
                'message' => 'Srvuser.username.isUnique'
            )
        ),
        'mail' => array(
            'email' => array(
                'rule' => array('email'),
                'message' => 'Srvuser.mail.invalid'
            ),
            'notempty' => array(
                'rule' => array('notempty'),
                'message' => 'Srvuser.mail.notempty'
            ),
            'isUnique' => array(
                'rule' => array('isUnique'),
                'message' => 'Srvuser.mail.isUnique'
            )
        ),
        'password' => array(
            'notempty' => array(
                'rule' => array('notempty'),
                'message' => 'Srvuser.password.notempty'
            ),
            'checkIdenticalValues' => array(
                'rule' => array('checkIdenticalValues', 'confirm'),
                'message' => 'Srvuser.password.check'
            )
        ),
        'srvrole_id' => array(
            'uuid' => array(
                'rule' => array('uuid'),
                'message' => 'Srvuser.srvrole_id.notempty'
            ),
        )
    );

    //The Associations below have been created with all possible keys, those that are not needed can be removed

    /**
     * belongsTo associations
     *
     * @var array
     */
    public $belongsTo = array(
        'Srvrole' => array(
            'className' => 'Srvrole',
            'foreignKey' => 'srvrole_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        )
    );

    /**
     * hasAndBelongsToMany associations
     *
     * @var array
     */
    public $hasAndBelongsToMany = array(
        'Collectivite' => array(
            'className' => 'Collectivite',
            'joinTable' => 'collectivites_srvusers',
            'foreignKey' => 'srvuser_id',
            'associationForeignKey' => 'collectivite_id',
            'unique' => 'keepExisting',
            'conditions' => '',
            'fields' => '',
            'order' => '',
            'limit' => '',
            'offset' => '',
            'finderQuery' => '',
            'deleteQuery' => '',
            'insertQuery' => '',
            'with' => 'CollectivitesSrvuser'
        ),
        'Mandat' => array(
            'className' => 'Mandat',
            'joinTable' => 'srvusers_mandats',
            'foreignKey' => 'srvuser_id',
            'associationForeignKey' => 'mandat_id',
            'unique' => 'keepExisting',
            'conditions' => '',
            'fields' => '',
            'order' => '',
            'limit' => '',
            'offset' => '',
            'finderQuery' => '',
            'with' => 'SrvusersMandat'
        )
    );

}
