<?php

/**
 * SrvusersMandat Model
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2013-10-21 17:57:34 +0200 (lun., 21 oct. 2013) $
 * $Revision: 302 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://ssampaio@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Model/Imgpage.php $
 * $Id: Imgpage.php 302 2013-10-21 15:57:34Z ssampaio $
 *
 *
 * @property Srvuser $Srvuser
 * @property Mandat $Mandat
 */
App::uses('AppModel', 'Model');

class SrvusersMandat extends AppModel {

    /**
     *
     * @var type
     */
    public $useDbConfig = 'default';

    /**
     * Validation rules
     *
     * @var array
     */
    public $validate = array(
        'mandat_id' => array(
            'uuid' => array(
                'rule' => array('uuid')
            )
        )
    );

    /**
     * belongsTo associations
     *
     * @var array
     */
    public $belongsTo = array(
        'Srvuser' => array(
            'className' => 'Srvuser',
            'foreignKey' => 'srvuser_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        ),
        'Mandat' => array(
            'className' => 'Mandat',
            'foreignKey' => 'mandat_id',
            'conditions' => '',
            'fields' => '',
            'order' => ''
        )
    );

}
