<?php
/**
 * Collectivites/add View
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-04-01 09:55:53 +0200 (mar. 01 avril 2014) $
 * $Revision: 376 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/View/Collectivites/add.ctp $
 * $Id: add.ctp 376 2014-04-01 07:55:53Z ssampaio $
 */
echo $this->Html->css('collectivite_add');
?>
<div class="collectivites form" id="slides">
    <?php echo $this->Form->create('Collectivite', array('class' => 'form-horizontal')); ?>
    <fieldset class="item">
        <legend><?php echo __d('collectivite', 'Collectivite.add.requirement'); ?></legend>
        <div class="content">
            <?php echo __d('collectivite', 'Collectivite.add.requirement.alert'); ?><br />
            <div class="well">
                <div id="configdb-div">
                    <input type="checkbox" required="required" id="configdb"><label for="configdb"><?php echo __d('collectivite', 'Collectivite.add.requirement.chk1'); ?></label>
                </div>
                <?php echo __d('collectivite', 'Collectivite.add.requirement.msg1'); ?>
            </div>

        </div>
    </fieldset>

    <fieldset class="item">
        <legend><?php echo __d('collectivite', 'Collectivite.add.collectivite'); ?></legend>
        <div class="content">
            <?php
            echo $this->Form->input('Collectivite.active', array('checked' => true, 'type' => 'hidden'));
            echo $this->Form->input('Collectivite.name');
            echo $this->Form->input('Collectivite.login_suffix');
            echo $this->Form->input('Collectivite.conn', array('type' => 'select', 'empty' => true));
            ?>
        </div>
    </fieldset>

    <fieldset class="item">
        <legend><?php echo __d('collectivite', 'Collectivite.add.admin'); ?></legend>
        <div class="content">
            <?php
            echo $this->Form->input('User.firstname', array('required' => true));
            echo $this->Form->input('User.lastname', array('required' => true));
            echo $this->Form->input('User.mail', array('required' => true));
            echo $this->Html->tag('hr');
            echo $this->Form->input('User.username', array('required' => true));
            echo $this->Html->tag('hr');
            echo $this->Form->input('User.password', array('required' => true));
            echo $this->Form->input('User.confirm', array('type' => 'password', 'required' => true));
            ?>
        </div>
    </fieldset>
    <?php echo $this->Form->end(array('editMode' => true)); ?>
</div>

<?php
$settings = array(
    'id' => 'modalNotMatch',
    'title' => __d('user', 'User.password.notmatch.title'),
    'message' => __d('user', 'User.password.notmatch.message')
);
echo $this->BootstrapBox->msgBox($settings);
?>

<script type="text/javascript">
    var confirmOk = $('<span></span>').append($('<i></i>').addClass('icon').addClass('icon-ok').addClass('icon-white')).addClass('label').addClass('label-success');
    var confirmNok = $('<span></span>').append($('<i></i>').addClass('icon').addClass('icon-remove').addClass('icon-white')).addClass('label').addClass('label-important');

    function checkPassConfirm() {
        if ($('#UserPassword').val() !== $('#UserConfirm').val() || $('#UserPassword').val() === '' || $('UserConfirm').val() === '') {
            $('#UserConfirmInfo').empty().append(confirmNok);
        } else {
            $('#UserConfirmInfo').empty().append(confirmOk);
        }
    }

    $('#UserConfirm').after($('<span></span>').attr('id', 'UserConfirmInfo').css('margin-left', '5px')).on('keyup', function() {
        checkPassConfirm();
    });

    $('#UserPassword').on('keyup', function() {
        checkPassConfirm();
    });

    $('#CollectiviteAddForm').on('submit', function(e) {
        if ($('#UserPassword').val() !== $('#UserConfirm').val()) {
            e.preventDefault();
            e.stopPropagation();
            $('#modalNotMatch').modal('show');
            $('#UserPassword').focus();
        }
    });
</script>