/**
 *
 * webroot/idelibre_client/assets/annotations.html
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML5)
 *
 * @author Cyril Calmels
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-06-20 09:57:04 +0200 (ven. 20 juin 2014) $
 * $Revision: 462 $
 * $Author: ssampaio $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/annotations/annotations.js $
 * $Id: annotations.js 462 2014-06-20 07:57:04Z ssampaio $
 */

chargement_Annotation = function() {
    //objet de configuration

    objet_configuration = function() {
        //définition des variables de configuration générale de l'application
        this.TAILLE_FENETRE_X = 800;
        this.TAILLE_FENETRE_Y = 800;
        this.POSITION_FENETRE_X = 0;
        this.POSITION_FENETRE_Y = 0;
        this.TAILLE_BOUTONS = 20;
        this.TAILLE_MIN = 40;
        this.TAILLE_TEXTE = 15;
        this.TAILLE_BORDURE_ANNOTATIONS = 3;
        this.ZOOM_MAX = 2;
        this.UTILISATEUR = "défaut";
        this.ID_UTILISATEUR = "0";
        this.ENTRER_FERMER = true;
        this.TEMPS_ENREGISTREMENT_CLAVIER = 500;
        this.DATE_COMPLETE = true;
        this.FONCTION_EVENEMENT_SAUVEGARDE = null;
        this.FONCTION_CHARGEMENT_LISTE_PARTAGE = null;
        this.FONCTION_OUVERTURE_ANNOTATION = null;
        this.FONCTION_FERMETURE_ANNOTATION = null;
        this.FONCTION_ID = null;
        this.OPACITE_BASE = 0.1;
        this.OPACITE_SELECTION = 0.3;
        this.COULEUR_ANNOTATION_PRIVEE = '#0000FF';
        this.COULEUR_ANNOTATION_PUBLIQUE = '#04B404';
        this.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE = '#FACC2E';
        this.CHEMIN_BOUTONS = "images/";
        this.LISTE_PARTAGE_ACTIVEE = false;
        this.AFFICHER_BOUTONS_SURVOL = false;
        //Déclaration des variables globales
        this.document_chemins = null;
        this.annotations = new Array();
        this.sauvegarde_annotations = new Array();
        this.nbannotations = 0;
        this.modePartage = false;
        this.creationAnnotation = false;
        this.document_actuel = null;
        this.document_en_cours = false;
        this.zoom_x = 0;
        this.zoom_y = 0;
        this.zoom_limite_hauteur = 0;
        this.zoom_limite_largeur = 0;
        this.zoom_largeur = this.TAILLE_FENETRE_X;
        this.zoom_hauteur = this.TAILLE_FENETRE_Y;
        this.zoom_valeur = 1;
        this.zoom_en_cours = false;
        this.mode_annotation = false;
        this.mode_surlignage = false;
        this.taille_surlignage = 0.05;
        this.page_en_cours = 0;
        this.dernier_objet_sauve = null;
        this.modification_en_cours = false;
        this.action_annotation = "";
        this.action_annotation2 = "";
    };
    var configuration = new objet_configuration();

    //---------------Déclaration de la Classe "annotation"----------------------
    annotation = function(partage, page) {
        //Les attributs étant des objets sont déclarés directement dans
        //la fonction pour éviter des erreurs de non redéfinition de leurs
        //méthodes lorsque l'objet est instancié plusieurs fois.
        this.partage = partage;
        this.page = page;
        this.image = this.page.set();
        this.rectangle_surlignage = this.page.rect(0, 0, 0, 0);
        this.rectangle = this.page.rect(0, 0, 0, 0);
        this.boutonFermer = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_fermer.png", 0, 0, 0, 0);
        this.boutonVerrou = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_verrou.png", 0, 0, 0, 0);
        this.boutonReduire = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_reduire.png", 0, 0, 0, 0);
        this.boutonAgrandir = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_agrandir.png", 0, 0, 0, 0);
        this.boutonRedimensionner = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_redimensionner.png", 0, 0, 0, 0);
        this.boutonInformations = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_informations.png", 0, 0, 0, 0);
        this.zoneTexteInformations = this.page.rect(0, 0, 0, 0);
        this.affichageTexteInformations = this.page.text(0, 0, "valeur par défaut");
        this.boutonAnnotation = this.page.image(configuration.CHEMIN_BOUTONS + "bouton_annotation.png", 0, 0, 0, 0);
        this.divChampsDeTexte = document.createElement("div");
        this.champsDeTexte = document.createElement("textarea");
        this.date_actuelle = new Date();
        this.listePartage = new Array();
        this.divListePartage = document.createElement("div");
    };
    annotation.prototype = {
        //attribus
        texteInformations: "",
        texteInformationsVisible: false,
        champDeTexteVisible: false,
        page_document: 0,
        date: 0,
        date_modif: 0,
        id: "",
        id_utilisateur: "0",
        edition: true,
        initialisee: false,
        lue: true,
        surlignage: null,
        //méthodes
        //méthode à appeler à la création de l'objet pour régler ses
        //propriétés de base et déclarer ses évênements
        initialisation: function(x, y, largeur, hauteur) {
            var self = this;
            //réglage de la page
            this.page_document = configuration.page_en_cours;
            //réglage de la date
            this.date = this.date_actuelle.getTime();
            this.date_modif = this.date;
            //attribution de l'ID utilisateur
            this.id_utilisateur = configuration.ID_UTILISATEUR;
            //attribution d'un ID temporaire
            if (this.id === "") {
                if (configuration.FONCTION_ID === null) {
                    this.id = Annotation.UUID();
                }
                else {
                    this.id = configuration.FONCTION_ID(this.date, this.id_utilisateur);
                }
            }
            //récupération de la liste de partage
            if (configuration.FONCTION_CHARGEMENT_LISTE_PARTAGE !== null) {
                if (this.listePartage.length === 0)
                    this.listePartage = configuration.FONCTION_CHARGEMENT_LISTE_PARTAGE();
                //préparation du futur affichage de la liste
                for (var ipar = 0; ipar < this.listePartage.length; ipar++) {
                    this.divListePartage.innerHTML = this.divListePartage.innerHTML + "<label for='" + this.id + this.listePartage[ipar][1] + "' style='display:inline;'><a style='text-decoration:none;color:#000000;'><li style='padding:3px;margin-top:4px;" + ((ipar > 0) ? "border-top:1px solid #E5E5E5;" : "") + "' onmouseout='javascript:this.style.backgroundColor=" + '"' + "#FFFFFF" + '"' + ";this.style.color=" + '"' + "#000000" + '"' + ";' onmouseover='javascript:this.style.backgroundColor=" + '"' + "#007FBE" + '"' + ";this.style.color=" + '"' + "#FFFFFF" + '"' + ";'><input type='checkbox' data-uuid='" + this.listePartage[ipar][1] + "' name='checkboxListePartage' id='" + this.id + this.listePartage[ipar][1] + "' onchange='javascript:if(this.checked){Annotation.check(" + '"' + this.id + '"' + "," + ipar + "," + '1' + ");}else{Annotation.check(" + '"' + this.id + '"' + "," + ipar + "," + '0' + ");}'" + ((this.listePartage[ipar][2] === 1) ? "checked" : "") + " style='vertical-align:top;'/>" + this.listePartage[ipar][0] + "</li></a></label>";
                }
                this.divListePartage.innerHTML = "<ul style='list-style-type: none;margin-left:2px'>" + this.divListePartage.innerHTML;
                this.divListePartage.innerHTML = this.divListePartage.innerHTML + "</ul>";
            }
            //déclaration du groupe
            this.image.push(
                    this.rectangle,
                    this.rectangle_surlignage,
                    this.boutonFermer,
                    this.boutonVerrou,
                    this.boutonReduire,
                    this.boutonAgrandir,
                    this.boutonRedimensionner,
                    this.boutonInformations,
                    this.affichageTexteInformations,
                    this.zoneTexteInformations,
                    this.boutonAnnotation
                    );
            //configuration des éléments du groupe
            this.rectangle.attr({
                x: x,
                y: y,
                width: largeur,
                height: hauteur,
                r: 10,
                stroke: configuration.COULEUR_ANNOTATION_PRIVEE,
                'stroke-width': configuration.TAILLE_BORDURE_ANNOTATIONS,
                fill: configuration.COULEUR_ANNOTATION_PRIVEE,
                'fill-opacity': configuration.OPACITE_BASE,
                cursor: 'move'
            });
            this.rectangle_surlignage.attr({
                r: 0,
                'stroke-width': 0,
                fill: configuration.COULEUR_ANNOTATION_PRIVEE,
                'fill-opacity': configuration.OPACITE_BASE + 0.2
            });
            if (this.partage) {
                this.rectangle.attr({
                    stroke: configuration.COULEUR_ANNOTATION_PUBLIQUE,
                    fill: configuration.COULEUR_ANNOTATION_PUBLIQUE
                });
                this.rectangle_surlignage.attr({
                    fill: configuration.COULEUR_ANNOTATION_PUBLIQUE
                });
            }
            this.boutonFermer.attr({
                cursor: 'pointer'
            });
            this.boutonReduire.attr({
                cursor: 'pointer'
            });
            this.boutonAgrandir.attr({
                cursor: 'pointer'
            });
            this.boutonAgrandir.hide();
            this.boutonRedimensionner.attr({
                cursor: 'nw-resize'
            });
            this.boutonInformations.attr({
                cursor: 'pointer'
            });
            this.zoneTexteInformations.attr({
                stroke: 'black',
                'stroke-width': configuration.TAILLE_BORDURE_ANNOTATIONS / 2,
                fill: '#D1D1D2',
                'fill-opacity': 1,
                r: 10
            });
            if (configuration.DATE_COMPLETE)
                this.texteInformations = "Propriétaire : " + configuration.UTILISATEUR + " \nDate de création : " + this.date_actuelle.getDate() + "/" + (this.date_actuelle.getMonth() + 1) + "/" + this.date_actuelle.getFullYear() + " " + this.date_actuelle.getHours() + ":" + this.date_actuelle.getMinutes() + ":" + this.date_actuelle.getSeconds() + "\nType d'annotation : " + ((configuration.modePartage) ? "partagée" : "privée");
            else
                this.texteInformations = "Propriétaire : " + configuration.UTILISATEUR + " \nDate de création : " + this.date_actuelle.getDate() + "/" + (this.date_actuelle.getMonth() + 1) + "/" + this.date_actuelle.getFullYear() + "\nType d'annotation : " + ((configuration.modePartage) ? "partagée" : "privée");
            this.zoneTexteInformations.hide();
            this.affichageTexteInformations.attr({
                text: this.texteInformations,
                'font-size': configuration.TAILLE_TEXTE,
                'text-anchor': 'start'
            });
            this.affichageTexteInformations.hide();
            this.boutonAnnotation.attr({
                cursor: 'pointer'
            });
            //création des évênements
            this.rectangle.mousedown(function() {
                if (configuration.creationAnnotation === false)
                    this.attr('fill-opacity', configuration.OPACITE_SELECTION);
            });
            this.rectangle.mouseup(function() {
                this.attr('fill-opacity', configuration.OPACITE_BASE);
            });
            if (this.surlignage) {
                var surlignageIn = function() {
                    self.rectangle.show();
                    self.boutonFermer.show();
                    self.boutonReduire.show();
                    self.boutonInformations.show();
                    self.boutonAnnotation.show();
                };
                var surlignageOut = function() {
                    self.rectangle.hide();
                    self.boutonFermer.hide();
                    self.boutonReduire.hide();
                    self.boutonInformations.hide();
                    self.boutonAnnotation.hide();
                    self.setInfosVisible(false);
                };
                this.rectangle_surlignage.mouseover(surlignageIn);
                this.boutonFermer.mouseover(surlignageIn);
                this.boutonReduire.mouseover(surlignageIn);
                this.boutonAnnotation.mouseover(surlignageIn);
                this.boutonInformations.mouseover(surlignageIn);
                this.rectangle.mouseout(surlignageOut);
                this.boutonFermer.mouseout(surlignageOut);
                this.boutonReduire.mouseout(surlignageOut);
                this.boutonAnnotation.mouseout(surlignageOut);
                this.boutonInformations.mouseout(surlignageOut);
            }
            this.boutonFermer.mouseup(function() {
                if (!configuration.creationAnnotation) {
                    self.evtBoutonFermer();
                }
            });
            this.evtBoutonFermer = function() {
                if (self.edition === true) {
                    configuration.dernier_objet_sauve = self.sauver();
                    configuration.action_annotation = "detruire";
                    self.detruire();
                    Annotation.sauver();
                }
            };
            this.boutonReduire.mouseup(function() {
                if (!configuration.creationAnnotation) {
                    self.evtBoutonReduire();
                }
            });
            this.evtBoutonReduire = function() {
                self.rectangle.hide();
                self.rectangle_surlignage.hide();
                self.boutonAgrandir.show();
                self.boutonRedimensionner.hide();
                self.boutonInformations.hide();
                self.setChampsVisible(false);
                self.setInfosVisible(false);
                self.boutonAnnotation.hide();
                self.boutonReduire.hide();
            };
            this.boutonAgrandir.mouseup(function() {
                if (!configuration.creationAnnotation) {
                    self.evtBoutonAgrandir();
                }
            });
            this.evtBoutonAgrandir = function() {
                self.rectangle.show();
                self.rectangle_surlignage.show();
                self.boutonReduire.show();
                self.boutonRedimensionner.show();
                self.boutonInformations.show();
                self.boutonAnnotation.show();
                self.boutonAgrandir.hide();
            };
            this.boutonInformations.mouseup(function() {
                if (!configuration.creationAnnotation) {
                    self.evtBoutonInformations();
                }
            });
            this.evtBoutonInformations = function() {
                if (self.texteInformationsVisible) {
                    self.setInfosVisible(false);
                }
                else {
                    self.affichageTexteInformations.toFront();
                    var bboxTexte = self.affichageTexteInformations.getBBox();
                    var bboxFenetre = self.rectangle.getBBox();
                    self.zoneTexteInformations.attr({
                        x: ((bboxFenetre.x + bboxTexte.width - configuration.zoom_x) * configuration.zoom_valeur) > (configuration.TAILLE_FENETRE_X - configuration.zoom_limite_largeur) ? (configuration.TAILLE_FENETRE_X / configuration.zoom_valeur - bboxTexte.width - configuration.TAILLE_TEXTE + configuration.zoom_x) : (bboxFenetre.x - configuration.TAILLE_TEXTE),
                        y: ((bboxFenetre.y + bboxFenetre.height - configuration.zoom_y) * configuration.zoom_valeur + configuration.TAILLE_TEXTE) > (configuration.TAILLE_FENETRE_Y - 4 * configuration.TAILLE_TEXTE * configuration.zoom_valeur - configuration.zoom_limite_hauteur) ? (bboxFenetre.y - configuration.TAILLE_TEXTE * 5) : (bboxFenetre.y + bboxFenetre.height + configuration.TAILLE_TEXTE),
                        width: bboxTexte.width + configuration.TAILLE_TEXTE * 1.5,
                        height: bboxTexte.height + configuration.TAILLE_TEXTE / 2
                    });
                    self.affichageTexteInformations.attr({
                        x: ((bboxFenetre.x + bboxTexte.width - configuration.zoom_x) * configuration.zoom_valeur) > (configuration.TAILLE_FENETRE_X - configuration.zoom_limite_largeur) ? (configuration.TAILLE_FENETRE_X / configuration.zoom_valeur - bboxTexte.width + configuration.zoom_x) : (bboxFenetre.x),
                        y: ((bboxFenetre.y + bboxFenetre.height - configuration.zoom_y) * configuration.zoom_valeur + configuration.TAILLE_TEXTE) > (configuration.TAILLE_FENETRE_Y - 4 * configuration.TAILLE_TEXTE * configuration.zoom_valeur - configuration.zoom_limite_hauteur) ? (bboxFenetre.y - configuration.TAILLE_TEXTE * 3) : (bboxFenetre.y + bboxFenetre.height + configuration.TAILLE_TEXTE * 3),
                        text: self.texteInformations
                    });
                    self.setInfosVisible(true);
                    self.setChampsVisible(false);
                }
            };
            this.boutonAnnotation.mouseup(function() {
                if (!configuration.creationAnnotation) {
                    self.evtBoutonAnnotation();
                }
            });
            //Pour cet évênement la fonction est définie à l'exérieur car elle peut être appelée par un autre évênement
            this.evtBoutonAnnotation = function() {
                if (self.champDeTexteVisible) {
                    self.setChampsVisible(false);
                    configuration.dernier_objet_sauve = self.sauver();
                    configuration.action_annotation = "editer";
                    configuration.action_annotation2 = "fermer_texte";
                    Annotation.sauver();
                }
                else {
                    var bbox = self.rectangle.getBBox();
                    var largeur = Math.max(bbox.width * 0.9, 200);
                    var hauteur = Math.max(bbox.height * 0.4, 50);
                    self.champsDeTexte.style.width = Math.min(largeur * configuration.zoom_valeur, window.innerWidth * 0.95) + "px";
                    self.champsDeTexte.style.height = Math.min(hauteur * configuration.zoom_valeur, window.innerHeight) + "px";
                    self.divChampsDeTexte.style.left = ((bbox.x - configuration.zoom_x + largeur) * configuration.zoom_valeur) > (configuration.TAILLE_FENETRE_X - configuration.zoom_limite_largeur) ? Math.max(configuration.POSITION_FENETRE_X + configuration.TAILLE_FENETRE_X - (largeur + 7) * configuration.zoom_valeur, 2) + "px" : Math.max(configuration.POSITION_FENETRE_X + (bbox.x - configuration.zoom_x) * configuration.zoom_valeur, 2) + "px";
                    self.divChampsDeTexte.style.top = ((bbox.y + bbox.height + hauteur - configuration.zoom_y) * configuration.zoom_valeur + configuration.TAILLE_BOUTONS / 2) > (configuration.TAILLE_FENETRE_Y - configuration.zoom_limite_hauteur) ? Math.max(configuration.POSITION_FENETRE_Y + (bbox.y - configuration.zoom_y - hauteur) * configuration.zoom_valeur - configuration.TAILLE_BOUTONS, 2) + "px" : Math.max(configuration.POSITION_FENETRE_Y + (bbox.y + bbox.height - configuration.zoom_y) * configuration.zoom_valeur + configuration.TAILLE_BOUTONS / 2, 2) + "px";
                    if (this.partage && configuration.LISTE_PARTAGE_ACTIVEE) {
                        self.divListePartage.style.left = (bbox.x - configuration.zoom_x - 190 / configuration.zoom_valeur) > 0 ? configuration.POSITION_FENETRE_X + (bbox.x - configuration.zoom_x) * configuration.zoom_valeur - 195 + "px" : Math.min(configuration.POSITION_FENETRE_X + (bbox.x - configuration.zoom_x) * configuration.zoom_valeur + Math.max(bbox.width * configuration.zoom_valeur + 10, 200), window.innerWidth - 175) + "px";
                        self.divListePartage.style.top = (bbox.y + 150 - configuration.zoom_y) * configuration.zoom_valeur < (configuration.TAILLE_FENETRE_Y - configuration.zoom_limite_hauteur) ? Math.max(configuration.POSITION_FENETRE_Y + (bbox.y + bbox.height - configuration.zoom_y) * configuration.zoom_valeur - 150, configuration.POSITION_FENETRE_Y) + "px" : configuration.POSITION_FENETRE_Y + configuration.TAILLE_FENETRE_Y - configuration.zoom_limite_hauteur - 150 + "px";
                        self.divListePartage.style.width = 175 + "px";
                        self.divListePartage.style.height = 150 + "px";
                        if (self.id_utilisateur !== configuration.ID_UTILISATEUR) {
                            for (var i in self.listePartage) {
                                var element = document.getElementById(self.id + self.listePartage[i][1]);
                                element.style.display = "none";
                                element.parentNode.style.borderTop = "";
                                element.parentNode.onmouseover = "";
                                element.parentNode.onmouseout = "";
                                element.parentNode.parentNode.parentNode.setAttribute("for", "");
                                if (self.listePartage[i][2] === 0) {
                                    element.parentNode.style.display = "none";
                                }
                            }
                        }
                    }
                    self.setChampsVisible(true);
                    self.setInfosVisible(false);
                    configuration.dernier_objet_sauve = self.sauver();
                    configuration.action_annotation = "editer";
                    configuration.action_annotation2 = "ouvrir_texte";
                    Annotation.sauver();
                }
            };
            var memSauv = 0;
            this.champsDeTexte.onkeyup = function(e) {
                if (self.edition === true) {
                    memSauv++;
                    if (e.keyCode === 13 && configuration.ENTRER_FERMER) {
                        self.champsDeTexte.value = self.champsDeTexte.value.substring(0, self.champsDeTexte.value.length - 1);
                        self.setChampsVisible(false);
                    }
                    setTimeout(function() {
                        memSauv--;
                        if (memSauv === 0) {
                            var date = new Date();
                            self.date_modif = date.getTime();
                            configuration.dernier_objet_sauve = self.sauver();
                            configuration.action_annotation = "editer";
                            configuration.action_annotation2 = "texte_timeout";
                            Annotation.sauver();
                        }
                    }
                    , configuration.TEMPS_ENREGISTREMENT_CLAVIER);
                }
                else {
                    Annotation.afficher_page(Annotation.getConfig().page_en_cours);
                }
                return true;
            };
            this.champsDeTexte.onclick = function() {
                self.rectangle.attr('fill-opacity', configuration.OPACITE_BASE);
            };
            //gestion du "drag and drop" pour le déplacement de l'annotation
            start = function() {
                if (self.edition === true) {
                    configuration.modification_en_cours = true;
                    self.setInfosVisible(false);
                    self.setChampsVisible(false);
                    var bbox = this.getBBox();
                    this.memX = bbox.x;
                    this.memY = bbox.y;
                    this.memWidth = bbox.width;
                    this.memHeight = bbox.height;
                    self.image.toFront();
                }
            };
            move = function(dx, dy) {
                if (self.edition === true) {
                    var ndx = dx;
                    var ndy = dy;
                    ndx *= (1 / configuration.zoom_valeur);
                    ndy *= (1 / configuration.zoom_valeur);
                    var x = this.memX + ndx;
                    var y = this.memY + ndy;
                    var largeur = this.memWidth;
                    var hauteur = this.memHeight;
                    self.config(x, y, largeur, hauteur, false, true);
                }
            };
            end = function() {
                if (self.edition === true) {
                    self.rectangle.attr('fill-opacity', configuration.OPACITE_BASE);
                    configuration.dernier_objet_sauve = self.sauver();
                    configuration.action_annotation = "editer";
                    configuration.action_annotation2 = "deplacement";
                    Annotation.sauver();
                    configuration.modification_en_cours = false;
                }
            };
            this.page.set(this.rectangle).drag(move, start, end);
            //gestion du "drag and drop" pour le redimmensionnement de la fenêtre
            startRedim = function() {
                if (self.edition === true) {
                    configuration.modification_en_cours = true;
                    self.setInfosVisible(false);
                    self.setChampsVisible(false);
                    var bbox = self.rectangle.getBBox();
                    this.memX = bbox.x;
                    this.memY = bbox.y;
                    this.memWidth = bbox.width;
                    this.memHeight = bbox.height;
                }
            };

            redim = function(dx, dy) {
                if (self.edition === true) {
                    var ndx = dx;
                    var ndy = dy;
                    ndx = ndx * (1 / configuration.zoom_valeur) + this.memWidth;
                    ndy = ndy * (1 / configuration.zoom_valeur) + this.memHeight;
                    if (ndx > configuration.TAILLE_FENETRE_X - this.memX)
                        ndx = configuration.TAILLE_FENETRE_X - this.memX;
                    if (ndy > configuration.TAILLE_FENETRE_Y - this.memY)
                        ndy = configuration.TAILLE_FENETRE_Y - this.memY;
                    if (ndx < -this.memX)
                        ndx = -this.memX;
                    if (ndy < -this.memY)
                        ndy = -this.memY;
                    self.config(this.memX, this.memY, ndx, ndy, true, true);
                    this.memNdx = Math.abs(ndx);
                    this.memNdy = Math.abs(ndy);
                }
            };

            redimReset = function() {
                if (self.edition === true) {
                    if ((this.memNdx !== null) && (this.memNdx < configuration.TAILLE_MIN || this.memNdy < configuration.TAILLE_MIN)) {
                        self.config((this.memX - configuration.zoom_x) * configuration.zoom_valeur, (this.memY - configuration.zoom_y) * configuration.zoom_valeur, configuration.TAILLE_MIN, configuration.TAILLE_MIN, true);
                    }
                    this.memX = null;
                    this.memY = null;
                    this.memWidth = null;
                    this.memHeight = null;
                    this.memNdx = null;
                    this.memNdy = null;
                    configuration.dernier_objet_sauve = self.sauver();
                    configuration.action_annotation = "editer";
                    configuration.action_annotation2 = "redimensionnement";
                    Annotation.sauver();
                    configuration.modification_en_cours = false;
                }
            };
            this.page.set(this.boutonRedimensionner).drag(redim, startRedim, redimReset);
            //configuration du champ de texte associé avec sa liste de partage
            this.champsDeTexte.maxLength = "5000";
            document.body.appendChild(this.divChampsDeTexte);
            document.body.appendChild(this.divListePartage);
            this.divChampsDeTexte.appendChild(this.champsDeTexte);
            this.divChampsDeTexte.style.zIndex = "1";
            this.divListePartage.style.zIndex = "1";
            this.divChampsDeTexte.style.position = "absolute";
            this.divListePartage.style.position = "absolute";
            this.champsDeTexte.style.zIndex = "0";
            this.divChampsDeTexte.style.top = configuration.POSITION_FENETRE_Y + "px";
            this.divChampsDeTexte.style.left = configuration.POSITION_FENETRE_X + "px";
            this.divListePartage.style.top = configuration.POSITION_FENETRE_Y + "px";
            this.divListePartage.style.left = configuration.POSITION_FENETRE_X + "px";
            this.divChampsDeTexte.style.boxSizing = "border-box";
            this.divListePartage.style.border = "1px solid #BDBDBD";
            this.divListePartage.style.boxShadow = "-1px 1px 3px #555";
            this.divListePartage.style.borderRadius = "10px";
            this.divListePartage.style.backgroundColor = "#FFFFFF";
            this.divListePartage.style.overflow = "auto";
            this.champsDeTexte.style.display = "block";
            this.champsDeTexte.style.opacity = "1";
            this.divChampsDeTexte.style.display = "none";
            this.divListePartage.style.display = "none";
            //initialisation terminée
            this.initialisee = true;
        },
        //méthode permettant de modifier à la volée les propriétés de
        //l'annotation
        config: function(x, y, largeur, hauteur, modifDimensions, deplacement_en_cours) {
            var nx = x;
            var ny = y;
            var nlargeur = Math.abs(largeur);
            var nhauteur = Math.abs(hauteur);
            //on teste la situation de zoom
            if (!deplacement_en_cours) {
                nx = nx * (1 / configuration.zoom_valeur) + configuration.zoom_x;
                ny = ny * (1 / configuration.zoom_valeur) + configuration.zoom_y;
            }
            //on utilise Math.floor pour les tests suivants pour éviter des bug dus
            //à des problèmes de cast avec safari IOS
            if (Math.floor(largeur) < 0) {
                nx = nx + largeur;
            }
            if (Math.floor(hauteur) < 0) {
                ny = ny + hauteur;
            }
            if (Math.floor(nx) < 0) {
                nx = 0;
            }
            if (Math.floor(ny) < 0) {
                ny = 0;
            }
            if (nx > configuration.TAILLE_FENETRE_X - nlargeur) {
                nx = configuration.TAILLE_FENETRE_X - nlargeur;
            }
            if (ny > configuration.TAILLE_FENETRE_Y - nhauteur) {
                ny = configuration.TAILLE_FENETRE_Y - nhauteur;
            }
            //une fois tous les test effectués on modifie les dimensions des
            //rectangles dans le même ordre que leur création pour conserver les priorités
            //d'interraction avec l'utilisateur
            if (this.surlignage) {
                this.rectangle_surlignage.attr({
                    width: this.surlignage[0] * configuration.TAILLE_FENETRE_X,
                    height: this.surlignage[1] * configuration.TAILLE_FENETRE_Y,
                    x: nx + this.surlignage[2] * configuration.TAILLE_FENETRE_X,
                    y: ny + this.surlignage[3] * configuration.TAILLE_FENETRE_Y
                });
            }
            this.rectangle_surlignage.toFront();
            this.rectangle.attr({
                width: nlargeur,
                height: nhauteur,
                x: nx,
                y: ny
            });
            this.rectangle.toFront();
            //la dernière étape est l'adaptation de l'affichage des boutons par
            //rapport aux nouvelles dimensions du rectangle
            if ((nlargeur >= configuration.TAILLE_MIN / configuration.zoom_valeur && nhauteur >= configuration.TAILLE_MIN / configuration.zoom_valeur) || !modifDimensions) {
                this.boutonFermer.attr({
                    x: nx - configuration.TAILLE_BOUTONS / 3,
                    y: ny - configuration.TAILLE_BOUTONS / 3
                });
                this.boutonFermer.toFront();
                this.boutonVerrou.attr({
                    x: nx - configuration.TAILLE_BOUTONS / 3,
                    y: ny - configuration.TAILLE_BOUTONS / 3
                });
                this.boutonReduire.attr({
                    x: nx + configuration.TAILLE_BOUTONS * 0.8,
                    y: ny - configuration.TAILLE_BOUTONS / 3
                });
                this.boutonReduire.toFront();
                this.boutonAgrandir.attr({
                    x: nx + configuration.TAILLE_BOUTONS * 0.8,
                    y: ny - configuration.TAILLE_BOUTONS / 3
                });
                this.boutonAgrandir.toFront();
                this.boutonRedimensionner.attr({
                    x: nx + nlargeur - configuration.TAILLE_BOUTONS * 0.95,
                    y: ny + nhauteur - configuration.TAILLE_BOUTONS
                });
                this.boutonRedimensionner.toFront();
                this.boutonInformations.attr({
                    x: nx - configuration.TAILLE_BOUTONS / 3,
                    y: ny + nhauteur - configuration.TAILLE_BOUTONS / 1.5
                });
                this.boutonInformations.toFront();
                this.boutonAnnotation.attr({
                    x: nx + configuration.TAILLE_BOUTONS * 0.8,
                    y: ny + nhauteur - configuration.TAILLE_BOUTONS / 1.5
                });
                this.boutonAnnotation.toFront();
                if (modifDimensions) {
                    if (this.edition) {
                        this.boutonFermer.attr({
                            width: configuration.TAILLE_BOUTONS,
                            height: configuration.TAILLE_BOUTONS
                        });
                    }
                    else {
                        this.boutonVerrou.attr({
                            width: configuration.TAILLE_BOUTONS,
                            height: configuration.TAILLE_BOUTONS
                        });
                        this.boutonVerrou.toFront();
                        this.rectangle.attr({
                            stroke: configuration.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE,
                            fill: configuration.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE
                        });
                        this.rectangle_surlignage.attr({
                            fill: configuration.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE
                        });
                    }
                    this.boutonReduire.attr({
                        width: configuration.TAILLE_BOUTONS,
                        height: configuration.TAILLE_BOUTONS
                    });
                    this.boutonReduire.toFront();
                    this.boutonAgrandir.attr({
                        width: configuration.TAILLE_BOUTONS,
                        height: configuration.TAILLE_BOUTONS
                    });
                    var facteurRedim = 1;
                    if (this.surlignage || this.id_utilisateur !== configuration.ID_UTILISATEUR) {
                        facteurRedim = 0;
                    }
                    this.boutonRedimensionner.attr({
                        width: configuration.TAILLE_BOUTONS * facteurRedim,
                        height: configuration.TAILLE_BOUTONS * facteurRedim
                    });
                    this.boutonRedimensionner.toFront();
                    this.boutonInformations.attr({
                        width: configuration.TAILLE_BOUTONS,
                        height: configuration.TAILLE_BOUTONS
                    });
                    this.boutonInformations.toFront();
                    this.boutonAnnotation.attr({
                        width: configuration.TAILLE_BOUTONS,
                        height: configuration.TAILLE_BOUTONS
                    });
                    this.boutonAnnotation.toFront();
                }
            }
            else {
                this.boutonFermer.attr({
                    width: 0,
                    height: 0
                });
                this.boutonVerrou.attr({
                    width: 0,
                    height: 0
                });
                this.boutonReduire.attr({
                    width: 0,
                    height: 0
                });
                this.boutonAgrandir.attr({
                    width: 0,
                    height: 0
                });
                this.boutonRedimensionner.attr({
                    width: 0,
                    height: 0
                });
                this.boutonInformations.attr({
                    width: 0,
                    height: 0
                });
                this.boutonAnnotation.attr({
                    width: 0,
                    height: 0
                });
            }
            var date = new Date();
            this.date_modif = date.getTime();
        },
        setVisible: function(visible) {
            if (visible) {
                this.image.show();
                this.boutonAgrandir.hide();
                this.setChampsVisible(false);
                this.setInfosVisible(false);
            }
            else {
                this.image.hide();
                this.setChampsVisible(false);
                this.setInfosVisible(false);
            }
        },
        setChampsVisible: function(visible) {
            var self = this;
            if (visible) {
                this.divChampsDeTexte.style.display = "block";
                if (this.partage && configuration.LISTE_PARTAGE_ACTIVEE) {
                    this.divListePartage.style.display = "block";
                }
                if (configuration.FONCTION_OUVERTURE_ANNOTATION !== null) {
                    configuration.FONCTION_OUVERTURE_ANNOTATION(self);
                }
            }
            else {
                this.divChampsDeTexte.style.display = "none";
                this.divListePartage.style.display = "none";
                if (configuration.FONCTION_FERMETURE_ANNOTATION !== null) {
                    configuration.FONCTION_FERMETURE_ANNOTATION(self);
                }
            }
            this.champDeTexteVisible = visible;
        },
        setInfosVisible: function(visible) {
            if (visible) {
                this.affichageTexteInformations.show();
                this.zoneTexteInformations.show();
            }
            else {
                this.affichageTexteInformations.hide();
                this.zoneTexteInformations.hide();
            }
            this.texteInformationsVisible = visible;
        },
        //Cette méthode est utilisée seulement par l'objet document_configuration.annotations
        getFonctionnelle: function() {
            return true;
        },
        //Cette méthode permet de savoir à quelle page doit être affichée cette annotation
        getPage: function() {
            return this.page_document;
        },
        //Cette méthode permet de créer un tableau sauvegarde à partir de l'annotation
        sauver: function() {
            var bbox = this.rectangle.getBBox();
            //            console.log({
            //                id: this.id,
            //                id_utilisateur: this.id_utilisateur,
            //                page: this.page_document,
            //                type: this.partage,
            //                x: bbox.x / configuration.TAILLE_FENETRE_X,
            //                y: bbox.y / configuration.TAILLE_FENETRE_Y,
            //                largeur: bbox.width / configuration.TAILLE_FENETRE_X,
            //                hauteur: bbox.height / configuration.TAILLE_FENETRE_Y,
            //                date: this.date,
            //                date_modif: this.date_modif,
            //                texteInformations: this.texteInformations,
            //                texteChamps: this.champsDeTexte.value,
            //                listePartage: this.listePartage,
            //                lue: this.lue,
            //                surlignage: this.surlignage
            //            });
            return {
                id: this.id,
                id_utilisateur: this.id_utilisateur,
                page: this.page_document,
                type: this.partage,
                x: bbox.x / configuration.TAILLE_FENETRE_X,
                y: bbox.y / configuration.TAILLE_FENETRE_Y,
                largeur: bbox.width / configuration.TAILLE_FENETRE_X,
                hauteur: bbox.height / configuration.TAILLE_FENETRE_Y,
                date: this.date,
                date_modif: this.date_modif,
                texteInformations: this.texteInformations,
                texteChamps: this.champsDeTexte.value,
                listePartage: this.listePartage,
                lue: this.lue,
                surlignage: this.surlignage
            };
        },
        //Cette méthode permet de charger des données sauvegardées ultérieurement, elle ne
        //peut être utilisée que sur une anotation qui n'a pas encore été initialisée
        charger: function(objet_sauvegarde) {
//            console.log("TEST");
//            console.log(objet_sauvegarde);
            if (this.page_document === 0) {
                this.page_document = objet_sauvegarde.page;
                this.partage = objet_sauvegarde.type;
                this.listePartage = objet_sauvegarde.listePartage;
                this.id = objet_sauvegarde.id;
                this.surlignage = objet_sauvegarde.surlignage;
                this.initialisation(objet_sauvegarde.x * configuration.TAILLE_FENETRE_X, objet_sauvegarde.y * configuration.TAILLE_FENETRE_Y, objet_sauvegarde.largeur * configuration.TAILLE_FENETRE_X, objet_sauvegarde.hauteur * configuration.TAILLE_FENETRE_Y);
                this.date = objet_sauvegarde.date;
                this.date_modif = objet_sauvegarde.date_modif;
                this.id_utilisateur = objet_sauvegarde.id_utilisateur;
                if (this.id_utilisateur !== configuration.ID_UTILISATEUR) {
                    this.edition = false;
                    this.champsDeTexte.disabled = true;
                }
                this.config(objet_sauvegarde.x * configuration.TAILLE_FENETRE_X, objet_sauvegarde.y * configuration.TAILLE_FENETRE_Y, objet_sauvegarde.largeur * configuration.TAILLE_FENETRE_X, objet_sauvegarde.hauteur * configuration.TAILLE_FENETRE_Y, true, true);
                this.texteInformations = objet_sauvegarde.texteInformations;
                this.champsDeTexte.value = objet_sauvegarde.texteChamps;
                this.lue = objet_sauvegarde.lue;
            }
        },
        //Cette méthode permet de détruire complètement l'annotation
        detruire: function() {
            this.image.removeData();
            this.image.remove();
            this.champsDeTexte.parentNode.removeChild(this.champsDeTexte);
            this.divChampsDeTexte.parentNode.removeChild(this.divChampsDeTexte);
            this.divListePartage.parentNode.removeChild(this.divListePartage);
            for (var prop in this) {
                this[prop] = null;
            }
            this.getFonctionnelle = function() {
                return false;
            };
            configuration.FONCTION_FERMETURE_ANNOTATION();
        }
    };
    //--------------------------------------------------------------------------

    //---------------------Création de l'objet Document-------------------------
    var document_annotations = function(image) {
        this.cheminImage = image;
    };
    document_annotations.prototype = {
        paper: null,
        fond: null,
        initialisation: function() {
            var self = this;
            // Création de la zone de dessin
            this.paper = Raphael(configuration.POSITION_FENETRE_X, configuration.POSITION_FENETRE_Y, configuration.TAILLE_FENETRE_X, configuration.TAILLE_FENETRE_Y);

            //ajout de l'image du document
            this.image = this.paper.image(this.cheminImage, 0, 0, configuration.TAILLE_FENETRE_X, configuration.TAILLE_FENETRE_Y);

            //Création d'un fond permettant de gérer la création d'configuration.annotations
            this.fond = this.paper.rect(0, 0, configuration.TAILLE_FENETRE_X, configuration.TAILLE_FENETRE_Y);
            this.fond.attr({
                fill: 'white',
                'fill-opacity': configuration.OPACITE_BASE,
                stroke: 'gray',
                'stoke-width': 1
            });

            //évênement de création des annotations
            annotationCreation = function(x, y) {
                configuration.creationAnnotation = true;
                configuration.annotations[configuration.nbannotations] = new annotation(configuration.modePartage, self.paper);
                configuration.annotations[configuration.nbannotations].initialisation(0, 0, 0, 0);
                this.memX = x - configuration.POSITION_FENETRE_X;
                this.memY = y - configuration.POSITION_FENETRE_Y;
            };
            annotationConfig = function(dx, dy) {
                var val_zoom = 1 / configuration.zoom_valeur;
                var ndx = dx;
                var ndy = dy;
                ndx = ndx * val_zoom;
                ndy = ndy * val_zoom;
                if (ndx > (configuration.TAILLE_FENETRE_X - this.memX) * val_zoom)
                    ndx = (configuration.TAILLE_FENETRE_X - this.memX) * val_zoom;
                if (ndy > (configuration.TAILLE_FENETRE_Y - this.memY) * val_zoom)
                    ndy = (configuration.TAILLE_FENETRE_Y - this.memY) * val_zoom;
                if (ndx < -this.memX)
                    ndx = -this.memX;
                if (ndy < -this.memY)
                    ndy = -this.memY;
                if (configuration.annotations[configuration.nbannotations].initialisee === true) {
                    configuration.annotations[configuration.nbannotations].config(this.memX, this.memY, ndx, ndy, true, false);
                }
                this.memNdx = Math.abs(ndx);
                this.memNdy = Math.abs(ndy);
            };
            annotationReset = function() {
                if (this.memNdx < configuration.TAILLE_MIN || this.memNdy < configuration.TAILLE_MIN) {
                    configuration.annotations[configuration.nbannotations].detruire();
                    configuration.nbannotations--;
                }
                if (typeof (configuration.annotations[configuration.nbannotations]) !== 'undefined' && typeof (configuration.annotations[configuration.nbannotations].sauver) !== 'undefined' && typeof (configuration.annotations[configuration.nbannotations].sauver) === 'function') {
                    configuration.dernier_objet_sauve = configuration.annotations[configuration.nbannotations].sauver();
                }
                configuration.nbannotations++;
                this.memX = null;
                this.memY = null;
                this.memNdx = null;
                this.memNdy = null;
                configuration.creationAnnotation = false;
                configuration.action_annotation = "creer";
                Annotation.sauver();
            };
            //évênement de déplacement lors d'un zoom

            deplacementStart = function(x, y) {
                this.memX = configuration.zoom_x;
                this.memY = configuration.zoom_y;
            };
            deplacement = function(dx, dy) {
                Annotation.regler_zoom(this.memX - dx, this.memY - dy, configuration.zoom_valeur, false);
            };
            deplacementEnd = function() {
                this.memX = null;
                this.memY = null;
            };

            //liaison des évênements possédants les mêmes déclencheurs
            var erreurMultiPoint = 0;
            dragStart = function(x, y) {
                if (configuration.creationAnnotation) {
                    erreurMultiPoint++;
                }
                if (!erreurMultiPoint) {
                    if (configuration.mode_annotation && !configuration.creationAnnotation) {
                        annotationCreation(x, y);
                    }
                    else {
                        deplacementStart(x, y);
                    }
                }
            };
            dragMove = function(dx, dy) {
                if (!erreurMultiPoint) {
                    if (configuration.mode_annotation) {
                        annotationConfig(dx, dy);
                    }
                    else {
                        deplacement(dx, dy);
                    }
                }
            };
            /**
             *
             * @returns {undefined}
             */
            dragEnd = function() {
                if (!erreurMultiPoint) {
                    if (configuration.mode_annotation) {
                        annotationReset();
                    }
                    else {
                        deplacementEnd();
                    }
                }
                else {
                    erreurMultiPoint--;
                }
            };
            this.paper.set(this.fond).drag(dragMove, dragStart, dragEnd);
        },
        /**
         *
         * @returns {undefined}
         */
        detruire: function() {
            for (var i = 0; i < configuration.annotations.length; i++) {
                if (configuration.annotations[i].getFonctionnelle())
                    configuration.annotations[i].detruire();
            }
            this.fond.removeData();
            this.fond.remove();
            this.image.removeData();
            this.image.remove();
            this.paper.remove();
            for (prop in this) {
                this[prop] = null;
            }
        }
    };

    //--------------------------------------------------------------------------


    /**
     * Cette partie comprend toutes les fonctions que l'utilisateur de la bibliothèque peut
     * utiliser pour gérer un document et ses configuration.annotations
     *
     * @returns {chargement_Annotation.Annotation_objet_principal}
     */
    Annotation_objet_principal = function() {
        /**
         *
         * @returns {Array}
         */
        this.UUID = function() {
            var nbr, randStr = "";
            do {
                randStr += (nbr = Math.random()).toString(16).substr(2);
            } while (randStr.length < 30);
            return [
                randStr.substr(0, 8), "-",
                randStr.substr(8, 4), "-4",
                randStr.substr(12, 3), "-",
                ((nbr * 4 | 0) + 8).toString(16), // [89ab]
                randStr.substr(15, 3), "-",
                randStr.substr(18, 12)
            ].join("");
        };
        /**
         * Créer la page en cours
         *
         * @param {Integer} page numéro de page
         * @returns {void}
         */
        this.creer_page = function(page) {
            if (!configuration.document_en_cours) {
                configuration.page_en_cours = page;
                configuration.document_actuel = new document_annotations(configuration.document_chemins[page - 1]);
                configuration.document_actuel.initialisation();
                configuration.document_en_cours = true;
                this.regler_zoom(0, 0, 1, false);
            }
        };
        /**
         * Détruit la page en cours
         *
         * @returns {void}
         */
        this.detruire_page = function() {
            if (configuration.document_en_cours) {
                configuration.document_actuel.detruire();
                configuration.document_en_cours = false;
                configuration.annotations.splice(0, configuration.annotations.length);
                configuration.nbannotations = 0;
            }
        };
        /**
         * Changement du type d'annotation (swap)
         *
         * @returns {void}
         */
        this.changer_mode_annotation = function() {
            configuration.modePartage = !configuration.modePartage;
        };
        /**
         * Changement du type d'annotation
         *
         * @param {type} boolean (true: annotations partagées, false : annotations privées)
         * @returns {void}
         */
        this.choisir_mode_annotation = function(boolean) {
            configuration.modePartage = boolean;
        };
        /**
         * Zoom sans animation
         *
         * @param {Float} x
         * @param {Float} y
         * @param {Float} valeur
         * @param {Boolean} animation true: animation, false : zoom instantanné
         * @returns {void}
         */
        this.regler_zoom = function(x, y, valeur, animation) {
            var zoom_x_actuel = configuration.zoom_x;
            var zoom_y_actuel = configuration.zoom_y;
            var zoom_largeur_actuel = configuration.zoom_largeur;
            var zoom_hauteur_actuel = configuration.zoom_hauteur;
            configuration.zoom_x = x;
            configuration.zoom_y = y;
            configuration.zoom_largeur = configuration.TAILLE_FENETRE_X / valeur;
            configuration.zoom_hauteur = configuration.TAILLE_FENETRE_Y / valeur;
            configuration.zoom_valeur = valeur;
            for (var i = 0; i < configuration.annotations.length; i++) {
                if (configuration.annotations[i].getFonctionnelle())
                    configuration.annotations[i].setChampsVisible(false);
            }
            if ((configuration.zoom_x + configuration.zoom_largeur) > configuration.TAILLE_FENETRE_X + configuration.zoom_limite_largeur / configuration.zoom_valeur) {
                configuration.zoom_x = configuration.TAILLE_FENETRE_X - configuration.zoom_largeur + configuration.zoom_limite_largeur / configuration.zoom_valeur;
            }
            if (configuration.zoom_x < 0) {
                configuration.zoom_x = 0;
            }
            if ((configuration.zoom_y + configuration.zoom_hauteur) > configuration.TAILLE_FENETRE_Y + configuration.zoom_limite_hauteur / configuration.zoom_valeur) {
                configuration.zoom_y = configuration.TAILLE_FENETRE_Y - configuration.zoom_hauteur + configuration.zoom_limite_hauteur / configuration.zoom_valeur;
            }
            if (configuration.zoom_y < 0) {
                configuration.zoom_y = 0;
            }
            if (!configuration.zoom_en_cours) {
                if (animation) {
                    configuration.zoom_en_cours = true;
                    retardement = function(i) {
                        setTimeout(function() {
                            configuration.document_actuel.paper.setViewBox((zoom_x_actuel * (10 - i) + configuration.zoom_x * i) / 10, (zoom_y_actuel * (10 - i) + configuration.zoom_y * i) / 10, (zoom_largeur_actuel * (10 - i) + configuration.zoom_largeur * i) / 10, (zoom_hauteur_actuel * (10 - i) + configuration.zoom_hauteur * i) / 10, false);
                        }, i * 15);
                    };
                    for (var i = 1; i < 11; i++) {
                        retardement(i);
                    }
                    setTimeout(function() {
                        configuration.zoom_en_cours = false;
                    }, 150);
                }
                else {
                    configuration.document_actuel.paper.setViewBox(configuration.zoom_x, configuration.zoom_y, configuration.zoom_largeur, configuration.zoom_hauteur, false);
                }
            }
        };
        /**
         * Zoom avec annimation ( +0.1 )
         *
         * @returns {void}
         */
        this.zoom_plus = function() {
            if (configuration.zoom_valeur + 0.1 <= configuration.ZOOM_MAX) {
                this.regler_zoom(configuration.zoom_x, configuration.zoom_y, configuration.zoom_valeur + 0.1, true);
            }
            else {
                this.regler_zoom(configuration.zoom_x, configuration.zoom_y, configuration.ZOOM_MAX, true);
            }
        };
        /**
         * Zoom avec annimation ( -0.1 )
         *
         * @returns {void}
         */
        this.zoom_moins = function() {
            if (configuration.zoom_valeur - 0.1 >= 1) {
                this.regler_zoom(configuration.zoom_x, configuration.zoom_y, configuration.zoom_valeur - 0.1, true);
            }
            else {
                this.regler_zoom(0, 0, 1, true);
            }
        };
        /**
         * Retenir les annotations en cours
         *
         * @returns {void}
         */
        this.sauver = function() {
            var j = 0;
            configuration.sauvegarde_annotations[configuration.page_en_cours - 1] = [];
            for (var i = 0; i < configuration.annotations.length; i++) {
                if (configuration.annotations[i].getFonctionnelle() && configuration.annotations[i].getPage() === configuration.page_en_cours) {
                    configuration.sauvegarde_annotations[configuration.page_en_cours - 1][j] = configuration.annotations[i].sauver();
                    j++;
                }
            }
            if (configuration.FONCTION_EVENEMENT_SAUVEGARDE !== null)
                configuration.FONCTION_EVENEMENT_SAUVEGARDE(configuration.dernier_objet_sauve, configuration.action_annotation, configuration.action_annotation2);
        };
        /**
         * Rafraichir l'affichage des annotations de la page en cours
         *
         * @returns {void}
         */
        this.charger = function() {
            if (typeof (configuration.sauvegarde_annotations[configuration.page_en_cours - 1]) !== 'undefined') {
                for (var i = 0; i < configuration.sauvegarde_annotations[configuration.page_en_cours - 1].length; i++) {
                    configuration.annotations[configuration.nbannotations] = new annotation(configuration.sauvegarde_annotations[configuration.page_en_cours - 1][i].type, configuration.document_actuel.paper);
                    configuration.annotations[configuration.nbannotations].charger(configuration.sauvegarde_annotations[configuration.page_en_cours - 1][i]);
                    configuration.nbannotations++;
                }
            }
        };
        /**
         * Changement de mode édition / déplacement
         *
         * @param {Boolean} valeur
         * @returns {void}
         */
        this.definir_creation_annotation = function(valeur) {
            configuration.mode_annotation = valeur;
        };
        /**
         * Chargement des imgpage en background
         *
         * @param {Array} chemins ['path_to_background_imgpage1', 'path_to_background_imgpage2', ...]
         * @returns {void}
         */
        this.initialiser_document = function(chemins) {
//            console.log("Hello");
            configuration.document_chemins = chemins;
            for (var i = 0; i < chemins.length; i++) {
                configuration.sauvegarde_annotations[i] = new Array();
            }
        };
        /**
         * Changement de page
         *
         * @param {type} epage numéro de page (1,2,3,4,6, ...)
         * @returns {void}
         */
        this.afficher_page = function(epage) {
            var page = epage;
            var nbpage = configuration.document_chemins.length;
            if (page < 1)
                page = 1;
            if (page > (nbpage))
                page = nbpage;
            this.detruire_page();
            this.creer_page(page);
            this.charger();
        };
        /**
         * Récupère le tableau sauvegarde courrant
         *
         * @returns {Array} tableau sauvegarde
         */
        this.getSauvegarde = function() {
            var resultat = new Array();
            for (var i = 0; i < configuration.sauvegarde_annotations.length; i++) {
                resultat[i] = configuration.sauvegarde_annotations[i];
            }
            return resultat;
        };
        /**
         * Ecrase le tableau sauvegarde courrant
         *
         * @param {type} nouvelle_sauvegarde
         * @returns {void}
         */
        this.setSauvegarde = function(nouvelle_sauvegarde) {
            configuration.sauvegarde_annotations = nouvelle_sauvegarde;
        };
        /**
         * sauvegarde l'object sauvegarde en cours dans le localStorage
         *
         * @param {type} clef uuid du document
         * @returns {undefined}
         */
        this.sauvegarde_locale = function(clef) {
            appUI.storage.core.set(clef, JSON.stringify(configuration.sauvegarde_annotations));
        };

        /**
         * récupérer un tableau sauvegarde à partir du localStorage et appliquer au document
         *
         * @param {String} clef uuid du document
         * @returns {void}
         */
        this.chargement_local = function(clef) {
           
            var sauvegarde = JSON.parse(appUI.storage.core.get(clef));
            if (sauvegarde !== null) {
                this.setSauvegarde(sauvegarde);
                this.actualiser();
            }
        };
        /**
         * Rafraichit l'affichage du document et des annotations (conserve le zoom)
         *
         * @returns {void}
         */
        this.actualiser = function() {
            if (configuration.page_en_cours > 0) {
                var mem_zoom_valeur = configuration.zoom_valeur;
                var mem_zoom_x = configuration.zoom_x;
                var mem_zoom_y = configuration.zoom_y;
                this.afficher_page(configuration.page_en_cours);
                this.regler_zoom(mem_zoom_x, mem_zoom_y, mem_zoom_valeur, false);
            }
        };
        /**
         * Déplace sur la page de l'annotation et ouvre son champ texte
         *
         * @param {String} id uuid de l'annotation
         * @param {Boolean} desactiver_surbrillance
         * @returns {void}
         */
        this.trouver_annotation = function(id, desactiver_surbrillance) {
            var i = 0;
            var j = 0;
            var k = 0;
            var trouve = false;
            while (i < configuration.sauvegarde_annotations.length && trouve === false) {
                j = 0;
                if (typeof configuration.sauvegarde_annotations[i] !== "undefined") {
                    while (j < configuration.sauvegarde_annotations[i].length && trouve === false) {
                        if (configuration.sauvegarde_annotations[i][j].id === id) {
                            trouve = true;
                            this.afficher_page(configuration.sauvegarde_annotations[i][j].page);
                            while (configuration.annotations[k].id !== id) {
                                k++;
                            }
                            if (!desactiver_surbrillance)
                                configuration.annotations[k].rectangle.attr({'fill-opacity': configuration.OPACITE_SELECTION});
                            var bbox = configuration.annotations[k].rectangle.getBBox();
                            var x = bbox.x;
                            var y = bbox.y;
                            this.regler_zoom(x, y, configuration.zoom_valeur, false);
                            configuration.annotations[k].evtBoutonAnnotation();
                            configuration.annotations[k].champsDeTexte.focus();
                            configuration.annotations[k].champsDeTexte.selectionStart = configuration.annotations[k].champsDeTexte.selectionEnd = configuration.annotations[k].champsDeTexte.value.length;
                        }
                        j++;
                    }
                }
                i++;
            }
        };

        //JEAN
        this.supprimer_annotation = function(id) {
            var i = 0;
            var j = 0;
            var trouve = false;
            while (i < configuration.sauvegarde_annotations.length && trouve === false) {
                j = 0;
                if (typeof configuration.sauvegarde_annotations[i] !== "undefined") {
                    while (j < configuration.sauvegarde_annotations[i].length && trouve === false) {
                        if (configuration.sauvegarde_annotations[i][j].id === id) {
                            trouve = true;
                            this.afficher_page(configuration.sauvegarde_annotations[i][j].page);
                            for (var k in configuration.annotations) {
                                if (configuration.annotations[k].id === id) {
                                    configuration.annotations[k].evtBoutonFermer();
                                }
                            }
                        }
                        j++;
                    }
                }
                i++;
            }
        }
        //JEAN
        /**
         *
         * @param {type} id
         * @param {type} numero
         * @param {type} valeur
         * @returns {undefined}
         */
        this.check = function(id, numero, valeur) {
            var i = 0;
            var j = 0;
            var k = 0;
            var trouve = false;
            while (i < configuration.sauvegarde_annotations.length && trouve === false) {
                j = 0;
                while (j < configuration.sauvegarde_annotations[i].length && trouve === false) {
                    if (configuration.sauvegarde_annotations[i][j].id === id) {
                        trouve = true;
                        configuration.sauvegarde_annotations[i][j].listePartage[numero][2] = valeur;
                        while (configuration.annotations[k].id !== id) {
                            k++;
                        }
                        configuration.annotations[k].listePartage[numero][2] = valeur;
                    }
                    j++;
                }
                i++;
            }
            if (trouve === true) {
                configuration.action_annotation = "editer";
                configuration.action_annotation2 = "check";
                Annotation.sauver();
            }
        };

        this.getConfig = function() {
            return {
                fenetre: {x: configuration.POSITION_FENETRE_X, y: configuration.POSITION_FENETRE_Y, largeur: configuration.TAILLE_FENETRE_X, hauteur: configuration.TAILLE_FENETRE_Y},
                annotations: {dimensions_minimum: configuration.TAILLE_MIN, taille_boutons: configuration.TAILLE_BOUTONS, taille_texte: configuration.TAILLE_TEXTE, epaisseur_bordure: configuration.TAILLE_BORDURE_ANNOTATIONS, mode_partage: configuration.modePartage, mode_annotation: configuration.mode_annotation}, //on ne peut pas modifier les modes avec le setConfig
                zoom_maximum: configuration.ZOOM_MAX,
                zoom_courant_valeur: configuration.zoom_valeur, //on ne peut pas modifier cette valeur avec le setConfig
                zoom_courant_x: configuration.zoom_x, //on ne peut pas modifier cette valeur avec le setConfig
                zoom_courant_y: configuration.zoom_y, //on ne peut pas modifier cette valeur avec le setConfig
                zoom_limite_hauteur: configuration.zoom_limite_hauteur, //décalage max par rapport au cadre lors du zoom (sert pour le scroll)
                zoom_limite_largeur: configuration.zoom_limite_largeur,
                utilisateur: configuration.UTILISATEUR,
                id_utilisateur: configuration.ID_UTILISATEUR,
                validation_entrer: configuration.ENTRER_FERMER, //true : la touche entrée valide et ferme le champ texte d'une annotation  ,false : permet de faire des sauts de ligne dans le champ texte d'une annotation
                delai_enregistrement_clavier: configuration.TEMPS_ENREGISTREMENT_CLAVIER, //delai avant enregistrement du texte des annotations
                date_avec_heure: configuration.DATE_COMPLETE,
                /**
                 * Type : callback
                 * Evenement : modification annotation
                 * Role : Savoir ce qui a été modifié
                 * Syntaxe : function(Object annotation, String action){}
                 * Arguments :
                 * 				 * Object annotation
                 * 				 * String action
                 *						detruire | creer | editer
                 * Retour :
                 *
                 * doit ếtre mise à null si non utilisée
                 */
                fonction_evenement_sauvegarde: configuration.FONCTION_EVENEMENT_SAUVEGARDE,
                /**
                 * Type : fonction
                 * Evenement : A la création de chaque annotation
                 * Role : Donner la liste de partage à l'annotation
                 * Syntaxe : function(){}
                 * Arguments :
                 * Retour : [
                 *		[ "utilisateur_nom_prenom" , uuid ],
                 *		[ "utilisateur_nom_prenom" , uuid ],
                 *		[ "utilisateur_nom_prenom" , uuid ],
                 *		[ "utilisateur_nom_prenom" , uuid ]
                 * ]
                 *
                 * doit ếtre mise à null si non utilisée
                 */
                fonction_chargement_liste_partage: configuration.FONCTION_CHARGEMENT_LISTE_PARTAGE,
                /**
                 * Type : callback
                 * Evenement : ouverture du champ texte d'une annotation
                 * Role :
                 * Syntaxe : function(){}
                 * Arguments :
                 * Retour :
                 *
                 * doit ếtre mise à null si non utilisée
                 */
                fonction_ouverture_annotation: configuration.FONCTION_OUVERTURE_ANNOTATION,
                /**
                 * Type : callback
                 * Evenement : fermeture du champ texte d'une annotation
                 * Role :
                 * Syntaxe : function(){}
                 * Arguments :
                 * Retour :
                 *
                 * doit ếtre mise à null si non utilisée
                 */
                fonction_fermeture_annotation: configuration.FONCTION_FERMETURE_ANNOTATION,
                /**
                 * Type : fonction
                 * Evenement : génération de l'uuid d'une annotation
                 * Role :
                 * Syntaxe : function(){}
                 * Arguments :
                 * Retour : String uuid
                 *
                 * doit ếtre mise à null si non utilisée
                 */
                fonction_id: configuration.FONCTION_ID,
                page_en_cours: configuration.page_en_cours, //on ne peut pas modifier cette valeur avec le setConfig
                pages_nombre: (configuration.document_chemins === null) ? 0 : configuration.document_chemins.length, //on ne peut pas modifier cette valeur avec le setConfig
                opacite_base: configuration.OPACITE_BASE,
                opacite_selection: configuration.OPACITE_SELECTION,
                couleur_annotation_privee: configuration.COULEUR_ANNOTATION_PRIVEE,
                couleur_annotation_publique: configuration.COULEUR_ANNOTATION_PUBLIQUE,
                couleur_annotation_publique_externe: configuration.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE,
                //chemin vers les fichiers des boutons
                chemin_dossier_boutons: configuration.CHEMIN_BOUTONS,
                //creation de la div de partage ou non
                liste_partage_activee: configuration.LISTE_PARTAGE_ACTIVEE,
                //status de l'action de l'utilisateur sur les annotations
                modification_en_cours: configuration.modification_en_cours,
                afficher_boutons_survol: configuration.AFFICHER_BOUTONS_SURVOL
            };
        };

        //se référer au getConfig pour les commentaires
        this.setConfig = function(objet) {
            if (typeof (objet.fenetre) !== "undefined") {
                if (typeof (objet.fenetre.x) !== "undefined")
                    configuration.POSITION_FENETRE_X = objet.fenetre.x;
                if (typeof (objet.fenetre.y) !== "undefined")
                    configuration.POSITION_FENETRE_Y = objet.fenetre.y;
                if (typeof (objet.fenetre.largeur) !== "undefined") {
                    configuration.TAILLE_FENETRE_X = objet.fenetre.largeur;
                }
                if (typeof (objet.fenetre.hauteur) !== "undefined") {
                    configuration.TAILLE_FENETRE_Y = objet.fenetre.hauteur;
                }
            }
            if (typeof (objet.annotations) !== "undefined") {
                if (typeof (objet.annotations.dimensions_minimum) !== "undefined")
                    configuration.TAILLE_MIN = objet.annotations.dimensions_minimum;
                if (typeof (objet.annotations.taille_boutons) !== "undefined")
                    configuration.TAILLE_BOUTONS = objet.annotations.taille_boutons;
                if (typeof (objet.annotations.taille_texte) !== "undefined")
                    configuration.TAILLE_TEXTE = objet.annotations.taille_texte;
                if (typeof (objet.annotations.epaisseur_bordure) !== "undefined")
                    configuration.TAILLE_BORDURE_ANNOTATIONS = objet.annotations.epaisseur_bordure;
            }
            if (typeof (objet.zoom_maximum) !== "undefined")
                configuration.ZOOM_MAX = objet.zoom_maximum;
            if (typeof (objet.utilisateur) !== "undefined")
                configuration.UTILISATEUR = objet.utilisateur;
            if (typeof (objet.id_utilisateur) !== "undefined")
                configuration.ID_UTILISATEUR = objet.id_utilisateur;
            if (typeof (objet.validation_entrer) !== "undefined")
                configuration.ENTRER_FERMER = objet.validation_entrer;
            if (typeof (objet.delai_enregistrement_clavier) !== "undefined")
                configuration.TEMPS_ENREGISTREMENT_CLAVIER = objet.delai_enregistrement_clavier;
            if (typeof (objet.date_avec_heure) !== "undefined")
                configuration.DATE_COMPLETE = objet.date_avec_heure;
            if (typeof (objet.fonction_evenement_sauvegarde) !== "undefined")
                configuration.FONCTION_EVENEMENT_SAUVEGARDE = objet.fonction_evenement_sauvegarde;
            if (typeof (objet.fonction_chargement_liste_partage) !== "undefined")
                configuration.FONCTION_CHARGEMENT_LISTE_PARTAGE = objet.fonction_chargement_liste_partage;
            if (typeof (objet.fonction_ouverture_annotation) !== "undefined")
                configuration.FONCTION_OUVERTURE_ANNOTATION = objet.fonction_ouverture_annotation;
            if (typeof (objet.fonction_fermeture_annotation) !== "undefined")
                configuration.FONCTION_FERMETURE_ANNOTATION = objet.fonction_fermeture_annotation;
            if (typeof (objet.fonction_id) !== "undefined")
                configuration.FONCTION_ID = objet.fonction_id;
            if (typeof (objet.opacite_base) !== "undefined")
                configuration.OPACITE_BASE = objet.opacite_base;
            if (typeof (objet.opacite_selection) !== "undefined")
                configuration.OPACITE_SELECTION = objet.opacite_selection;
            if (typeof (objet.couleur_annotation_privee) !== "undefined")
                configuration.COULEUR_ANNOTATION_PRIVEE = objet.couleur_annotation_privee;
            if (typeof (objet.couleur_annotation_publique) !== "undefined")
                configuration.COULEUR_ANNOTATION_PUBLIQUE = objet.couleur_annotation_publique;
            if (typeof (objet.couleur_annotation_publique_externe) !== "undefined")
                configuration.COULEUR_ANNOTATION_PUBLIQUE_EXTERNE = objet.couleur_annotation_publique_externe;
            if (typeof (objet.chemin_dossier_boutons) !== "undefined")
                configuration.CHEMIN_BOUTONS = objet.chemin_dossier_boutons;
            if (typeof (objet.zoom_limite_hauteur) !== "undefined")
                configuration.zoom_limite_hauteur = objet.zoom_limite_hauteur;
            if (typeof (objet.zoom_limite_largeur) !== "undefined")
                configuration.zoom_limite_largeur = objet.zoom_limite_largeur;
            if (typeof (objet.liste_partage_activee) !== "undefined")
                configuration.LISTE_PARTAGE_ACTIVEE = objet.liste_partage_activee;
            if (typeof (objet.afficher_boutons_survol) !== "undefined")
                configuration.AFFICHER_BOUTONS_SURVOL = objet.afficher_boutons_survol;

            this.actualiser();
        };

        /**
         * Détruire proprement tout le document (svg compris)
         *
         * @returns {void}
         */
        this.reset = function() {
            Annotation.detruire_page();
            for (prop in Annotation) {
                this[prop] = null;
            }
            chargement_Annotation();
        };
    };

    Annotation = new Annotation_objet_principal();
};