/**
 *
 * webroot/idelibre_client/assets/js/appUI/contextes/ctx_home.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/contexts/ctx_convocation.js $
 * $Id: ctx_convocation.js 537 2014-07-29 12:45:51Z genot $
 */

/**
 * Home context singleton
 */

var ctxConvocation = $.extend(true, {}, new appContext(), {
    name: 'convocation',
    fullname: 'Convocation',
    document: {
        content: {
            url: 'convocation.js',
            process: function() {
                appUI.content.empty();
                //  Message de bienvenue
                var textDiv = $('<h1></h1>').html(ctxConvocation.fullname)
                .prepend($('<div />')
                         .append($('<i />').addClass('icon').addClass('icon-caret-left'))
                         .append(' ')
                         .append($('<i />').addClass('icon').addClass('icon-th'))
                         .css('float', 'left')
                         .addClass('btn')
                         .addClass('btn-inverse')
                         .bind('click', function() {
                             appUI.set('seances');
                         }))
                .append($('<div />')
                        .append($('<i />').addClass('icon').addClass('icon-list'))
                        .append(' ')
                        .append($('<i />').addClass('icon').addClass('icon-caret-right'))
                        .css('float', 'right')
                        .addClass('btn')
                        .addClass('btn-inverse')
                        .bind('click', function() {
                            appUI.set('odj');
                        }));
                appUI.content.append(textDiv);

                var convocationPages = $('<div />').attr('id', 'convocationPages').addClass('loading-bg');
                appUI.content.append(convocationPages);

                // Gestion des évènements sur les images
                /**
                 *   posY et lastPosY servent à la gestion du scroll au doigt.
                 *   unused : scale et lastScale servent à la gestion du zoom au doigt.
                 **/
                var posY, lastPosY, scale, lastScale = 0;

                /**
                 *   On applique la gestion tactile sur l'élément "convocationPages"
                 **/
                var element = window.document.getElementById("convocationPages");

                /**
                 *   Options pour un scroll stable (voir doc. HammerJS)
                 **/
                var options = {
                    dragLockToAxis: true,
                    dragBlockHorizontal: true,
                    scale_treshold: 0
                };

                /**
                 *  @function touch
                 *  @param {JSObject} element
                 *  @param {JSObject} options
                 *  @description Ecouteur des évènements tactiles via Hammer.JS
                 **/
                var touch = new Hammer(element, options);
                touch.on("touch swiperight swipeleft drag dragend transform", function(event) {
                    manageMultitouch(event);
                });

                /**
                 *  @function manageMultiTouch
                 *  @param {JSObject} ev
                 *  @description Gestion et répartition des évènements tactiles
                 **/
                function manageMultitouch(ev) {
                    switch (ev.type) {
                        case 'touch':
                            // on sauvegarde la position verticale et la taille du document
                            lastScale = scale;
                            lastPosY = element.scrollTop;

                            break;

                        case 'swiperight':
                            // swipe vers la droite : retour à la page précédente
                            prev();
                            break;

                        case 'swipeleft':
                            // swipe vers la gauche : aller vers la page suivante
                            next();
                            break;

                        case 'drag':
                            //  on applique sur le document la translation équivalente au mouvement du doigt pour scroller.
                            posY = lastPosY - ev.gesture.deltaY;
                            element.scrollTop = posY;
                            break;

                        case 'dragend':
                            //  on sauvegarde la dernière position verticale du document au lâcher du doigt.
                            lastPosY = posY;
                            element.scrollTop = lastPosY;
                            break;
                    }
                }

                //  Récupération de toutes les séances de l'utilisateur courant.
                var dataSeances = appUI.storage.core.get('seances');
                for (var itS in dataSeances) {
                    var seance = dataSeances[itS];
                    // Pour chaque séance, on associe les images correspondantes en les récupérant depuis la base de                            données locale (indexeddb)
                    if (seance.Seance.id === appUI.seance_to_read) {

                        var nbPages = 0;
                        for (var itP in seance.Document.Imgpage) {
                            var page = seance.Document.Imgpage[itP];

                            nbPages++;
                            var newPage = new Image();
                            $(newPage).attr('id', page.id);
                            $('#convocationPages').append(newPage);

                            appUI.idb.get(page.id, function(err, doc) {
                                if (err) {
                                    if (err.status === 404) {
                                        console.log("Image introuvable");
                                    } else {
                                        console.log(err);
                                    }
                                } else {
                                    $('#' + doc.id).attr('src', 'data:image/png;base64,' + doc.data);
                                }
                            });
                        }
                    }
                }

                var currentPage = 0;

                /**
                 *  @function show
                 *  @param {Integer} numPage
                 *  @param {String} direction
                 *  @description Affiche la page correspondante à numPage
                 **/
                function show(numPage, direction) {
                    $('#convocationPages img').removeAttr('current').css('display', 'none');
                    $($('#convocationPages img')[numPage]).attr('current', 'current').css('display', 'block');
                    $('#convocationPages').scrollTop(0);
                }

                /**
                 *  @function next
                 *  @description Affiche la page suivante
                 **/
                function next() {
                    if (currentPage + 2 <= nbPages) {
                        currentPage++;
                        $('#currentPage').html(currentPage + 1);
                        show(currentPage, 'next');
                    }
                }

                /**
                 *  @function prev
                 *  @description Affiche la page précédente
                 **/
                function prev() {
                    if (currentPage - 1 >= 0) {
                        currentPage--;
                        $('#currentPage').html(currentPage + 1);
                        show(currentPage, 'prev');
                    }
                }

                //  Création de l'outil de visualisation d'images dans le DOM.
                var pager = $('<div />').attr('id', 'convocationPager');

                $(pager)
                .append($('<div />').addClass('btn').append($('<i />').addClass('icon').addClass('icon-caret-left')).bind('click', prev))
                .append($('<div />').attr('id', 'currentPage').html(currentPage + 1))
                .append($('<div />').html('/' + nbPages))
                .append($('<div />').addClass('btn').append($('<i />').addClass('icon').addClass('icon-caret-right')).bind('click', next));

                appUI.content.append(pager);
                show(currentPage);

                /**
                 *  @function resize
                 *  @description Adapte l'outil de visualisation d'images à la taille de l'écran
                 **/
                function resize() {
                    $('#convocationPages, #convocationPager').css('width', $('#UIContent h1').css('width'));
                }

                $(window).unbind('resize').bind('resize', resize);
                resize();
            }
        }
    },
    
    /**
     *  @function refreshData
     *  @description Rafraîchit le contexte courant
     **/
    refreshData: function(type, account, data) {


    }
});
