/**
 *
 * webroot/idelibre_client/assets/js/appUI/contextes/ctx_home.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/contexts/ctx_home.js $
 * $Id: ctx_home.js 537 2014-07-29 12:45:51Z genot $
 */

/**
 * Home context singleton
 */




var ctxHome = $.extend(true, {}, new appContext(), {
    name: 'home',
    fullname: 'Accueil',
    document: {
        content: {
            //            url: 'home.js',
            process: function() {

                //  Vidage du contexte précédent
                appUI.content.empty();
                //  Message de bienvenue
                var textDiv = $('<h1></h1>').html("Bienvenue sur l'application <b>i-delibRE client</b>").addClass('homeTitle');
                appUI.content.append(textDiv);
                //  Affichage de la liste des mandats
                var mandats = $('<div />');
                if (typeof appUI.accounts.items === "undefined" || appUI.accounts.items === null || appUI.accounts.items.length === 0) {
                    //  Si aucun compte n'a été défini, on affiche un message d'avertissement...
                    mandats.append($('<div />').addClass('alert').addClass('alert-info').html('Aucun mandat d&eacute;fini.'));
                } else {
                    //  Sinon, on affiche tous les comptes.
                    for (var i = 0, ln = appUI.accounts.items.length; i < ln; i++) {
                        var account = appUI.accounts.items[i];
                        if (!account.firstTime) {

                            var mandat = $('<div />').addClass('selectableListItem');
                            var labelContent = account.label;
                            if (account.userFirstname !== "" && account.userLastname !== "") {
                                labelContent += "<br />(" + connName(account.login) + ")";
                            }

                            var label = $('<div />').html(labelContent).css({
                                margin: '0 15px',
                                'text-align': 'center'
                            });
                            //  On récupère toutes les séances et convocations pour chaque compte afin d'afficher les compteurs (compteur de séances non lues, compteur de séances totales...)
                            var dataSeances = appUI.storage.core.get("seances", account.id);
                            var countSeances = 0;
                            var countUnreadSeances = 0;
                            if (dataSeances !== null) {
                                countSeances = dataSeances.length;
                                for (var j = 0; j < countSeances; j++) {
                                    var seance = dataSeances[j];
                                    for (var k = 0, lnConvoc = seance.Convocation.length; k < lnConvoc; k++) {
                                        var convocation = seance.Convocation[k];
                                        if (convocation.User.id === account.userId && !convocation.read) {
                                            countUnreadSeances++;
                                        }
                                    }

                                }
                            }
                            
                            
                             

                            //  On crée les notifications pour chaque compteur.
                            var badgeNbSeances = $('<span />')
                                    .addClass('badge')
                                    .addClass('badge-info')
                                    .addClass('countSeances')
                                    .html(countSeances);
                            var nbSeances = $('<div />').append('Vous avez ').append(badgeNbSeances).append(' séance' + (countSeances > 1 ? 's' : '') + ' planifiée' + (countSeances > 1 ? 's' : '') + '.').css('margin-top', '55px');
                            var badgeNbSeancesNonLues = $('<span />')
                                    .addClass('badge')
                                    .addClass('badge-important')
                                    .css({
                                        'float': 'left',
                                        'margin': '0 3px',
                                        'visibility': countUnreadSeances > 0 ? 'visible' : 'hidden'
                                    })
                                    .attr('title', 'Séances non lues')
                                    .addClass('countUnreadSeances')
                                    .append($('<i />').addClass('icon').addClass('icon-envelope'))
                                    .append(' ' + countUnreadSeances);
                            //  On récupère toutes les annotations pour chaque compte afin d'afficher le compteur d'annotations non lues.
                            var dataAnnotations = appUI.storage.core.get("annotations", account.id);
                            var countUnreadAnnotations = 0;
                            if (dataAnnotations !== null) {
                                for (var j = 0, lnAnnotations = dataAnnotations.length; j < lnAnnotations; j++) {
                                    if (!dataAnnotations[j].lue && dataAnnotations[j].type && dataAnnotations[j].id_utilisateur !== appUI.accounts.get(account.id).userId) {
                                        countUnreadAnnotations++;
                                    }
                                }
                            }




                            //  On crée la notification pour le compteur d'annotations non lues.
                            var badgeNbAnnotNonLues = $('<span />')
                                    .addClass('badge')
                                    .addClass('badge-warning')
                                    .css({
                                        'float': 'right',
                                        'margin': '0 3px',
                                        'visibility': countUnreadAnnotations > 0 ? 'visible' : 'hidden'
                                    })
                                    .attr('title', 'Annotations non lues')
                                    .addClass('countUnreadAnnotations')
                                    .append($('<i />').addClass('icon').addClass('icon-comments'))
                                    .append(' ' + countUnreadAnnotations);






                            // pour les seances modifiées
                            var seancesModifiees = appUI.storage.core.get("modifiedSeances", account.id);


                            if (typeof seancesModifiees === "undefined" || seancesModifiees === null) {
                                seancesModifiees = [];
                            }





                            var nbSeancesModifiees = seancesModifiees.length;

                           // console.log(nbSeancesModifiees);

                              var badgeNbModifiees = $('<span />')
                             .addClass('badge')
                             .addClass('badge-warning')
                             .addClass('countModifiedSeances')
                             .css({
                             'float': 'left',
                             'margin': '0 3px',
                             'visibility': nbSeancesModifiees > 0 ? 'visible' : 'hidden'
                             })
                             .attr('title', 'Séances Modifiée')
                             .append($('<i />').addClass('icon').addClass('icon-refresh'))
                             .append(' ' + nbSeancesModifiees);
                             
                             
                             



                            var certCheck = '';
                            if (appUI.cordova) {
                                certCheck = $('<span />')
                                        .css({
                                            'margin': '0 3px',
                                            'position': 'absolute',
                                            'bottom': '30px',
                                            'left': '10px'
                                        })
                                        .addClass('certCheck')
                                        //  On ajoute une icône indiquant si le compte est connecté ou non.
                                        .append($('<i />').addClass('icon').css('color', '#999').addClass(appUI.accountsCert.get(account.id) === 'certificat non valide' ? 'icon-unlock' : 'icon-lock'))
                                        .append(' ')
                                        .append($('<span />').addClass('info').html(appUI.accountsCert.get(account.id)));
                            }


                            var isSocketInitialized = appUI.engine.getSocket(account.id) !== null
                                    && typeof appUI.engine.getSocket(account.id) !== 'undefined'
                                    && typeof appUI.engine.getSocket(account.id).socket !== 'undefined';


                            var socketConnected = $('<span />')
                                    .css({
                                        'margin': '0 3px',
                                        'position': 'absolute',
                                        'bottom': '10px',
                                        'left': '10px'
                                    })
                                    .addClass('socketConnected')
                                    //  On ajoute une icône indiquant si le compte est connecté ou non.
                                    .append($('<i />').addClass('icon').css('color', '#999').addClass(isSocketInitialized && appUI.engine.getSocket(account.id).socket.connected ? 'icon-link' : 'icon-unlink'))
                                    .append(' ')
                                    .append($('<span />').addClass('info').html(isSocketInitialized && appUI.engine.getSocket(account.id).socket.connected ? 'connect&eacute;' : 'd&eacute;connect&eacute;'));

                            var loadConvocations = $('<span />')
                                    .css({
                                        'position': 'absolute',
                                        'margin': '0 3px',
                                        'height': '15px',
                                        'right': '10px',
                                        'top': '130px'
                                    })
                                    .addClass('loadProgress')
                                    .append($('<span />').addClass('info')
                                            .attr('title', 'Convocations téléchargées')
                                            .append($('<span />').addClass('convocations').html(appUI.imgLoaded.getStatus2(account).convocations))
                                            .append($('<span />').addClass('nbConvocations').html("/" + countSeances))
                                            .append(' ')
                                            .append($('<i />').addClass('icon').addClass('icon-file').addClass("itemAction"))
                                            );

                            var loadProgress = $('<span />')
                                    .css({
                                        'margin': '0 3px',
                                        'position': 'absolute',
                                        'bottom': '10px',
                                        'right': '10px'
                                    })
                                    .addClass('loadProgress')
                                    .append($('<span />').addClass('info')
                                            .append($('<span />').addClass('percent').html(appUI.imgLoaded.getStatus2(account).percent))
                                            .append($('<span />').html(' %'))
                                            .append(' ')
                                            .append($('<i />').addClass('icon').addClass('icon-folder-close'))
                                            );

                            var btn = $('<div></div>')
                                    //                                .css(appUI.contexts.params.cssBtn)
                                    .addClass('btn')
                                    .addClass('btn-huge')
                                    .css({overflow: 'hidden', '-o-text-overflow': 'ellipsis', 'text-overflow': 'ellipsis', 'position': 'relative'})
                                    .addClass('btn-account')
                                    .attr('id', account.id + 'Btn')
                                    .attr('data', account.id)
                                    .html(nbSeances)
                                    .prepend(badgeNbSeancesNonLues)
                                    .prepend(certCheck)
                                    .prepend(socketConnected)
                                    .prepend(badgeNbModifiees)
                                    .prepend(loadConvocations)

                                    .prepend(loadProgress)
                                    .prepend(badgeNbAnnotNonLues).click(function(e) {
                                appUI.accounts.switch($(this).attr('data'));
                            });
                            $(mandat).append(label).append(btn);
                            $(mandats).append($(mandat));
                        }
                    }
                }


                // appUI.content.append(badgeNbModifiees);
                appUI.content.append(mandats);
                //  Création du bouton pour accéder à la page de gestion des comptes.
//                var btnGotoAccounts = $('<div />')
//                .addClass('btn')
//                .addClass('btn-inverse')
//                .append($('<i />').addClass('icon').addClass('icon-user'))
//                .append(' Gestion des mandats')
//                .bind('click', function() {
//                    appUI.set('params');
//                });
                appUI.content.append($('<hr >'));
//                appUI.content.append(btnGotoAccounts);
                //  Affichage du logo i-delibRE client.
                var logoIdelibre = $('<img />').prop('src', 'assets/img/logo_idelibre_client.png').addClass('pull-right').addClass('homeLogo').css('clear', 'both');
                appUI.content.append(logoIdelibre);

            }
        }
    },
    /**
     *  @function refreshData
     *  @param {String} type
     *  @param {JSObject} account
     *  @param {JSObject} data
     *  @description Rafraîchit le contexte courant
     **/
    refreshData: function(type, account, data) {
        if (type === "seances") {
            //  rafraichissement des badges lors de la synchro de toutes les seances (connexion, ajout de compte, ...)
            var dataSeances = appUI.storage.core.get("seances", account.id);
            var countSeances = 0;
            var countUnreadSeances = 0;
            if (typeof dataSeances !== "undefined" && dataSeances !== null) {
                countSeances = dataSeances.length;
                for (var j = 0; j < countSeances; j++) {
                    var seance = dataSeances[j];
                    for (var k = 0, lnConvoc = seance.Convocation.length; k < lnConvoc; k++) {
                        var convocation = seance.Convocation[k];
                        if (convocation.User.id === account.userId && !convocation.read) {
                            countUnreadSeances++;
                        }
                    }
                }
            }

            var badgeNbSeances = $('<span />')
                    .addClass('badge')
                    .addClass('badge-info')
                    .addClass('countSeances')
                    .html(countSeances);
            $('#' + account.id + 'Btn .countSeances').parent().empty().append('Vous avez ').append(badgeNbSeances).append(' séance' + (countSeances > 1 ? 's' : '') + ' planifiée' + (countSeances > 1 ? 's' : '') + '.');
            $('#' + account.id + 'Btn .countUnreadSeances')
                    .empty()
                    .append($('<i />').addClass('icon').addClass('icon-envelope'))
                    .append(' ' + countUnreadSeances)
                    .css('visibility', countUnreadSeances > 0 ? 'visible' : 'hidden');



        } else if (type === "modification") {
            var seancesModifiees = appUI.storage.core.get("modifiedSeances", account.id);
            var nbSeancesModifiees = seancesModifiees.length;

            $('#' + account.id + 'Btn .countModifiedSeances')
                    .empty()
                    .append($('<i />').addClass('icon').addClass('icon-refresh'))
                    .append(' ' + nbSeancesModifiees)
                    .css('visibility', nbSeancesModifiees > 0 ? 'visible' : 'hidden');




        } else if (type === "annotations") {
            //  rafraichissement des badges lors de la synchro de toutes les annotations (connexion, ajout de compte, ...)
            var dataAnnotations = appUI.storage.core.get("annotations", account.id);
            var countUnreadAnnotations = 0;
            if (dataAnnotations !== null) {
                for (var j = 0, lnAnnotations = dataAnnotations.length; j < lnAnnotations; j++) {
                    if (!dataAnnotations[j].lue && dataAnnotations[j].type && dataAnnotations[j].id_utilisateur !== appUI.accounts.get(account.id).userId) {
                        countUnreadAnnotations++;
                    }
                }
            }

            $('#' + account.id + 'Btn .countUnreadAnnotations')
                    .empty()
                    .append($('<i />').addClass('icon').addClass('icon-comments'))
                    .append(' ' + countUnreadAnnotations)
                    .css('visibility', countUnreadAnnotations > 0 ? 'visible' : 'hidden');
        } else if (type === "seance") {
            //  rafraichissement des badges lors de la reception d une seance



        } else if (type === "annotation") {
            //  rafraichissement des badges lors de la reception d une annotation
            countUnreadAnnotations++;
            $('#' + account.id + 'Btn .countUnreadAnnotations')
                    .empty()
                    .append($('<i />').addClass('icon').addClass('icon-comments'))
                    .append(' ' + countUnreadAnnotations)
                    .css('visibility', countUnreadAnnotations > 0 ? 'visible' : 'hidden');


        } else if (type === 'loadProgress') {

            var dataSeances = appUI.storage.core.get("seances", account.id);

            $('#' + account.id + 'Btn .loadProgress .percent').html(appUI.imgLoaded.getStatus2(account).percent);
            $('#' + account.id + 'Btn .loadProgress .convocations').html(appUI.imgLoaded.getStatus2(account).convocations);
            if (appUI.imgLoaded.getStatus2(account).convocations !== dataSeances.length) {
                $('#' + account.id + 'Btn .loadProgress .icon-file').addClass('active');
                setTimeout(function() {
                    $('#' + account.id + 'Btn .loadProgress .icon-file').removeClass('active');
                }, 300);
            }
            $('#' + account.id + 'Btn .loadProgress .nbConvocations').html("/" + dataSeances.length);
        }else if (type === "reload") {
             this.document.content.process();
        }
    }
});
