/**
 *
 * webroot/idelibre_client/assets/js/appUI/contextes/ctx_home.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/contexts/ctx_odj.js $
 * $Id: ctx_odj.js 537 2014-07-29 12:45:51Z genot $
 */

/**
 * Home context singleton
 */

var ctxOdj = $.extend(true, {}, new appContext(), {
    name: 'odj',
    fullname: 'Ordre du jour',
    timeout: {},
    document: {
        content: {
            url: 'odj.js',
            process: function() {
                appUI.content.empty();
                //  Message de bienvenue
                var textDiv = $('<h1></h1>').html(ctxOdj.fullname)
                        .prepend($('<div />')
                                .append($('<i />').addClass('icon').addClass('icon-download'))
                                .css({
                                    float: 'left',
                                    'margin-left': '15px'
                                })
                                .addClass('btn')
                                .addClass('btn-warning')
                                .attr('id', 'dlAllDocs')
                                .attr('title', 'Charger tous les documents')
                                .bind('click', function() {
                                    appUI.engine.loadSeanceImages(appUI.accounts.get(appUI.user.account_id), appUI.seance_to_read, appUI.engine.getSocket(appUI.user.account_id));
                                }))
                        .prepend($('<div />')
                                .append($('<i />').addClass('icon').addClass('icon-caret-left'))
                                .append(' ')
                                .append($('<i />').addClass('icon').addClass('icon-group'))
                                .css({
                                    float: 'left'
                                })
                                .addClass('btn')
                                .addClass('btn-inverse')
                                .bind('click', function() {
                                    appUI.set('convocation');
                                }))
                        ;
                appUI.content.append(textDiv);

                var odj = $('<ol />').attr('id', 'ODJ').css('margin-top', '50px');
                appUI.content.append(odj);

                //  Récupération des séances et des annotations de l'utilisateur courant.
                var dataSeances = appUI.storage.core.get('seances');
                var dataAnnotations = appUI.storage.core.get('annotations');

                //  On compte les annotations privées, partagées et non lues pour les afficher dans des notifications
                for (var itS in dataSeances) {
                    var seance = dataSeances[itS];

                    if (seance.Seance.id === appUI.seance_to_read) {

                        for (var itP in seance.Projet) {

                            //  Comptage des annotations privées
                            var countPrivateAnnotations = 0;

                            for (var itCPA = 0, lnCPA = dataAnnotations.length; itCPA < lnCPA; itCPA++) {
                                var annotation = dataAnnotations[itCPA];

                                if (annotation.document_id === seance.Projet[itP].document_id) {
                                    if (!annotation.type) { //type : true = shared, false = private
                                        countPrivateAnnotations++;
                                    }
                                }
                            }

                            //  Comptage des annotations partagées
                            var countSharedAnnotations = 0;

                            for (var itCSA = 0, lnCSA = dataAnnotations.length; itCSA < lnCSA; itCSA++) {
                                var annotation = dataAnnotations[itCSA];
                                if (annotation.document_id === seance.Projet[itP].document_id) {
                                    if (annotation.type && annotation.id_utilisateur === appUI.accounts.get(appUI.user.account_id).userId) { //type : true = shared, false = private
                                        countSharedAnnotations++;
                                    }
                                }
                            }

                            //  Comptage des annotations partagées non lues
                            var countUnreadSharedAnnotations = 0;

                            for (var itUCSA = 0, lnUCSA = dataAnnotations.length; itUCSA < lnUCSA; itUCSA++) {
                                var annotation = dataAnnotations[itUCSA];
                                if (annotation.document_id === seance.Projet[itP].document_id) {
                                    if (annotation.type && annotation.id_utilisateur !== appUI.accounts.get(appUI.user.account_id).userId && !annotation.lue) { //type : true = shared, false = private
                                        countUnreadSharedAnnotations++;
                                    }
                                }
                            }

                            var loadProgressData = appUI.imgLoaded.getProjetStatus(seance.Seance.id, seance.Projet[itP].id, appUI.user.account_id);
                            var loadProgress = $('<span />')
                                    .css({
//                                        float: 'right',
//                                        'margin-left': '3px'
                                        'position': 'absolute',
                                        bottom: '3px',
                                        right: '60px'
                                    })
                                    .addClass('loadProgress')
                                    .append($('<span />').addClass('info')
                                            .append($('<span />').addClass('percent').html(loadProgressData.percent))
                                            .append($('<span />').html(' %'))
                                            .append($('<span />').html(' ('))
                                            .append($('<span />').addClass('loaded').html(loadProgressData.loaded))
                                            .append($('<span />').html('/'))
                                            .append($('<span />').addClass('total').html(loadProgressData.total))
                                            .append($('<span />').html(') '))
                                            .append($('<i />').addClass('icon').addClass('icon-download'))
                                            );


                            var itemAction = $('<span />').addClass('itemAction').append(' ').append($('<i />').addClass('icon').addClass('icon-ok'));

                            if (loadProgressData.loaded === 0) {
//                                $('.info', loadProgress).removeClass('full').removeClass('active').addClass('empty');
                                $(itemAction).removeClass('full').removeClass('active').addClass('empty');
                                $('.icon', itemAction).removeClass('icon-ok').addClass('icon-download');

                            } else if (loadProgressData.loaded === loadProgressData.total) {
//                                $('.info', loadProgress).removeClass('empty').removeClass('active').addClass('full');
                                $(itemAction).removeClass('empty').removeClass('active').addClass('full');
                                $('.icon', itemAction).removeClass('icon-download').addClass('icon-ok');
                            }


                            //  Affichage des notifications.
                            var projet = $('<li />')
                                    .addClass('projet')
                                    .addClass('item')
                                    .attr('id', seance.Projet[itP].id + 'Projet')
                                    .attr('projetId', seance.Projet[itP].id)
                                    .attr('documentId', seance.Projet[itP].document_id)
                                    .attr('action', (loadProgressData.loaded === loadProgressData.total) ? 'doc' : 'download')
                                    .bind('click', function() {
                                        if ($(this).attr('action') === 'download') {
                                            appUI.engine.loadProjetImages(appUI.accounts.get(appUI.user.account_id), appUI.seance_to_read, $(this).attr('projetId'), appUI.engine.getSocket(appUI.user.account_id));
                                        } else if ($(this).attr('action') === 'doc') {
                                            appUI.action.uuid = $(this).attr('documentId');
                                            appUI.set('document');
                                        }
                                    })

                                    .append($('<span />')
                                            .attr('title', 'annotations partagées')
                                            .addClass('shared')
                                            .addClass('badge')
                                            .addClass('badge-success')
                                            .append($('<i />').addClass('icon').addClass('icon-comments'))
                                            .append(' ')
                                            .append(countSharedAnnotations)
                                            .css('visibility', countSharedAnnotations > 0 ? 'visible' : 'hidden'))
                                    .append($('<span />')
                                            .attr('title', 'annotations privées')
                                            .addClass('private')
                                            .addClass('badge')
                                            .addClass('badge-info')
                                            .append($('<i />').addClass('icon').addClass('icon-comment'))
                                            .append(' ')
                                            .append(countPrivateAnnotations)
                                            .addClass('countPrivateAnnotations')
                                            .css('visibility', countPrivateAnnotations > 0 ? 'visible' : 'hidden'))
                                    .append($('<span />').addClass('title').html(seance.Projet[itP].name).prepend(' ').prepend(itemAction));

                            var themes = seance.Projet[itP].theme.split(',');
                            for (var t in themes) {
                                projet.prepend($('<span></span>').addClass('theme').addClass('pull-right').addClass('label').addClass('label-info').html(themes[t]));
                            }

                            projet.prepend(loadProgress)
                                    .prepend($('<span />')
                                            .attr('title', 'annotations non lues')
                                            .addClass('unread')
                                            .addClass('pull-right')
                                            .addClass('badge')
                                            .addClass('badge-warning')
                                            .append($('<i />').addClass('icon').addClass('icon-comments'))
                                            .append(' ')
                                            .append(countUnreadSharedAnnotations)
                                            .css('visibility', countUnreadSharedAnnotations > 0 ? 'visible' : 'hidden'));
                            $('#ODJ').append(projet);

                            //  ajout de l'icone de telechargement du document
                            if ((appUI.engine.getCurrentSocket() !== null) && appUI.engine.getCurrentSocket().socket.connected) {


                                projet.css('width', '90%').append(
                                        $('<div />')
                                        .attr('fileid', seance.Projet[itP].document_id)
                                        .addClass('dldoc')
                                        .addClass('dl')
                                        .addClass('alert')
                                        .addClass('alert-info')
                                        .append($('<i />').addClass('icon').addClass('icon-download').addClass('icon-3x'))
//                                        .append(' Téléchargement')
                                        .bind('click', function(e) {
                                            e.stopPropagation();

                                            if (appUI.engine.getCurrentSocket().socket.connected) {
                                                var form = $('<form />')
                                                        .css('display', 'none')
                                                        .attr('target', appUI.cordova ? '_system' : '_blank')
                                                        .attr('method', 'post')
                                                        .attr('action', (appUI.cordova ? 'https://' : '') + appUI.accounts.get(appUI.user.account_id).server_url + '/Documents/getFile/' + $(this).attr('fileid'))
                                                        .append($('<input />').attr('type', 'text').attr('name', 'data[User][login]').val(appUI.accounts.get(appUI.user.account_id).login))
                                                        .append($('<input />').attr('type', 'password').attr('name', 'data[User][password]').val(appUI.accounts.get(appUI.user.account_id).password))
                                                        .appendTo($('body'));
                                                if (appUI.cordova) {
                                                    window.open(form.attr('action') + '?' + form.serialize(), '_system');
                                                } else {
                                                    form.submit();
                                                }

                                                $(form).remove();
                                            } else {
                                                $('#fileDlModal').modal('show');
                                            }
                                        })

                                        );

                            }

                            //  affichage des annexes
                            if (seance.Projet[itP].Annex.length > 0) {
                                var idProjet = seance.Projet[itP].id + 'Projet';
                                var id = seance.Projet[itP].id;
                                var openBtn = $('<div />')
                                        .addClass('openBtn')
                                        .append($('<i />').addClass('icon').addClass('icon-file'))
                                        .append(' Annexes');
                                var annexesList = $('<ul />')
                                        .addClass('annexes-list');
                                for (var iA = 0, lnA = seance.Projet[itP].Annex.length; iA < lnA; iA++) {
                                    var li = $('<li />').append(
                                            $('<div />')
                                            .attr('fileid', seance.Projet[itP].Annex[iA].id)
                                            .addClass('dl')
                                            .addClass('alert')
                                            .addClass('alert-info')
                                            .append($('<i />').addClass('icon').addClass('icon-download'))
                                            .append(' ' + seance.Projet[itP].Annex[iA].name)
                                            .bind('click', function() {
                                               if ((appUI.engine.getCurrentSocket() !== null) && appUI.engine.getCurrentSocket().socket.connected) {
                                                    var form = $('<form />')
                                                            .css('display', 'none')
//                                                            .attr('target', '_blank')
                                                            .attr('target', appUI.cordova ? '_system' : '_blank')
                                                            .attr('method', 'post')
                                                            .attr('action', (appUI.cordova ? 'https://' : '') + appUI.accounts.get(appUI.user.account_id).server_url + '/Annexes/getFile/' + $(this).attr('fileid'))
                                                            .append($('<input />').attr('type', 'text').attr('name', 'data[User][login]').val(appUI.accounts.get(appUI.user.account_id).login))
                                                            .append($('<input />').attr('type', 'password').attr('name', 'data[User][password]').val(appUI.accounts.get(appUI.user.account_id).password))
                                                            .appendTo($('body'));
                                                    if (appUI.cordova) {
                                                        window.open(form.attr('action') + '?' + form.serialize(), '_system');
                                                    } else {
                                                        form.submit();
                                                    }

                                                    $(form).remove();
                                                } else {
                                                    $('#fileDlModal').modal('show');
                                                }
                                            })
                                            );
                                    $(annexesList).append(li);
                                }

                                var annexes = $('<div />')
                                        .addClass('annexes-container')
                                        .attr('id', id + 'Annexes')
                                        .append(annexesList)
                                        .append(openBtn);
                                $('#' + idProjet).after(annexes).addClass('with-annexes');
                                $('#' + id + 'Annexes .openBtn').bind('click', function() {
                                    $('.annexes-list', $(this).parent()).slideToggle('fast');
                                });
                            }
                        }

                        var loadProgressODJ = appUI.imgLoaded.getProjetsStatus(seance.Seance.id, appUI.user.account_id);
                        if (loadProgressODJ.total === loadProgressODJ.loaded) {
                            $('#dlAllDocs').removeClass('btn-warning');
                        } else {
                            $('#dlAllDocs').addClass('btn-warning');
                        }

                    }
                }
            }
        }
    },
    /**
     *  @function refreshData
     *  @param {String} type
     *  @param {JSObject} account
     *  @param {JSObject} data
     *  @description Rafraîchit le contexte courant
     **/
    refreshData: function(type, account, data) {

        if (type === "annotations") {
            //  rafraichissement des badges lors de la synchro de toutes les annotations (connexion, ajout de compte, ...)
            var dataSeances = appUI.storage.core.get('seances');
            var dataAnnotations = appUI.storage.core.get('annotations');

            for (var itS in dataSeances) {
                var seance = dataSeances[itS];

                if (seance.Seance.id === appUI.seance_to_read) {
                    for (var itP in seance.Projet) {

                        //  Recomptage des annotations privées
                        var countPrivateAnnotations = 0;

                        for (var itCPA = 0, lnCPA = dataAnnotations.length; itCPA < lnCPA; itCPA++) {
                            var annotation = dataAnnotations[itCPA];

                            if (annotation.document_id === seance.Projet[itP].document_id) {
                                if (!annotation.type) {
                                    //type : true = shared, false = private
                                    countPrivateAnnotations++;
                                }
                            }
                        }

                        //  Réactulisation du badge comptant les annotations privées
                        $('#' + seance.Projet[itP].id + 'Projet .countPrivateAnnotations').empty().append($('<i />').addClass('icon').addClass('icon-comment'))
                                .append(' ')
                                .append(countPrivateAnnotations)
                                .css('visibility' + countPrivateAnnotations > 0 ? 'visible' : 'hidden');

                        //  Recomptage des annotations partagées
                        var countSharedAnnotations = 0;

                        for (var itCSA = 0, lnCSA = dataAnnotations.length; itCSA < lnCSA; itCSA++) {
                            var annotation = dataAnnotations[itCSA];
                            if (annotation.document_id === seance.Projet[itP].document_id) {
                                if (annotation.type && annotation.id_utilisateur === appUI.accounts.get(appUI.user.account_id).userId) {
                                    //type : true = shared, false = private
                                    countSharedAnnotations++;
                                }
                            }
                        }

                        //  Réactulisation du badge comptant les annotations partagées
                        $('#' + seance.Projet[itP].id + 'Projet .countSharedAnnotations').empty().append($('<i />').addClass('icon').addClass('icon-comments'))
                                .append(' ')
                                .append(countSharedAnnotations)
                                .css('visibility' + countSharedAnnotations > 0 ? 'visible' : 'hidden');

                        //  Recomptage des annotations partagées non lues
                        var countUnreadSharedAnnotations = 0;

                        for (var itUCSA = 0, lnUCSA = dataAnnotations.length; itUCSA < lnUCSA; itUCSA++) {
                            var annotation = dataAnnotations[itUCSA];
                            if (annotation.document_id === seance.Projet[itP].document_id) {
                                if (annotation.type && annotation.id_utilisateur !== appUI.accounts.get(appUI.user.account_id).userId && !annotation.lue) {
                                    //type : true = shared, false = private
                                    countUnreadSharedAnnotations++;
                                }
                            }
                        }

                        //  Réactualisation du badge comptant les annotations partagées non lues
                        $('#' + seance.Projet[itP].id + 'Projet .countUnreadSharedAnnotations').empty().append($('<i />').addClass('icon').addClass('icon-comments'))
                                .append(' ')
                                .append(countUnreadSharedAnnotations)
                                .css('visibility' + countUnreadSharedAnnotations > 0 ? 'visible' : 'hidden');
                    }
                }
            }
        } else if (type === "annotation") {
            //  TODO : Rafraichissement des badges lors de la reception d une annotation



        } else if (type === "loadProgress") {
            var dataSeances = appUI.storage.core.get('seances');
            for (var itS in dataSeances) {
                var seance = dataSeances[itS];
                if (seance.Seance.id === appUI.seance_to_read) {
                    for (var itP in seance.Projet) {
                        var loadProgressData = appUI.imgLoaded.getProjetStatus(seance.Seance.id, seance.Projet[itP].id, account.id);
                        if (loadProgressData.loaded === 0) {
//                            $('#' + seance.Projet[itP].id + 'Projet .loadProgress .info').removeClass('full').removeClass('active').addClass('empty');
                            $('#' + seance.Projet[itP].id + 'Projet .itemAction').removeClass('full').removeClass('active').addClass('empty');
                            $('#' + seance.Projet[itP].id + 'Projet .itemAction .icon').removeClass('icon-file').addClass('icon-download');
                            $('#' + seance.Projet[itP].id + 'Projet').attr('action', 'download');
                        } else if (loadProgressData.loaded === loadProgressData.total) {
//                            $('#' + seance.Projet[itP].id + 'Projet .loadProgress .info').removeClass('empty').removeClass('active').addClass('full');
                            $('#' + seance.Projet[itP].id + 'Projet .itemAction').removeClass('empty').removeClass('active').addClass('full');
                            $('#' + seance.Projet[itP].id + 'Projet .itemAction .icon').removeClass('icon-download').addClass('icon-ok');
                            $('#' + seance.Projet[itP].id + 'Projet').attr('action', 'doc');
                        } else if (loadProgressData.loaded > parseInt($('#' + seance.Projet[itP].id + 'Projet .loadProgress .loaded').html())) {
//                            $('#' + seance.Projet[itP].id + 'Projet .loadProgress .info').removeClass('full').removeClass('empty').addClass('active');

//                            if (!$('#' + seance.Projet[itP].id + 'Projet .itemAction').hasClass('active')) {
                            $('#' + seance.Projet[itP].id + 'Projet .itemAction').removeClass('full').removeClass('empty').toggleClass('active');
//                            }

                        }

                        $('#' + seance.Projet[itP].id + 'Projet .loadProgress .loaded').html(loadProgressData.loaded);
                        $('#' + seance.Projet[itP].id + 'Projet .loadProgress .percent').html(loadProgressData.percent);
                    }

                    var loadProgressODJ = appUI.imgLoaded.getProjetsStatus(seance.Seance.id, appUI.user.account_id);
                    if (loadProgressODJ.total === loadProgressODJ.loaded) {
                        $('#dlAllDocs').removeClass('btn-warning');
                    } else {
                        $('#dlAllDocs').addClass('btn-warning');
                    }
                }
            }
        }
    }
});
