/**
 *
 * webroot/idelibre_client/assets/js/appUI/contextes/ctx_params.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/contexts/ctx_params.js $
 * $Id: ctx_params.js 537 2014-07-29 12:45:51Z genot $
 */

/**
 * Params context singleton
 */

var ctxParams = $.extend(true, {}, new appContext(), {
    name: 'params',
    fullname: 'Param&egrave;tres',
    cssCenter: {
        left: '150px',
        display: 'block'
    },
    cssLeft: {
        left: -window.innerWidth * 2,
        display: 'none'
    },
    cssRight: {
        left: window.innerWidth * 2,
        display: 'none'
    },
    cssBtnsCenter: {
        width: '75%',
        left: '150px',
        position: 'absolute',
        display: 'block'
    },
    cssAccount: {
        position: 'absolute',
        width: '75%',
        display: 'block'
    },
    cssBtn: {
        'margin': '15px',
        'width': "150px",
        'height': "150px",
        'cursor': 'pointer',
        'border': '1px solid #ccc',
        'border-radius': '15px',
        'box-shadow': '0 0 7px #ccc',
        'padding': '15px'
    },
    /**
     *  @function setFormEvents
     *  @description Gestion du formulaire de connexion
     *  @returns {Void}
     **/
    setFormEvents: function() {

        /**
         *  @function submitLogin
         *  @description Gestion des sockets et des certificats
         *
         **/
        var submitLogin = function() {
            if (!appUI.accounts.login.isEmpty()) {
                var url = 'https://' + appUI.accounts.login.item.server_url;
                appUI.engine.purgeSockets();

                if (appUI.cordova && typeof device !== 'undefined' && (device.platform === "Android" || device.platform === "iOS")) {
                    //if (appUI.cordova && typeof device !== 'undefined' && device.platform === "Android") {
                    //                appUI.accountsCert.put(appUI.accounts.items[i].id, 'certificat non valide');

                    //android
                    window.plugins.sslCertificateChecker.check(function(message) {
                      //  console.log('sslCertificateChecker call');
                      //  console.log(url);
                        var socket = io.connect(url, {'force new connection': true});
                        appUI.contexts.params.getLoginInfo(socket, appUI.accounts.login.item.server_url );

                        appUI.cordovaCertSuccessCallback(message);
                    }, appUI.cordovaCertErrorCallback, url);

                    //} else if (appUI.cordova && typeof device !== 'undefined' && device.platform === "iOS") {
                    //iOS
                } else if (!appUI.cordova) {
                    //web app
                    var socket = io.connect(url, {'force new connection': true});
                    appUI.contexts.params.getLoginInfo(socket, appUI.accounts.login.item.server_url);
                }
            }
        };


        /**
         * Bouton submit
         */
        $('#actionLogin').click(function() {
            if (!$(this).hasClass('disabled')) {
                if (($("#inputLogin").val() !== '' && $("#inputPassword").val() !== '') || ($("#inputLogin").val() !== '' && $("#inputPassword").val() !== '')) {
                    if (appUI.cordova && $("#inputServerUrl").length > 0) {
                        $("#inputServerUrl").val($("#inputServerUrl").val().replace('https://', '').replace('http://', ''));
                    }
                    appUI.contexts.params.saveLoginData();
                    submitLogin();
                } else {
                    var msg = 'Veuilez renseigner les champs suivants : Indentifiant, Mot de passe';
                    appUI.notify(msg, 1);
                    $('#inputLogin').focus();
                }
            }
        });

        $('#actionClear').click(function() {
            $(this).parents('form')[0].reset();
            appUI.accounts.login.item = {};
            appUI.accounts.login.store();
        });

        $('#actionReload').click(function() {
            window.location.reload();
        });
    },
    /**
     *  @function getLoginInfo
     *  @param {JSObject} socket
     *  @param {String} url
     *  @description Récupération de l'ensemble des mandats
     *  @returns {Void}
     **/
    getLoginInfo: function(socket, url) {
        appUI.engine.ico.emit();
	appUI.notify('vérification des identifiants');
        socket.on('connect', function(data) {
         //   console.log('connected');
            appUI.engine.ico.emit();
            //  Demande d'authentification du super-client

            socket.emit('global auth', appUI.accounts.login.item);
        });

        //  Réception des données du super-client
        socket.on('global auth feedback', function(data) {
            if (typeof data.accounts !== 'undefined') {
               var welcome = "Bienvenue " + appUI.accounts.login.item.login ;
            //    console.log(welcome);
                appUI.notify(welcome);
                //  purge des comptes existants
                appUI.accounts.deleteAll();
                
                
                
                
                for (var i = 0, ln = data.accounts.length; i < ln; i++) {
                    var account_id = appUI.accounts.add();
                    appUI.accounts.save(account_id, {
                        label: typeof data.accounts[i].User.label !== 'undefined' && data.accounts[i].User.label !== '' ? data.accounts[i].User.label : '',
                        login: data.accounts[i].User.login,
                        password: data.accounts[i].User.password,
                        server_url: url  //appui.account......
                    });
                }
            }

            appUI.engine.ico.on();
            socket.disconnect();
        });

        socket.on('logout', function(data) {
            console.log('logout')
            appUI.notify('Erreur identifiant / mot de passe');
            appUI.engine.ico.on();
            socket.disconnect();
        });

        socket.on('error login', function(data) {
            appUI.accounts.deleteAll();
          //  console.log('error login');
            appUI.engine.ico.on();
            appUI.notify('Erreur identifiant / mot de passe');
            socket.disconnect();
        });


    },
    /**
     *  @function loadLoginData
     *  @param {String} login
     *  @description Chargement des informations du super-client dans les champs concernés du formulaire de connexion
     *  @returns {Void}
     **/
    loadLoginData: function(login) {
        if (typeof login !== "undefined") {
            $('#inputLogin').val(login.login);
            $('#inputPassword').val(login.password);
            /*
             * Correction de l'url enregistrée
             */
            if (appUI.cordova && $("#inputServerUrl").length > 0 && typeof login.server_url !== "undefined" && login.server_url !== null) {
                $("#inputServerUrl").val(login.server_url.replace('https://', '').replace('http://', ''));
            }
        }
    },
    /**
     *  @function getLoginInfo
     *  @description Sauvegarde des champs d'informations du formulaire de connexion du super-client
     *  @returns {Void}
     **/
    saveLoginData: function() {
        appUI.accounts.login.save({
            login: $('#inputLogin').val(),
            password: $('#inputPassword').val(),
            server_url: typeof $('#inputServerUrl').val() !== "undefined" ? $('#inputServerUrl').val() : ''
        });
    },
    /**
     *  @function clearAccountData
     *  @description Remise à zéro des champs d'informations du formulaire de connexion du super-client
     *  @returns {Void}
     **/
    clearAccountData: function() {
        $('#accountFormLabel').html();
        $('#inputLogin').val();
        $('#inputPassword').val();
        $('#inputServerUrl').val();
    },
    /**
     *  @function loadAccountData
     *  @param {JSObject} account
     *  @description Chargement des données de "account" dans les champs du formulaire de connexion prévus à cet effet
     *  @returns {Void}
     **/
    loadAccountData: function(account) {
        if (typeof account !== "undefined") {
            $('#inputLabel').val(account.label);
            $('#inputLogin').val(account.login);
            $('#inputPassword').val(account.password);
            /*
             * Correction de l'url enregistrée
             */
            if (appUI.cordova && $("#inputServerUrl").length > 0 && typeof account.server_url !== "undefined" && account.server_url !== null) {
                $("#inputServerUrl").val(account.server_url.replace('https://', '').replace('http://', ''));
            }
        }
    },
    /**
     *  @function saveAccountData
     *  @param {String} id
     *  @description Sauvegarde des champs d'informations du formulaire de connexion dans le compte correspondant à "id"
     *  @returns {Void}
     **/
    saveAccountData: function(id) {
        appUI.accounts.save(id, {
            label: $('#inputLabel').val(),
            login: $('#inputLogin').val(),
            password: $('#inputPassword').val(),
            server_url: typeof $('#inputServerUrl').val() !== "undefined" ? $('#inputServerUrl').val() : ''
        });
    },
    /**
     *  @function initForm
     *  @description Initialisation du formulaire de connexion
     *  @returns {Void}
     **/
    initForm: function() {
        /**
         * confirmation de suppression
         */
        $('#confirmDeleteAccount').remove();
        var deleteAccountModal = $('<div></div>').attr('id', 'confirmDeleteAccount').addClass('modal').addClass('hide')
                .append($('<div></div>').addClass('modal-header')
                        .append($('<button></button>').addClass('close').attr('data-dismiss', 'modal').attr('aria-hidden', 'true').html("&times;"))
                        .append($('<h3></h3>').html("Suppression de mandat")))
                .append($('<div></div>').addClass('modal-body')
                        .append($('<p></p>').html('Etes-vous sûr(e) de vouloir supprimer ce mandat ?')))
                .append($('<div></div>').addClass('modal-footer')
                        .append($('<a></a>').attr('id', 'confirmDeleteAccount' + 'BtnOk').attr('href', '#').addClass('btn').html('Supprimer').click(function() {
                            //suppression du compte en cours d'utilisation
                            appUI.accounts.delete(appUI.accounts.current_item_id);
                            //reinit current account id
                            $('#confirmDeleteAccount').modal('hide');
                            appUI.contexts.params.gotoBtns();
                        }))
                        .append($('<a></a>').attr('id', 'confirmDeleteAccount' + 'BtnNo').attr('href', '#').addClass('btn').html('Annuler').attr('data-dismiss', 'modal').attr('aria-hidden', 'true'))
                        );
        appUI.content.append(deleteAccountModal);
    },
    /**
     *  @function genField
     *  @param {JSObject} options
     *  @description Génération des champs du formulaire de connexion
     *  @returns {Void}
     **/
    genField: function(options) {
        var settings = $.extend({}, {
            id: '',
            label: '',
            type: '',
            css: '',
            placeholder: '',
            required: false
        }, options);

        var input;
        var mdplost;
        var prepend;

        if (settings.type === '' || settings.type === 'text') {
            input = $('<input />').attr('type', 'text').attr('placeholder', settings.placeholder);
        } else if (settings.type === 'https') {
            input = $('<input />').attr('type', 'text').addClass('span2').attr('placeholder', settings.placeholder);
            prepend = $('<span />').addClass('add-on').html('https://');
        } else if (settings.type === 'checkbox') {
            input = $('<input />').attr('type', 'checkbox');
        } else if (settings.type === 'textarea') {
            input = $('<textarea></textarea>').css(settings.css)
        } else if (settings.type === 'file') {
            input = $('<input />').attr('type', 'file');
        } else if (settings.type === 'password') {
            input = $('<input />').attr('type', 'password').attr('placeholder', settings.placeholder);
            if (appUI.online) {
                mdplost = $('<a></a>').attr('href', '/Srvusers/mdplost/client').html('Mot de passe oublié ?').css('margin-left', '15px');
            }
        }

        $(input).attr('id', settings.id);

        if (settings.required) {
            $(input).attr('required', 'required');
        }

        return $('<div></div>').addClass('control-group').addClass(settings.type === "https" ? 'input-prepend' : '')
                .append($('<label></label>').addClass('control-label').attr('for', settings.id).html(settings.label))
                .append($('<div></div>').addClass('controls').append(prepend).append(input).append(mdplost));
    },
    /**
     *  @function genForm
     *  @description Génération du formulaire de connexion
     *  @returns {Void}
     **/
    genForm: function() {
        //
        // Groupe de contrôle : Identification
        //

        //login
        var controlGroupLogin = this.genField({
            id: 'inputLogin',
            label: 'Identifiant',
            type: 'text',
            required: true
        });

        //password
        var controlGroupPassword = this.genField({
            id: 'inputPassword',
            label: 'Mot de passe',
            type: 'password',
            required: true
        });

        //server
        var controlGroupServer = this.genField({
            id: 'inputServerUrl',
            label: 'URL du serveur',
            type: 'https',
            required: true
        });

        //
        // Groupe de contrôle : Bouton submit
        //
        var submitButton = $('<button></button>')
                .attr('type', 'button')
                .addClass('btn')
                .addClass('btn-inverse')
                .attr('id', 'actionLogin')
                .append($('<i></i>').addClass('icon-hdd').addClass('icon-white'))
                .append(' Enregistrer');

        var clearButton = '';
        if (appUI.debugMode) {
            clearButton = $('<button></button>')
                    .attr('type', 'button')
                    .addClass('btn')
                    .addClass('btn-danger')
                    .attr('id', 'actionClear')
                    .append($('<i></i>').addClass('icon-trash').addClass('icon-white'))
                    .append(' Remise à zéro');
        }

        var reloadBtn = $('<button></button>')
                .attr('type', 'button')
                .addClass('btn')
                .addClass('btn-info')
                .attr('id', 'actionReload')
                .append($('<i></i>').addClass('icon-refresh').addClass('icon-white'))
                .append(' Recharger');

        var controlGroupSubmit = $('<div></div>')
                .addClass('control-group')
                .append($('<div></div>').addClass('controls').addClass('btn-group').append(clearButton).append(submitButton).append(reloadBtn));

        /**
         * Form
         */
        var form = $('<form></form>').attr('id', 'form').addClass('collapse').addClass('in').css({
            'margin-top': '25px',
            'margin-left': '150px'
        }).addClass('form-horizontal')
                .append(controlGroupLogin)
                .append(controlGroupPassword)
                .append($('<hr />'));
        if (appUI.cordova) {
            form.append(controlGroupServer);
        }
        form.append(controlGroupSubmit);

        /**
         * Account
         */
        var account = $('<div></div>').attr('id', 'accountForm').addClass('account')
                .append($('<h1></h1>')
                        .append(' ')
                        .append($('<i></i>').addClass('icon-key'))
                        .append(' ')
                        .append($('<span></span>').attr('id', 'accountFormLabel').html('Informations de connexion')))
                .append(form)
                .css(appUI.contexts.params.cssAccount);

        return account;
    },
    /**
     *  @function gotoBtns
     *  @description
     *  @returns {Void}
     **/
    gotoBtns: function() {
        $("#accountForm").animate(appUI.contexts.params.cssRight, 100, function() {

            $("#accountForm").css('display', 'none');
            $("#accountBnts").css('display', 'block');

            $('#accountBtns').animate(appUI.contexts.params.cssBtnsCenter, 100);
            appUI.accounts.current_item_id = null;
            appUI.contexts.params.draw();
        });
    },
    /**
     *  @function genBtn
     *  @param {JSObject} options
     *  @description
     *  @returns {Void}
     **/
    genBtn: function(options) {
        var btn = $('<div></div>')
                .addClass('btn')
                .addClass('btn-huge')
                .css({overflow: 'hidden', '-o-text-overflow': 'ellipsis', 'text-overflow': 'ellipsis'})
                .addClass('btn-account')
                .attr('id', options.id + 'Btn')
                .attr('data', options.id)
                .html($('<div />').html(options.label).css('margin-top', '55px'))
                .prepend($('<i></i>').css('float', 'left').addClass('icon-check').addClass('validAccountIco'))
                .bind('click', function() {
                    //animation des boutons vers l exterieur gauche
                    $("#accountBtns").animate(appUI.contexts.params.cssLeft, 100, function() {
                        $("#accountBtns").css('display', 'none');
                        $("#accountForm").css('display', 'block');
                        //animation du formulaire vers le centre
                        $('#accountForm').animate(appUI.contexts.params.cssCenter, 100);
                        //definition du compte en cours d'utilisation
                        appUI.accounts.current_item_id = options.id;
                        //chargement des informations du compte
                        appUI.contexts.params.loadAccountData(appUI.accounts.get(appUI.accounts.current_item_id));
                    });
                });

        if (options.firstTime) {
            $('.validAccountIco', btn).removeClass('icon-check').addClass('icon-check-empty');
            btn.css('font-weight', 'bold');
        }
        return btn;
    },
    /**
     *  @function genBtns
     *  @param {JSObject} options
     *  @description
     *  @returns {Void}
     **/
    genBtns: function(options) {
        var btns = $('<div></div>').attr('id', 'accountBtns');
        btns.append($('<h1></h1>').html('Liste des mandats'));

        if (typeof appUI.accounts.items === "undefined" || appUI.accounts.items === null || appUI.accounts.items.length === 0) {
            btns.append($('<div />').addClass('alert').addClass('alert-info').html('Aucun mandat d&eacute;fini.'));
        } else {
            for (var i in options) {
                btns.append($('<div />').addClass('selectableListItem').append(appUI.contexts.params.genBtn(options[i])));
            }
        }

        var addAccountBtn = $('<div></div>')
                .css({
                    display: 'block',
                    'margin-top': '25px',
                    width: '150px'
                })
                .addClass('btn')
                .addClass('btn-inverse')
                .attr('id', 'addAccountBtn')
                .append($('<i></i>').addClass('icon').addClass('icon-white').addClass('icon-plus-sign'))
                .append(' ')
                .append($('<i></i>').addClass('icon-user').addClass('icon-white'))
                .append(' Ajouter un mandat')
                .click(function() {
                    appUI.accounts.add();
                    appUI.contexts.params.draw();
                });


        return btns.append($('<hr />')).append(addAccountBtn);
    },
    /**
     *  @function draw
     *  @description Génération du contexte avec formulaire de connexion et boutons
     *  @returns {Void}
     **/
    draw: function() {
        //        if (appUI.accounts.login.isEmpty()) {
        appUI.content.append(appUI.contexts.params.genForm());
        //remplissage avec les valeurs en localStorage
        appUI.accounts.login.restore();

        if (appUI.accounts.login.item !== null && appUI.accounts.login.item.login !== "" && appUI.accounts.login.item.password !== "") {
            appUI.contexts.params.loadLoginData(appUI.accounts.login.item);
        }

        appUI.contexts.params.setFormEvents();
        //        }

        //        appUI.content.empty();
        //        appUI.content.append(appUI.contexts.params.genBtns(appUI.accounts.items));
        //        appUI.content.append(appUI.contexts.params.genForm());
        //        appUI.contexts.params.setFormEvents();
        //        appUI.contexts.params.initForm(appUI.accounts.get(appUI.accounts.current_item_id));
        //        appUI.accounts.menu.draw();
    },
    /**
     *
     */
    document: {
        content: {
            url: 'params.js',
            process: function() {
                //                $('body').css('overflow', 'hidden');
                appUI.accounts.restore();
                appUI.contexts.params.draw();
            }
        }
    },
    /**
     *  @function refreshData
     *  @param {String} type
     *  @param {JSObject} account
     *  @param {JSObject} data
     *  @description Rafraîchit le contexte courant
     **/
    refreshData: function(type, account, data) {

    }
});
