/**
 *
 * webroot/idelibre_client/assets/js/appUI/contextes/ctx_home.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 17:54:55 +0200 (mar. 29 juil. 2014) $
 * $Revision: 541 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/contexts/ctx_seances.js $
 * $Id: ctx_seances.js 541 2014-07-29 15:54:55Z genot $
 */

/**
 * Home context singleton
 * 
 */





var ctxSeances = $.extend(true, {}, new appContext(), {
    name: 'seances',
    fullname: 'S&eacute;ances planifi&eacute;es',
    document: {
        content: {
            url: 'seances.js',
            process: function() {
                appUI.content.empty();
                //  Message de bienvenue
                var textDiv = $('<h1></h1>').html(ctxSeances.fullname)
                        .prepend($('<div />')
                                .append($('<i />').addClass('icon').addClass('icon-caret-left'))
                                .append(' ')
                                .append($('<i />').addClass('icon').addClass('icon-home'))
                                .css('float', 'left')
                                .addClass('btn')
                                .addClass('btn-inverse')
                                .bind('click', function() {
                                    appUI.set('home');
                                }));
                appUI.content.append(textDiv);

                //  Récupération des séances et des annotations de l'utilisateur courant.
                var dataSeances = appUI.storage.core.get('seances');
                var dataAnnotations = appUI.storage.core.get("annotations");
                var dataModified = appUI.storage.core.get("modifiedSeances");

                



                if (typeof dataModified === "undefined" || dataModified === null) {
                    dataModified = [];
                }


                //  Affichage de la liste des séances, création des notifications affichant les séances non lues et les annotations non lues.
                var seances = $('<div />');
                if (dataSeances === null || dataSeances.length === 0) {
                    seances.append($('<div />').addClass('alert').addClass('alert-info').html('Aucune s&eacute;ance planifi&eacute;e.'));
                } else {
                    //  Création des boutons propres à chaque séance.
                    for (var i = 0, ln = dataSeances.length; i < ln; i++) {
                        var account = appUI.accounts.get(appUI.user.account_id);

                        var dataSeance = dataSeances[i];


                        var dataConvocation;
                        for (var iC = 0, lnC = dataSeance.Convocation.length; iC < lnC; iC++) {
                            if (dataSeance.Convocation[iC].user_id === account.userId) {
                                dataConvocation = dataSeance.Convocation[iC];
                            }
                        }

                        // style du texte dans le bouton
                        var weight = "normal";
                        if (in_array(dataSeance.Seance.id, dataModified)) {
                            weight = "bold";
                        }

                        if (!dataConvocation.read) {
                            weight = "bold";
                        }


                        var seance = $('<div />')
                                .addClass('selectableListItem')

                                .css('font-weight', weight);
                        var labelContent = dataSeance.Seance.name;

                        var label = $('<br><div />')
                                .css({
                                    'font-weight': 'bolder',
                                    'text-overflow': 'ellipsis',
                                    'overflow': 'hidden',
                                    'white-space': 'nowrap'
                                })
                                .append(' ' + labelContent);

                        var documentsIds = [];
                        for (var iP = 0, lnP = dataSeance.Projet.length; iP < lnP; iP++) {
                            documentsIds.push(dataSeance.Projet[iP].document_id);
                        }

                        //  Comptage des annotations partagées non lues
                        var countUnreadAnnotations = 0;
                        if (dataAnnotations !== null) {
                            for (var j = 0, lnAnnotations = dataAnnotations.length; j < lnAnnotations; j++) {
                                if (!dataAnnotations[j].lue && dataAnnotations[j].id_utilisateur !== appUI.accounts.get(appUI.user.account_id).userId && documentsIds.indexOf(dataAnnotations[j].document_id) !== -1) {
                                    countUnreadAnnotations++;
                                }
                            }
                        }





                        //  Affichage de la notification des annotations partagées non lues
                        var badgeNbAnnotNonLues = $('<span />')
                                .addClass('badge')
                                .addClass('badge-warning')
                                .css({
                                    'float': 'right',
                                    'margin': '0 3px',
                                    'visibility': countUnreadAnnotations > 0 ? 'visible' : 'hidden'
                                })
                                .attr('title', 'Annotations non lues')
                                .addClass('countUnreadAnnotations')
                                .append($('<i />').addClass('icon').addClass('icon-comments'))
                                .append(' ' + countUnreadAnnotations);






                        var unread = $('<span />')
                                .addClass('badge')
                                .addClass('badge-important')
                                .css({
                                    'float': 'left',
                                    'margin': '0 3px',
                                    'visibility': dataConvocation.read ? 'hidden' : 'visible'
                                })
                                .attr('title', 'Séance non lue')
                                .addClass('unread')
                                .html($('<i />').addClass('icon').addClass('icon-envelope'));



                        var modified = $('<span />')
                                .addClass('badge')
                                .addClass('badge-warning')
                                .css({
                                    'float': 'left',
                                    'margin': '0 3px',
                                    'visibility': in_array(dataSeance.Seance.id, dataModified) ? 'visible' : 'hidden'
                                })
                                .attr('title', 'Séance modifi&eacutee')
                                .addClass('modified')
                                .html($('<i />').addClass('icon').addClass('icon-refresh'));





                        var loadProgress = $('<span />')
                                .css({float: 'right'})
                                .addClass('loadProgress')
                                .append($('<span />').addClass('info')
                                        .attr('title', 'Projets téléchargés')
                                        .append($('<span />').addClass('percent').html(appUI.imgLoaded.getProjetsStatus(dataSeance.Seance.id, account.id).percent))
                                        .append($('<span />').html(' %'))
                                        .append(' ')
                                        .append($('<i />').addClass('icon').addClass('icon-folder-close'))
                                        );

                        var loadConvocations = $('<span />')
                                .css({float: 'left'})
                                .addClass('loadProgress')
                                .append($('<span />').addClass('info')
                                        .attr('title', 'Convocations téléchargées')
                                        .append($('<span />').addClass('convocations').html(appUI.imgLoaded.getConvocationStatus(dataSeance.Seance.id, account.id).percent))
                                        .append($('<span />').html(' %'))
                                        .append(' ')
                                        .append($('<i />').addClass('icon').addClass('icon-file'))
                                        );




                        //  Comptage du nombre de projets de chaque séance et affichage de la notification correspondante.
                        var badgeNbProjet = $('<span />')
                                .addClass('badge')
                                .addClass('badge-info')
                                .css('margin', '0 3px')
                                .addClass('nbProjets')
                                .html(dataSeance.Projet.length);
                        var nbProjet = $('<div />').append('Il y a ').append(badgeNbProjet).append(' affaire' + (dataSeance.Projet.length > 1 ? 's' : '') + '.').append($('<br />')).append(loadConvocations).append(loadProgress);

                        //  Lecture et affichage de la date de la séance

                        var jsDate = new Date(dataSeance.Seance.date_seance.replace(' ', 'T') + 'Z');

                        var dateHeure = dataSeance.Seance.date_seance.split(" ");


                        var date = dateHeure[0].split("-");
                        var heure = dateHeure[1].split(":");


                        var strDate = date[2] + '/' + date[1] + '/' + date[0] + '<br>' + heure[0] + ':' + heure[1];




                        var btnContent = $('<div />')
                                //                                .css('margin-top', '10px')
                                .append(label)
                                .append(strDate)
                                .append($('<hr />'))
                                .append(nbProjet);

                        //  Affichage des boutons propres à chaque séance
                        var btn = $('<div></div>')
                                .addClass('btn')
                                .addClass('btn-huge')
                                .css({overflow: 'hidden', '-o-text-overflow': 'ellipsis', 'text-overflow': 'ellipsis'})
                                .addClass('btn-account')
                                .attr('id', dataSeance.Seance.id + 'Btn')
                                .attr('seanceId', dataSeance.Seance.id)
                                .attr('read', dataConvocation.read ? 'read' : 'unread')
                                .attr('disabled', 'disabled')
                                .append(unread)
                                .append(badgeNbAnnotNonLues)
                                .append(modified)
                                .append(btnContent)
                                .click(function(e) {

                                    
                                    unset($(this).attr('seanceId'), dataModified);
                                    
                                    appUI.storage.core.set("modifiedSeances", dataModified);

                                    if ($(this).attr('disabled') == "disabled") {
                                        return false;
                                    } else {



                                        appUI.seance_to_read = $(this).attr('seanceId'); //FIXME: s'en sortir autrement (essayer de faire correctement des closures et non pas utiliser un nouvel attribut de appUI) !!!!

                                        //  Création de la boîte modale nécessaire à la validation de l'accusé réception
                                        if ($(this).attr('read') === 'unread') {
                                            $('#readModal').modal('show');

                                            $('#readModalConfirm').unbind('click').bind('click', function() {
                                                $('#readModal').modal('hide');

                                                for (var iS = 0, lnS = appUI.engine.sockets.length; iS < lnS; iS++) {
                                                    if (appUI.engine.sockets[iS].accountId === appUI.user.account_id) {
                                                        //  Envoi de l'accusé de réception au server en spécifiant ses identifiants et la séance concernée (via id).
                                                        var arData = {
                                                            username: appUI.accounts.get(appUI.user.account_id).login,
                                                            password: appUI.accounts.get(appUI.user.account_id).password,
                                                            seanceId: appUI.seance_to_read //FIXME: s'en sortir autrement (essayer de faire correctement des closures et non pas utiliser un nouvel attribut de appUI) !!!!
                                                                    //                                                        seance: $(this).attr('seanceId')
                                                        };

                                                        //  Si la socket est connectée, on envoie directement...
                                                        if (appUI.engine.sockets[iS].socket.socket.connected) {
                                                            appUI.engine.ico.emit();
                                                            appUI.engine.sockets[iS].socket.emit('ar', arData);
                                                        } else {
                                                            //  Sinon on stocke la demande dans un tableau de "choses à faire".
                                                            var todo = appUI.storage.core.get('todo');
                                                            var todoElt = {};

                                                            todoElt.function = 'ar';
                                                            todoElt.args = arData;

                                                            todo.push(todoElt);
                                                            appUI.storage.core.set('todo', todo);
                                                        }

                                                        var dataSeancesToSave = appUI.storage.core.get('seances');
                                                        for (var itseanceToSave in dataSeancesToSave) {
                                                            var seanceToSave = dataSeancesToSave[itseanceToSave];
                                                            if (seanceToSave.Seance.id === appUI.seance_to_read) {
                                                                for (var itconvocationToSave in seanceToSave.Convocation) {
                                                                    var convocationToSave = seanceToSave.Convocation[itconvocationToSave];
                                                                    if (convocationToSave.user_id === appUI.accounts.get(appUI.user.account_id).userId) {
                                                                        convocationToSave.read = true;
                                                                    }
                                                                }
                                                            }
                                                        }
                                                        appUI.storage.core.set('seances', dataSeancesToSave);
                                                        appUI.set('convocation');
                                                    }
                                                }
                                            });
                                        } else {
                                            appUI.set('convocation');
                                        }
                                    }
                                });
                        $(seance).append(btn);
                        $(seances).append($(seance));
                        if (appUI.imgLoaded.getConvocationStatus(dataSeance.Seance.id, account.id).percent === 100) {
                            btn.removeAttr("disabled");
                        }

                    }
                }
                appUI.content.append(seances);

            }
        }
    },
    /**
     *  @function refreshData
     *  @param {String} type
     *  @param {JSObject} account
     *  @param {JSObject} data
     *  @description Rafraîchit le contexte courant
     **/
    refreshData: function(type, account, data) {


        if (typeof account === 'undefined') {
            account = appUI.accounts.getDefault();
        }

        
        
        
        if (type === "seances") {
            
            //this.document.content.process(); // pour la seances faire un remove seance par ex

            var dataSeances = appUI.storage.core.get('seances', account.id);
            if (dataSeances.length !== 0) {
                for (var i = 0, ln = dataSeances.length; i < ln; i++) {

                    //  Réactualisation des séances (si ajout ou suppression depuis le serveur
                    var dataSeance = dataSeances[i];

                    var dataConvocation;
                    for (var iC = 0, lnC = dataSeance.Convocation.length; iC < lnC; iC++) {
                        if (dataSeance.Convocation[iC].user_id === account.userId) {
                            dataConvocation = dataSeance.Convocation[iC];
                        }
                    }




                    //  Réactualisation des séances, selon si elles sont lues ou non lues (suppression de la notification d'accusé-réception).
                    $('#' + dataSeance.Seance.id + 'Btn').attr('read', dataConvocation.read ? 'read' : 'unread');
                    $('#' + dataSeance.Seance.id + 'Btn').parent().css('font-weight', dataConvocation.read ? 'normal' : 'bold');
                    $('#' + dataSeance.Seance.id + 'Btn .unread').css('visibility', dataConvocation.read ? 'hidden' : 'visible');
                    $('#' + dataSeance.Seance.id + 'Btn .nbProjets').html(dataSeance.Projet.length);

                    //$('#' + dataSeance.Seance.id + 'Btn').parent().css('font-weight', 'bold');



                }
            }
        
        
        }else if(type === "remove" ){
            this.document.content.process();
            
            
         }else if(type === "modification" ){
            this.document.content.process();
                
            
        
        
        } else if (type === "annotations") {
            //  TODO : Réactualisation des notifications d'annotations
            //
            //
            //            var dataSeances = appUI.storage.core.get('seances');
            //            var dataAnnotations = appUI.storage.core.get("annotations");
            //
            //
            //            var countUnreadAnnotations = 0;
            //            if (dataAnnotations !== null) {
            //                for (var j = 0, lnAnnotations = dataAnnotations.length; j < lnAnnotations; j++) {
            //                    if (!dataAnnotations[j].lue && dataAnnotations[j].id_utilisateur !== appUI.accounts.get(appUI.user.account_id).userId && documentsIds.indexOf(dataAnnotations[j].document_id) !== -1) {
            //                        countUnreadAnnotations++;
            //                    }
            //                }
            //            }

        } else if (type === "loadProgress") {
            var dataSeances = appUI.storage.core.get('seances', account.id);

            if (dataSeances.length !== 0) {
                for (var i = 0, ln = dataSeances.length; i < ln; i++) {
                    //  Réactualisation des séances (si ajout ou suppression depuis le serveur
                    var dataSeance = dataSeances[i];

                    //  Réactualisation des séances, selon si elles sont lues ou non lues (suppression de la notification d'accusé-réception).
                    $('#' + dataSeance.Seance.id + 'Btn .loadProgress .percent').html(appUI.imgLoaded.getProjetsStatus(dataSeance.Seance.id, account.id).percent);
                    $('#' + dataSeance.Seance.id + 'Btn .loadProgress .convocations').html(appUI.imgLoaded.getConvocationStatus(dataSeance.Seance.id, account.id).percent);
                    if (appUI.imgLoaded.getConvocationStatus(dataSeance.Seance.id, account.id).percent === 100) {
                        $('#' + dataSeance.Seance.id + 'Btn').removeAttr("disabled");

                    }
                }
            }
        }
    }
});
