/**
 *
 * webroot/idelibre_client/assets/js/appUI/data/data_menu.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/data/data_menu.js $
 * $Id: data_menu.js 537 2014-07-29 12:45:51Z genot $
 */

var data_menu = function() {
};
data_menu.prototype = {
    element: null,
    baseItems: [
        "menu-goto-ctx-params"
    ],
    baseEvents: {
        "menu-goto-ctx-home": function() {
            appUI.set('home');
        },
        "menu-goto-ctx-notifications": function() {
            appUI.set('seances');
        },
        "menu-goto-ctx-params": function() {
            appUI.set('params');
        },
    },
    ctx: {
        home: {
            draw: [],
            events: {}
        },
        params: {
            draw: [
                "menu-goto-ctx-home",
                "menu-goto-ctx-home-divider"
            ],
            events: {}
        },
        seances: {
            draw: [
                "menu-goto-ctx-home",
                "menu-goto-ctx-home-divider"
            ],
            events: {}
        },
        convocation: {
            draw: [
                "menu-goto-ctx-home",
                "menu-goto-ctx-home-divider"
            ],
            events: {}
        },
        odj: {
            draw: [
                "menu-goto-ctx-home",
                "menu-goto-ctx-home-divider"
            ],
            events: {}
        },
        document: {
            draw: [
                "menu-goto-ctx-home",
                "menu-goto-ctx-home-divider",
                "menu-go-back-odj",
                "menu-document-divider",
                "menu-previous-page",
                "menu-next-page",
                "menu-zoom-in",
                "menu-zoom-out",
                "menu-navigation-divider",
                "menu-private-annot",
                "menu-shared-annot",
                "menu-save-annot",
                "menu-annotation-divider"
            ],
            events: {
                "menu-go-back-odj": function() {
                    $('#btnSeances_ctx_doc').trigger('click');
                },
                "menu-previous-page": function() {
                    $('#btnPrev').trigger('mousedown');
                },
                "menu-next-page": function() {
                    $('#btnNext').trigger('mousedown');
                },
                "menu-zoom-in": function() {
                    $('#toolbox .icon-zoom-in').parent().trigger('mousedown');
                },
                "menu-zoom-out": function() {
                    $('#toolbox .icon-zoom-out').parent().trigger('mousedown');
                },
                "menu-private-annot": function() {
                    $('#modeAnnot').trigger('mousedown');
                },
                "menu-shared-annot": function() {
                    $('#modeAnnotPart').trigger('mousedown');
                },
                "menu-save-annot": function() {
                    $('#saveAnnots').trigger('mousedown');
                }
            }
        }
    },

    /**
     *  @function init
     *  @description Création du menu, appels des fonctions d'initialisation
     *  @return {Void}
     **/
    init: function() {
        this.base.menuInit();
        this.base.hide();
        this.base.draw();
        this.base.events();
    },

    /**
     *  @function update
     *  @description Mise à jour du menu
     *  @return {Void}
     **/
    update: function(options) {
        this.base.hide();
        this.custom.draw(options.draw);
        this.custom.events(options.events);
    },
    base: {
        /**
         *  @function menuInit
         *  @description Initialisation du menu
         *  @return {Void}
         **/
        menuInit: function() {
            $('html').on('click', function(e) {
                if ($(e.target).attr('id') !== 'btn-menu') {
                    $('#menu-btn').parent().removeClass('open');
                }
            });
            //  définition des actions effectuées lors de l'appui sur le bouton "menu"
            $('#menu-btn').bind('click', function(e) {
                e.stopPropagation();
                if ($(this).parent().hasClass('open')) {
                    $(this).parent().removeClass('open');
                } else {
                    $(this).parent().addClass('open');
                }
            });
        },
        /**
         *  @function hide
         *  @description Cache les éléments de classe CSS "removable-item"
         *  @return {Void}
         **/
        hide: function() {
            $('#menu-list .removable-item').css('display', 'none');
        },
        /**
         *  @function draw
         *  @description Affichage des composants du menu
         *  @return {Void}
         **/
        draw: function() {//ajouter btn de base
            appUI.menu.custom.draw(appUI.menu.baseItems);
        },
        /**
         *  @function events
         *  @description Initialisation des évènements propres aux composants du menu
         *  @return {Void}
         **/
        events: function() {//set default events (tous les immuables)
            appUI.menu.custom.events(appUI.menu.baseEvents);
        }
    },
    custom: {
        /**
         *  @function hide
         *  @param {Array<String>}
         *  @description Cache les éléments du menu de classes définies par "options"
         *  @return {Void}
         **/
        hide: function(options) {
            for (var i in options) {
                $("#" + options[i]).css('display', 'none');
            }
        },
        /**
         *  @function draw
         *  @param {Array} options
         *  @description Affichage de composants personnalisés dans le menu
         *  @return {Void}
         **/
        draw: function(options) {
            for (var i in options) {
                $("#" + options[i]).css('display', 'list-item');
            }
        },
        /**
         *  @function events
         *  @param {Array} options
         *  @description Initialisation d'événements personnalisés
         **/
        events: function(options) {
            for (var i in options) {
                this.event(i, options[i]);
            }
        },
        /**
         *  @function event
         *  @param {String} id
         *  @param {JSObject} fct
         *  @description
         *  @return {Void}
         **/
        event: function(id, fct) {
            $("#" + id).unbind('click').unbind('tapone');
            $("#" + id).bind('click', function() {
                if (!$("#" + id).hasClass('disabled') && $("#" + id).css('display') === 'list-item') {
                    fct();
                }
            });
        }
    },
}

