/**
 *
 * webroot/idelibre_client/assets/js/appUI/data/data_user.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 14:45:51 +0200 (mar. 29 juil. 2014) $
 * $Revision: 537 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/data/data_user.js $
 * $Id: data_user.js 537 2014-07-29 12:45:51Z genot $
 */
var data_user = function() {
};
data_user.prototype = {
    id: null,
    account_id: null,
    account_label: null,
    login: null,
    password: null,
//    use_cert: null,
//    private_key: null,
    firstname: null,
    lastname: null,
    canGetParams: false,
    logged: false,
    firstTimeLogin: true,
    firstTimeLogout: true,
    firstSync: true,
    serverUrl: "",
    /**
     *  @function store
     *  @description Stockage des données utilisateur dans la base de données locale
     *  @return {Boolean}
     **/
    store: function() {
        var retval = false;
        try {
            this.canGetParams = (this.login !== null && this.password !== null);
            appUI.storage.core.set('appUIDataUser', JSON.stringify(this));
            retval = true;
        } catch (err) {
            appUI.error("Impossible d'enregistrer les données utilisateurs", err);
        }
        return retval;
    },
    /**
     *  @function retreive
     *  @description Récupération des données utilisateur stockées dans la base de données locale
     *  @return {Boolean}
     **/
    retreive: function() {
        var retval = false;
        try {
            retval = JSON.parse(appUI.storage.core.get('appUIDataUser'));
        } catch (err) {
            appUI.error("Impossible de lire les données utilisateurs", err);
        }
        return retval;
    },
    /**
     *  @function load
     *  @description Chargement des données utilisateur
     *  @return {Boolean}
     **/
    load: function() {
        var retval = false;
        try {
           // console.log('load data_user');
            $.extend(true, this, this.retreive());
            this.setCanGetParams();
            retval = true;
        } catch (err) {
            appUI.error('Impossible de charger les données utilisateurs', err);
        }
        return retval;
    },
    /**
     *  @function setCanGetParams
     *  @description Vérifie si l'utilisateur existe et si ses paramètres peuvent être modifiés
     *  @return {Boolean}
     **/    
    setCanGetParams: function() {
        appUI.user.canGetParams = ((typeof appUI.user.login !== "undefined" && appUI.user.login !== '' && appUI.user.login !== null) && (typeof appUI.user.password !== "undefined" && appUI.user.password !== '' && appUI.user.password !== null));
    },  
    /**
     *  @function resetUser
     *  @description Réinitialisation des données de l'utilisateur
     *  @return {Boolean}
     **/
    resetUser: function() {
        localStorage.clear(appUIDataUser);
        this.load();
    },
};