/**
 *
 * webroot/idelibre_client/assets/js/appUI/ui.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * JavaScript (HTML 5)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 16:59:11 +0200 (mar. 29 juil. 2014) $
 * $Revision: 540 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/assets/js/appUI/ui.js $
 * $Id: ui.js 540 2014-07-29 14:59:11Z genot $
 */

/**
 *	UI object
 */





/*
 * 
 * fonctions orphelines utilitaire
 * 
 * 
 */


// retourne le nom de la connection en extrayant apres le @
function connName(login){
    var extract = login.split('@');
    return extract[1];
}


// compare 2 tableaux
function arraysIdentical(a, b) {
    var i = a.length;
    if (i != b.length)
        return false;
    while (i--) {
        if (a[i] !== b[i])
            return false;
    }
    return true;
}
;



/**
 * donne la position des élément different entre les 2 tableaux de meme longeur
 * retourne vrai si ils sont de longeur differentes pour ne pas avoir le probleme de la nouvelle convocation
 * @param {type} tab1
 * @param {type} tab2
 * @returns {positionDif.tabReturn|Array|Boolean}
 */

var positionDif = function(tab1, tab2) {
    var len = tab1.length;
    if (len !== tab2.length) {
        return true;
    }
    var tabReturn = [];
    for (var i = 0; i < len; i++) {
        if (tab1[i] != tab2[i]) {
            tabReturn.push(i);
        }
    }
    return tabReturn;

};



/*
 * renvoie true si key est present dans le tableau
 * @param {any} search clé
 * @param {array} array array
 * @returns {Boolean} 
 */
function in_array(key, array) {
    for (i = 0; i < array.length; i++)
    {
        if (array[i] == key)
        {
            return true;
        }
    }
    return false;
}


function unset(val, array) {
    var index = array.indexOf(val);
    if (index > -1) {
        array.splice(index, 1);
    }
}











var UI = function() {
};
UI.prototype = {
    autoLoad: true,
    cacheLoading: false,
    client_id: MD5(navigator.appCodeName + navigator.appName + navigator.appVersion + navigator.oscpu + navigator.platform + navigator.product + navigator.productSub + navigator.userAgent),
    engine: {},
    accountsSockets: new Hashtable(),
    debugMode: false, //affiche ou masque la barre de débug et les "console.log"
    debugTools: {},
    isDeleted: false,
    imgLoaded: {},
    canSwipe: 0, //permet la gestion de l'activation/désactivation du swipe
    consoleCloseTimeout: null,
    cordova: /^file:\/{3}[^\/]/i.test(window.location.href) && /ios|iphone|ipod|ipad|android/i.test(navigator.userAgent), //précise s'il faut exécuter le code spécifique à cordova ou non
    notification: {}, //contient le div de la barre de notifications
    notificationContent: {}, //contient les messages de la barre de notifications
    user: {}, //contient des informations sur l'utilisateur en cours s'il est identifié sur le serveur
    accounts: {},
    storage: {},
    menu: {},
    header: {}, //contient le header du contexte en cours
    content: {}, //contient le contenu du contexte en cours
    footer: {}, //contient le pied de page du contexte en cours
    toolbox: {}, //contient la barre de Debug
    options: {},
    lastClick: {
        x: false,
        y: false
    }, //contient les coordonnées du dernier click
    action: null, //donne des informations sur la dernière action effectuée (contexte et séance)
    context: 'home', //indique le contexte courant
    contexts: {
        home: ctxHome,
        seances: ctxSeances,
        convocation: ctxConvocation,
        odj: ctxOdj,
        params: ctxParams,
        document: ctxDocument
    }, //donne la liste de tous les contextes

    nbPagesConvocTotales: 0,
    nbPagesProjetTotales: 0,
    data_imgpages_id: new Hashtable(),

    /**
     *  @function genUUID
     *  @description génère un UUID aléatoire et renvoie cet UUID.
     *  @return {String}
     */
    genUUID: function() {
        var nbr, randStr = "";
        do {
            randStr += (nbr = Math.random()).toString(16).substr(2);
        } while (randStr.length < 30);
        return [
            randStr.substr(0, 8), "-",
            randStr.substr(8, 4), "-4",
            randStr.substr(12, 3), "-",
            ((nbr * 4 | 0) + 8).toString(16), // [89ab]
            randStr.substr(15, 3), "-",
            randStr.substr(18, 12)
        ].join("");
    },
    /**
     *	Context
     */

    /**
     *  @function init
     *  @description initialise l'objet UI, le lancement de cette fonction est nécessaire au fonctionnement de l'application.
     *  @return {Boolean}
     */
    init: function() {
        var that = this;

        //attribution des contextes aux boutons du menu principal
        $('#logoIdelibre').data('context', 'home');
        $('#btnParams').data('context', 'params');
        $('#btnParamsPhone').data('context', 'params');

        //lecture des infos de version et revision
        $.ajax({
            url: "version.html",
            dataType: "html",
            success: function(data) {
                $('#versionInfo').html(data);
            }
        });

        $.ajax({
            url: "revision.html",
            dataType: "html",
            success: function(data) {
                $('#revisionInfo').html(data);
            }
        });

        $('#menu-about').bind('click', function() {
            $('#infoModal').modal("show");
        });

        //clic sur le logo i-delibre
        $('#logoIdelibre').bind('click', function(e) {
            //fermeture des panneaux latéraux
            $('#left-panel .menu-close-btn').trigger('click');
            $('#right-panel .menu-close-btn').trigger('click');
        });

        //icone de notification
        $('#notificationBar').bind('click', function() {
            appUI.notification.toggle();
        });

        $('#notificationClear').bind('click', function(e) {
            e.stopPropagation();
            appUI.notificationClear();
        });

        //set context attributes
        this.header = $('#UIHeader');
        this.content = $('#UIContent');
        this.footer = $('#UIFooter');
        this.toolbox = $('#toolbox');
        this.notification = $('.app-ui-notification');
        this.notificationContent = $('.app-ui-notification-content');

        var initErrors = [];
        var reportErrors = function(strErr, err) {
            try {
                appUI.error(strErr, err);
                initErrors.push(strErr + ' : ' + err);
            } catch (err2) {
                var fullStrErr = strErr + ' : ' + err + ' (' + err2 + ')';
                initErrors.push(fullStrErr);
                console.log(fullStrErr);
            }
        };

        //init debug
        try {
            this.debugTools = new engine_debugTools();
        } catch (err) {
            reportErrors('Impossible de charger le module debugTools', err);
        }

        //init storage
        try {
            this.storage = new data_storage();
            this.storage.mode.current = "localStorage";
            this.storage.core.init();
        } catch (err) {
            reportErrors('Impossible de charger le module storage', err);
        }



        //init menu
        try {
            this.menu = new data_menu();
            //initialisation du menu
            this.menu.init();
        } catch (err) {
            reportErrors('Impossible de charger le module menu', err);
        }

        //initialisation de l'attribut user
        try {
            this.user = new data_user();
            this.user.load();
        } catch (err) {
            reportErrors('Impossible de charger le module user', err);
        }
        //console.log(this.user);

        //init accounts management
        try {
            this.accounts = new data_accounts_collection(appUI.accountMaxLength);
            //initialisation du selecteur de compte
            this.accounts.restore();

            if (appUI.cordova && appUI.storage.core.get('demoFirstTime') === null) {
                appUI.storage.core.set('demoFirstTime', true);
            }

            if (appUI.cordova && appUI.storage.core.get('demoFirstTime') === "true") {
                this.accounts.addDemo();
            }

            this.accounts.menu.init();
            this.accounts.menu.draw();

            var defAcc = this.accounts.getDefault();
            if (typeof defAcc !== "undefined" && typeof defAcc.id !== "undefined") {
                //                this.accounts.switch(defAcc.id, true);
            }

        } catch (err) {
            reportErrors('Impossible de charger le module account', err);
        }

        try {
            this.engine = new engine_ws();
        } catch (err) {
            reportErrors('Impossible de charger le module engine_ws', err);
        }

        //initialisation de l'attribut imgLoaded
        try {
            console.log('init imgloaded');
            
            this.imgLoaded = new data_imgloaded();
            this.imgLoaded.init();
            //this.imgLoaded.checkAllImagesStatus();
            
            
        } catch (err) {
            reportErrors('Impossible de charger le module imgloaded', err);
        }



        //si pas d erreur d'initialisation des modules, on initialise les comportements de l appli
        var initErrorsLn = initErrors.length;
        if (initErrorsLn === 0) {

            //définition de l'action d'ouverture/fermeture du panneau latéral gauche
            $('#left-panel-btn').bind('click', function() {
                $('.header .menu-close-btn').css('visibility', 'hidden');

                //vérification du contexte courant
                var actContext = null;
                for (var i in that.contexts) {
                    if (that.context === that.contexts[i].name) {
                        actContext = that.contexts[i];
                    }
                }

                //vérification de l'état courant du panneau (ouvert/fermé) et passage
                //à l'état inverse
                if (parseInt($('#left-panel').prop('data-open')) === 1) {
                    //fermeture du panneau
                    $('#left-panel .menu-close-btn').trigger('click');
                } else {
                    //ouverture du panneau
                    //récupération du contenu du panneau
                    if (actContext.leftPanel.content.url !== '') {
                        $.ajax({
                            cache: true,
                            dataType: "script",
                            url: actContext.leftPanel.content.url,
                            success: actContext.leftPanel.content.process()
                        });
                    }
                    //animation d'ouverture
                    $('#left-panel').prop('data-open', 1).show().animate({
                        left: '0'
                    }, 'fast');
                    //réactivation du slide au doigt ou à la sourie tant que le panneau
                    //est ouvert (à l'aide d'une désactivation du swipe)
                    $('body').swipe('disable');
                }
            });

            //définition de l'action de fermeture du panneau latéral gauche
            $('#left-panel .menu-close-btn').on('click', function() {
                //animation de fermeture du panneau
                $('#left-panel').prop('data-open', 0).animate({
                    left: '-40%'
                }, 'fast').hide();
                //si aucune annotation n'est ouverte, réactivation du swipe
                if (appUI.canSwipe <= 0) {
                    $('body').swipe('enable');
                }
            });

            $('#right-panel-btn').bind('click', function() {
                $('.header .menu-close-btn').css('visibility', 'hidden');
                var actContext = null;
                for (i in that.contexts) {
                    if (that.context === that.contexts[i].name) {
                        actContext = that.contexts[i];
                    }
                }

                if (parseInt($('#right-panel').prop('data-open')) === 1) {
                    $('#right-panel .menu-close-btn').trigger('click');
                } else {
                    if (actContext.rightPanel.content.url !== '') {
                        $.ajax({
                            cache: true,
                            dataType: "script",
                            url: actContext.rightPanel.content.url,
                            success: actContext.rightPanel.content.process()
                        });
                    }

                    $('#right-panel').prop('data-open', 1).show().animate({
                        right: '0'
                    }, 'fast');
                    $('body').swipe('disable');
                }
            });

            $('#right-panel .menu-close-btn').on('click', function() {
                $('#right-panel').prop('data-open', 0).animate({
                    right: '-40%'
                }, 'fast').hide();
                if (appUI.canSwipe <= 0) {
                    $('body').swipe('enable');
                }
            });

            //definition des boutons d'action
            $('.btn-action, .brand').live('click', function() {
                if (!$(this).hasClass('disabled')) {

                    that.action.runstate = appActionRunstates.start;

                    that.action.runstate = appActionRunstates.running;
                    if (typeof $(this).data('context') !== 'undefined') {
                        that.action.context = $(this).data('context');
                    }

                    if (typeof $(this).data('uuid') !== 'undefined') {
                        that.action.uuid = $(this).data('uuid');
                    }

                    if (typeof $(this).data('action') !== 'undefined') {
                        that.action.action = $(this).data('action');
                    }

                    if (typeof $(this).data('notification-uuid') !== 'undefined') {
                        that.current_notification_uuid = $(this).data('notification-uuid');
                    }

                    that.set(that.action.context);
                    that.action.runstate = appActionRunstates.end;

                    if ($(this).parents('#menu-panel').length > 0) {
                        $('#menu-wrapper .menu-close-btn').trigger('click');
                        $('#right-panel .menu-close-btn').trigger('click');
                        $('#left-panel .menu-close-btn').trigger('click');
                    }
                }
            });

            /**
             *	Init current action
             */
            that.action = $.extend(true, {}, new appAction());

            /**
             * set page elements behaviors
             */
            appUI.engine.init();

            this.loaded = this.set(this.context);
        } else if (appUI.debugMode) {
            $('#UIContent').append($('<h1></h1>').html('Init Errors'));
            for (var i = 0; i < initErrorsLn; i++) {
                $('#UIContent').append(
                    $('<div></div>')
                    .addClass('alert')
                    .addClass('alert-danger')
                    .append($('<i></i>').addClass('icon').addClass('icon-warning-sign'))
                    .append(' ' + initErrors[i]));
            }
        }

        return this.loaded;
    },

    /**
     *  @function showDebugTools
     *  @description Affiche ou enlève la barre de déboguage
     **/
    showDebugTools: function() {
        //remplacement de la console
        if (appUI.debugMode) {
            (function(w) {
                "use strict";
                //					var oldLog;
                //make sure there's a console to call
                if (!w.console) {
                    w.console = {
                        //no-op used to provide consistent interface
                        log: function() {
                        }
                    };
                }
                //store the reference to the old console
                appUI.oldLog = w.console.log;
                w.console.log = function() {
                    var args;
                    //cast arguments into an Array
                    args = Array.prototype.slice.call(arguments);
                    //...
                    appUI.notify(args, 0);
                    //...
                    //call the old console.log function in the context of console for chrome
                    return appUI.oldLog.apply(w.console, args);
                };
            }(window));

            $('<div></div>')
            .attr('id', 'debugModeBtn')
            .addClass('btn')
            .addClass('btn-small')
            .addClass('btn-danger')
            .css({
                position: 'absolute',
                top: '5px',
                left: '5px',
                'z-index': '100000',
                'cursor': 'pointer',
                'font-weight': 'bold'
            })
            .append($('<i></i>').addClass('icon-off'))
            .bind('click', function() {
                if ($('.debugTools').length > 0) {
                    appUI.debugTools.remove();
                    appUI.debugMode = false;
                } else {
                    appUI.debugTools.load();
                    appUI.debugMode = true;
                }
            })
            .appendTo($('#menuBar'));
        } else {
            $('#debugModeBtn').remove();
        }
    },
    set: function(context) {
        this.context = context;
        return this.refresh();
    },
    refresh: function() {
        return this.flushContext() && this.genContext();
    },
    /**
     *  @function flushContext
     *  @description vide le contexte courant, cette fonction doit être appelée avant chaque changement de contexte.
     *  @return {Void}
     */
    flushContext: function() {
        try {
            if (typeof Annotation !== 'undefined') {
                //remise à zéro de toutes les configurations du contexte
                //(bind d'évênements, éléments d'interface modifiés...)
                Annotation.reset();
                $(window).unbind('resize');
                jQuery(document).unbind('swipemove mousemove touchmove mousedown mouseup touchend gesturechange mousewheel wheel');
                $('body').swipe("destroy");
                $(document).swipe("destroy");
                $('body').css('overflow', 'auto');
                jQuery('#divAnnotation').unbind('click touch mouseup touchend');
                $('#divAnnotation').remove();
                $('#scrollbar').remove();
                $('#btnSeances_ctx_doc').remove();
                $('#menuBar').css('position', 'fixed');
            }
            //remise à zéro du contexte (suppression de tous ses éléments)
            this.header.empty();
            this.content.empty();
            this.footer.empty();
            this.toolbox.empty();



            return true;
        } catch (err) {
            this.error('Impossible de vider le contexte', err);
        }

    },

    /**
     *  @function genContexte
     *  @description Génération de l'interface graphique
     *  @return {Void}
     **/
    genContext: function() {
        //		var that = this;

        //définition du contexte actuel
        var actContext = null;
        for (i in this.contexts) {
            if (this.context === this.contexts[i].name) {
                actContext = this.contexts[i];
            }
        }

        //remplissage de l'entête de la zone d'affichage principale
        if (typeof actContext.document.header.process !== "undefined") {
            if (typeof actContext.document.header.url !== "undefined" && actContext.document.header.url !== '') {
                $.ajax({
                    cache: true,
                    dataType: "script",
                    url: actContext.document.header.url,
                    complete: function() {
                        actContext.document.header.process();
                    }
                });
            } else {
                actContext.document.header.process();
            }
        }

        //remplissage du corps de la zone d'affichage principale
        if (typeof actContext.document.content.process !== "undefined") {
            if (typeof actContext.document.content.url !== "undefined" && actContext.document.content.url !== '') {
                $.ajax({
                    cache: true,
                    dataType: "script",
                    url: actContext.document.content.url,
                    complete: function() {
                        actContext.document.content.process();
                    }
                });
            } else {
                actContext.document.content.process();
            }
        }

        //remplissage du pied de page de la zone d'affichage principale
        if (typeof actContext.document.footer.process !== "undefined") {
            if (typeof actContext.document.footer.url !== "undefined" && actContext.document.footer.url !== '') {
                $.ajax({
                    cache: true,
                    dataType: "script",
                    url: actContext.document.footer.url,
                    complete: function() {
                        actContext.document.footer.process();
                    }
                });
            } else {
                actContext.document.footer.process();
            }
        }

        //panneaux latéraux
        //panneau gauche
        if (actContext.leftPanel.btnName !== '') { // si le panneau gauche est défini,
            // on affiche le bouton d'action et on en change l'intitulé,
            $('#left-panel-btn ').show();
            $('#left-panel-btn .btn-name').html(actContext.leftPanel.btnName);
            // on rempli la zone d'affichage principale du panneau,
            if (typeof actContext.leftPanel.content.process !== "undefined") {
                if (typeof actContext.leftPanel.content.url !== "undefined" && actContext.leftPanel.content.url !== '') {
                    $.ajax({
                        cache: true,
                        dataType: "script",
                        url: actContext.leftPanel.content.url,
                        success: function() {
                            actContext.leftPanel.content.process();
                        }
                    });
                } else {
                    actContext.leftPanel.content.process();
                }
            }
        } else { // sinon on masque le bouton d'action
            $('#left-panel-btn').hide();
        }

        //panneau droit
        if (actContext.rightPanel.btnName !== '') { // si le panneau droit est défini,
            // on affiche le bouton d'action et on en change l'intitulé,
            $('#right-panel-btn').show();
            $('#right-panel-btn .btn-name').html(actContext.rightPanel.btnName);
            if (typeof actContext.rightPanel.content.process !== "undefined") {
                if (typeof actContext.rightPanel.content.url !== "undefined" && actContext.rightPanel.content.url !== '') {
                    $.ajax({
                        cache: true,
                        dataType: "script",
                        url: actContext.rightPanel.content.url,
                        success: function() {
                            actContext.rightPanel.content.process();
                        }
                    });
                } else {
                    actContext.rightPanel.content.process();
                }
            }
        } else { // sinon on masque le bouton d'action
            $('#right-panel-btn').hide();
        }

        //menu
        appUI.menu.update(appUI.menu.ctx[actContext.name]);
    },
    notifyOSDTimeout: null,
    /**
     *  @function notifyOSD
     *  @param {String} message
     *  @description Permet d'avertir l'utilisateur d'une modification des données le concernant et recuperation des messages d'erreur en mode debug
     **/
    notifyOSD: function(message) {
        $('.notifyOSD').remove();

        if (this.notifyOSDTimeout !== null) {
            clearTimeout(this.notifyOSDTimeout);
        }
    
        //  Element d'affichage des notifications
        var notifyOSD = $('<div></div>')
        .addClass('alert')
        .addClass('notifyOSD')
        .addClass('alert-success')
        .css({
            'font-weight': 'bold',
            opacity: 0.7,
            position: 'absolute',
            top: '50px',
            right: '100px',
            'z-index': 999999999,
            'border': '2px solid #008000',
            'max-height': '50px',
            'max-width': '350px',
            overflow: 'auto'
        })
        .append($('<span></span>').html(message).css('opacity', 1))
        .click(function() {
            clearTimeout(this.notifyOSDTimeout);
            $('.notifyOSD').remove();
        });

        $('body').append(notifyOSD);
        
        //  Durée d'affichage de la notification
        this.notifyOSDTimeout = setTimeout(function() {
            $('.notifyOSD').remove();
        }, 3000);
    },
    /**
     *  @function notify
     *  @param {String} msg
     *  @param {Integer} errLevel
     *  @description Envoi de messages et affichage dans la zone de notitifcation de l'application
     *  @returns {Void}
     **/
    notify: function(msg, errLevel) {
        if (typeof errLevel === 'undefined') {
            errLevel = 0;
        }

        if (!appUI.debugMode) {
            if (errLevel === 2) {
                msg = "Une erreur s'est produite...";
            }
            if (errLevel > 0) {
                errLevel--;
            }
        }

        var notificationMsg = $('<div></div>').addClass('item').addClass('label');

        if (appUI.debugMode) {
            notificationMsg.css('overflow', 'auto');
        }

        var notificationIco = $('<i></i>').addClass('ico').addClass('icon-white');

        if (errLevel === 0) {
            notificationIco.addClass('icon-info-sign');
            //			notificationMsg.addClass('label-info');
        } else if (errLevel === 1) {
            notificationIco.addClass('icon-bullhorn');
            notificationMsg.addClass('label-warning');
        } else if (errLevel === 2) {
            notificationIco.addClass('icon-warning-sign');
            notificationMsg.addClass('label-important');
        }
        notificationMsg.append(notificationIco).append(msg).after($('<br />'));

        this.notificationContent.append(notificationMsg);

        var scrollHeight = 0;
        var lastHeight;
        $('.app-ui-notification .item').each(function() {
            scrollHeight += $(this).innerHeight();
            lastHeight = $(this).innerHeight();
        });

        document.getElementById('appuinotification').scrollTop = document.getElementById('appuinotification').scrollHeight;

        if (errLevel >= 1) {
            this.notification.show();
        }

        appUI.notifyRefreshIcon();

        clearTimeout(appUI.consoleCloseTimeout);
        appUI.consoleCloseTimeout = setTimeout('appUI.notificationClose()', 3000);

        if (errLevel === 0) {
            this.notifyOSD(msg);
        }
    },

    /**
     *  @function notifyRefreshIcon
     *  @description rafraichissement de l'icone de notification
     *  @returns {Void}
     **/
    notifyRefreshIcon: function() {
        var countItem = $('#menuBar .app-ui-notification-content .item').length;
        if (countItem > 0) {
            appUI.checkNotifyIcon();
            $('#logo-notification .count').css('visibility', 'visible').html(countItem);
            $('#logo-notification').addClass('badge-info').removeClass('badge-inverse');
        } else {
            $('#logo-notification .count').css('visibility', 'hidden').html(0);
            $('#logo-notification').removeClass('badge-info').addClass('badge-inverse');
        }
    },
    /**
     *  @function checkNotifyIcon
     *  @returns {Void}
     */
    checkNotifyIcon: function() {
        $('#logo-notification .icon-comment').css('position', 'relative').animate({left: "-2px"}, 50, function() {
            $('#logo-notification .icon-comment').animate({left: "2px"}, 50, function() {
                $('#logo-notification .icon-comment').animate({left: "0"}, 50, function() {
                    $('#logo-notification .icon-comment').animate({left: "-2px"}, 50, function() {
                        $('#logo-notification .icon-comment').animate({left: "2px"}, 50, function() {
                            $('#logo-notification .icon-comment').animate({left: "0"}, 50, function() {
                                $('#logo-notification .icon-comment').css('position', 'static');
                            });
                        });
                    });
                });
            });
        });
    },

    /**
     *  @function nofiticationClose
     *  @description Fermeture de la zone de notification
     *  @returns {Void}
     **/
    notificationClose: function() {
        this.notification.hide();
        this.notifyRefreshIcon();
    },

    /**
     *  @function notificationClear
     *  @description Purge de la zone de notification
     *  @returns {Void}
     **/
    notificationClear: function() {
        this.notification.hide();
        $('.app-ui-notification-content', this.notification).empty();
        this.notifyRefreshIcon();
    },
    /**
     *  @function error
     *  @param {String} msg
     *  @param {String} errorMsg
     *  @description Notification des erreurs et affichage dans la barre de déboguage
     *  @returns {Void}
     **/
    error: function(msg, errorMsg) {
        this.notify(msg, 2);
        appUI.debugTools.debug(errorMsg);
    },
    /**
     *  @function stackTrace
     *  @returns {String}
     **/
    stackTrace: function() {
        var err = new Error();
        return err.stack;
    }

};
