/**
 *
 * webroot/idelibre_client/debugTools.js
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 * @encoding UTF-8
 *
 * SVN Informations
 * $Date: 2014-07-29 16:59:11 +0200 (mar. 29 juil. 2014) $
 * $Revision: 540 $
 * $Author: genot $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/webroot/idelibre_client/documents.js $
 * $Id: documents.js 540 2014-07-29 14:59:11Z genot $
 */

try {
    $.ajax({
        url: "assets/annotations/raphael-min.js",
        dataType: "script",
        cache: true,
        success: function(data, textStatus, jqXHR) {
            $.ajax({
                url: "assets/annotations/annotations.js",
                dataType: "script",
                cache: true,
                success: function(data, textStatus, jqXHR) {
                    //  désactivation du scroll natif pour le remplacer par celui de l'application
                    $('body').css('overflow', 'hidden');
                    //  initialisation de la bibliothèque annotations.js
                    chargement_Annotation();

                    /**
                     *  @function initAnnots
                     *  @description Initialisation du cadre de travail destiné aux annotations
                     *  @return {Void}
                     **/
                    var initAnnots = function() {
                        
                        

                        //  ajout d'une méthode rendant possible le scroll du document à l'aide de
                        //  l'interface d'i-delibRE
                        Annotation.divIdelibre = function() {
                            //  suppression de l'ancienne div
                            $('#divAnnotation').remove();
                            $('#btnSeances_ctx_doc').remove();
                            //  création de la nouvelle div contenant le svg à scroll
                            $('body').append($('<div></div>').prop('id', 'divAnnotation'));
                            $('svg').prop('id', 'svg');
                            //  ajout du svg et configuration de la div
                            $('#divAnnotation').append($('svg')).css({
                                position: 'absolute',
                                top: '0px',
                                left: '0px',
                                height: '100%',
                                width: '100%',
                                overflow: 'hidden'
                            });
                            //  mise en place de la fermeture automatique des panneaux latéraux lorsque l'on clique à l'extérieur de ceux-ci
                            var divAnnotationTouch = new Hammer(window.document.getElementById("divAnnotation"));
                            divAnnotationTouch.on("touch", function(event) {
                                switch (event.type) {
                                    case 'touch':
                                        $('#left-panel .menu-close-btn').trigger('click');
                                        $('#right-panel .menu-close-btn').trigger('click');
                                        break;
                                }
                            });

                            //  création du bouton de retour aux séances
                            var boutonSeances = $('<span></span>')
                            .attr('id', 'btnSeances_ctx_doc')
                            .addClass('btn')
                            .addClass('btn-inverse')
                            .addClass('btn-huge')
                            .css({
                                "position": "absolute",
                                "top": "50px",
                                "left": "5px"
                            })
                            .attr('title', "Revenir à l'Ordre du jour")
                            .append($('<i></i>').addClass('icon-caret-left')/*.addClass('icon-white')*/)
                            .append($('<span></span>').html(' '))
                            .append($('<i></i>').addClass('icon-list')/*.addClass('icon-white')*/)
                            //  définition de l'action du bouton de retour aux séances
                            .on('click touchstart', function() {
                                //  lancement de l'animation de retour aux séances
                                $('#divAnnotation').animate({
                                    left: window.innerWidth + 'px'
                                }, 400, function() {
                                    //  changement de contexte, passage au contexte notifications
                                    appUI.set('odj');
                                });
                            });
                            //  ajout du bouton séances dans le contexte
                            $('body').append(boutonSeances);

                            var sx = 0;
                            var sy = 0;
                            var possible = true;
                            //  bind d'un évênement permettant d'obtenir les coordonnées des clicks sur le svg
                            var svgTouch = new Hammer(window.document.getElementById("svg"));
                            svgTouch.on("drag", function(event) {
                                switch (event.type) {
                                    case 'drag':
                                        if (event.gesture.touches.length !== 2) {
                                            sx = event.gesture.center.pageX;
                                            sy = event.gesture.center.pageY;
                                            possible = false;
                                        }
                                        break;

                                }
                            });
                        };

                        //  création du tableau contenant les url des images des pages du document
                        var array_document = new Array();
                        var array_annotations = new Array();

                        var tab = appUI.storage.core.get("annotations");

                        for (var i in appUI.finalAnnots) {

                            for (var j = 0; j < tab.length; j++) {
                                if (appUI.finalAnnots[i].id === tab[j].imgpage_id) {
                                    //  Le format de données fait parvenir des flottants mal encodés, on remplace "," par "."
                                    if (typeof (tab[j].x) !== "number") {
                                        tab[j].x = parseFloat(tab[j].x.replace(',', '.'));
                                        tab[j].y = parseFloat(tab[j].y.replace(',', '.'));
                                        tab[j].hauteur = parseFloat(tab[j].hauteur.replace(',', '.'));
                                        tab[j].largeur = parseFloat(tab[j].largeur.replace(',', '.'));
                                    }
                                    if (typeof array_annotations[appUI.finalAnnots[i].imgpagenum - 1] !== "undefined") {
                                        array_annotations[appUI.finalAnnots[i].imgpagenum - 1].push(tab[j]);
                                    } else {
                                        array_annotations[appUI.finalAnnots[i].imgpagenum - 1] = new Array(tab[j]);
                                    }
                                }
                            }
                            array_document[appUI.finalAnnots[i].imgpagenum - 1] = appUI.finalAnnots[i].image;
                        }


                        //  une fois le tableau d'url prêt le document peut être initialisé
                        Annotation.initialiser_document(array_document);

                        //  calcul des variables de configuration du document
                        var largeur = Math.min($(window).width() * 0.8, 1654);
                        var hauteur = 1.41 * largeur;
                        var x = ($(window).width() - largeur) / 2;
                        var listePartage = new Array();
                        var j = 0;
                        //  récupération de la liste de partage
                        for (i in appUI.actShareUsers) {
                            if (appUI.actShareUsers[i].id !== appUI.accounts.getCurrentUserInfos().userId) {
                                listePartage[j] = [appUI.actShareUsers[i].firstname + " " + appUI.actShareUsers[i].lastname, appUI.actShareUsers[i].id, 0];
                                j++;
                            }
                        }

                        //  les variables de configuration sont toutes pretes, lancement de la configuration dudocument
                        Annotation.setConfig({
                            fenetre: {x: x, y: 50, largeur: largeur, hauteur: hauteur},
                            annotations: {dimensions_minimum: 40, taille_boutons: 25, taille_texte: 15, epaisseur_bordure: 2},
                            zoom_maximum: 2,
                            zoom_limite_hauteur: hauteur - $(window).height() * 0.9,
                            utilisateur: appUI.accounts.get(appUI.user.account_id).userFirstname + " " + appUI.accounts.get(appUI.user.account_id).userLastname,
                            id_utilisateur: appUI.accounts.get(appUI.user.account_id).userId,
                            validation_entrer: false,
                            delai_enregistrement_clavier: 500,
                            date_avec_heure: true,
                            opacite_base: 0.2,
                            opacite_selection: 0.5,
                            couleur_annotation_privee: '#0000FF',
                            couleur_annotation_publique: '#04B404',
                            couleur_annotation_publique_externe: '#FACC2E',
                            chemin_dossier_boutons: 'assets/img/buttons/',
                            liste_partage_activee: true,
                            /**
                             *  Surcharge la fonction existante dans annotations.js
                             *  @function fonction_chargement_liste_partage
                             *  @description Gestion et création d'une liste de partage pour les annotations
                             *  @return {Array}
                             **/
                            fonction_chargement_liste_partage: function() {
                                var resultat = new Array();
                                for (var i in listePartage) {
                                    resultat[i] = listePartage[i].slice();
                                }
                                return resultat;
                            },
                            /**
                             *  Surcharge la fonction existante dans annotations.js
                             *  @function fonction_evenement_sauvegarde
                             *  @param {JSObject} data
                             *  @param {String} action
                             *  @param {String} action2
                             *  @description Gestion de la sauvegarde et de l'envoi des annotations à la création, édition et suppression
                             *  @return {Void}
                             **/
                            fonction_evenement_sauvegarde: function(data, action, action2) {
                                console.log('fonction_evenement_sauvegarde');
                                //  On remplace la fonction de sauvegarde (lorsqu'on manipule des annotations) par nos instructions.
                                var credentials = {
                                    username: appUI.accounts.get(appUI.user.account_id).login,
                                    password: appUI.accounts.get(appUI.user.account_id).password,
                                    userId: appUI.accounts.get(appUI.user.account_id).userId,
                                };
                                var socket = appUI.engine.getCurrentSocket();
                                var allAnnots = appUI.storage.core.get('annotations');

                                if (allAnnots === null || typeof allAnnots === 'undefined' || typeof allAnnots === 'string') {
                                    allAnnots = new Array();
                                }

                                Annotation.definir_creation_annotation(false);
                                Annotation.choisir_mode_annotation(false);

                                //  console.log(new Date().getTime() + ' - ' + action + ' - ' + action2);
                                //  Action à effectuer lorqu'une annotation est créée.
                                if (action === "creer") {
                                    //unproper but working
                                    data.document_id = appUI.action.uuid;
                                    for (var i in appUI.finalAnnots) {
                                        if (appUI.finalAnnots[i].imgpagenum === Annotation.getConfig().page_en_cours) {
                                            data.imgpage_id = appUI.finalAnnots[i].id;
                                        }
                                    }

                                    allAnnots.push(data);
                                    appUI.storage.core.set('annotations', allAnnots);

                                    //  On prépare les données avec l'annotation créée sous forme d'un JSON avec les credentials et l'action "create" pour signaler au serveur une création.
                                    var finalData = {
                                        username: credentials.username,
                                        password: credentials.password,
                                        annot: data,
                                        action: 'create'
                                    }
                                    //  On vérifie la connexion, si OK on envoie, si non on sauvegarde dans le todo propre au compte.
                                    if (socket.socket.connected) {
                                        appUI.engine.ico.emit();
                                        socket.emit('annot', finalData);
                                    } else {
                                        var todo = appUI.storage.core.get('todo');
                                        var todoElt = {};

                                        todoElt.function = "annot";
                                        todoElt.args = finalData;

                                        todo.push(todoElt);
                                        appUI.storage.core.set('todo', todo);
                                    }
                                }
                                //  Action à effectuer lorsqu'une annotation est éditée
                                if (action === "editer") {
                                    if (action2 === "ouvrir_texte") { //à l'ouverture du texte on note l'annotation comme lue
                                        data.lue = true;
                                    }

                                    for (var i in allAnnots) {
                                        if (allAnnots[i].id === data.id) {
                                            allAnnots.splice(i, 1);
                                        }
                                    }

                                    //unproper but working
                                    data.document_id = appUI.action.uuid;
                                    for (var i in appUI.finalAnnots) {
                                        if (appUI.finalAnnots[i].imgpagenum === Annotation.getConfig().page_en_cours) {
                                            data.imgpage_id = appUI.finalAnnots[i].id;
                                        }
                                    }
                                    allAnnots.push(data);

                                    appUI.storage.core.set('annotations', allAnnots);

                                    //  On prépare les données avec l'annotation créée sous forme d'un JSON avec les credentials et l'action "read" ou "edit" pour signaler au serveur une édition.
                                    var finalData = {
                                        username: credentials.username,
                                        password: credentials.password,
                                        annot: data,
                                        action: credentials.userId !== data.id_utilisateur ? 'read' : 'edit'
                                    }
                                    //  On vérifie la connexion, si OK on envoie, si non on sauvegarde dans le todo propre au compte.
                                    if (socket.socket.connected) {
                                        appUI.engine.ico.emit();
                                        socket.emit('annot', finalData);
                                    } else {
                                        var todo = appUI.storage.core.get('todo');
                                        var todoElt = {};

                                        todoElt.function = "annot";
                                        todoElt.args = finalData;

                                        todo.push(todoElt);
                                        appUI.storage.core.set('todo', todo);
                                    }
                                }
                                //  Action à effectuer lorsqu'une annotation est détruite.
                                if (action === "detruire") {

                                    for (var i in allAnnots) {
                                        if (allAnnots[i].id === data.id) {
                                            allAnnots.splice(i, 1);
                                        }
                                    }
                                    appUI.storage.core.set('annotations', allAnnots);
                                    //  On prépare les données avec l'annotation créée sous forme d'un JSON avec les credentials et l'action "erase" pour signaler au serveur une suppression.
                                    var finalData = {
                                        username: credentials.username,
                                        password: credentials.password,
                                        annot: data,
                                        action: 'erase'
                                    }
                                    //  On vérifie la connexion, si OK on envoie, si non on sauvegarde dans le todo propre au compte.
                                    if (socket.socket.connected) {
                                        appUI.engine.ico.emit();
                                        socket.emit('annot', finalData);
                                    } else {
                                        var todo = appUI.storage.core.get('todo');
                                        var todoElt = {};

                                        todoElt.function = "annot";
                                        todoElt.args = finalData;

                                        todo.push(todoElt);
                                        appUI.storage.core.set('todo', todo);
                                    }
                                }
                            },
                            /**
                             *  Surcharge la fonction existante dans annotations.js
                             *  @function fonction_ouverture_annotation
                             *  @param {JSObject} data
                             *  @description ... à la lecture des annotations
                             *  @return {Void}
                             **/                            
                            fonction_ouverture_annotation: function(data) {
                                //                                appUI.canSwipe++;
                                //                                $('body').swipe('disable');
                            },
                            /**
                             *  Surcharge la fonction existante dans annotations.js
                             *  @function fonction_fermeture_annotation
                             *  @description ... à la fermeture des annotations
                             *  @return {Void}
                             **/   
                            fonction_fermeture_annotation: function() {
                                if (appUI.canSwipe > 0) {
                                    appUI.canSwipe--;
                                }
                                if (appUI.canSwipe <= 0) {
                                    $('body').swipe('enable');
                                }
                            },
                            /**
                             *  Surcharge la fonction existante dans annotations.js
                             *  @function fonction_id
                             *  @param {Date} date
                             *  @param {String} id
                             *  @description Génère aléatoirement un identifiant
                             *  @return {String}
                             **/   
                            fonction_id: function(date, id) {
                                return appUI.genUUID();
                            }
                        });
                        //  réglage de scrolling par rapport à la taille du document
                        if ((hauteur + 70) < $(window).height()) {
                            Annotation.setConfig({zoom_limite_hauteur: 0});
                        }
                        //  récupération des annotations présentes en localStorage
                        Annotation.setSauvegarde(array_annotations);
                        Annotation.actualiser();
                        //  affichage de la première page
                        Annotation.afficher_page(1);
                        //  mise en place du div permettant le scroll et les animations de slide entre les pages
                        //  le setTimeout de 0 secondes sert à éviter des bugs de priorité sur certains navigateurs
                        setTimeout(function() {
                            Annotation.divIdelibre();
                        }, 0);
                        $('#menuBar').css('position', 'absolute');
                        //  redimensionnement de la scrollbar en fonction de la taille du document
                        scrollRedim();

                    };

                    var intervalInitAnnots = setInterval(function() {
                        if (appUI.finalAnnots.length === appUI.nbPagesProjetTotales) {
                            initAnnots();
                            clearInterval(intervalInitAnnots);
                            $('#divAnnotation').removeClass();
                        }
                    }, 200);

                },
                error: function(jqXHR, textStatus, errorThrown) {

                }
            });
        },
        error: function(jqXHR, textStatus, errorThrown) {

        }
    });
} catch (err) {
    appUI.notify(err);
}