<?php

/**
 * CakePHP WsClient Shell
 *
 * i-delibRE : le porte-document nomade des élus pour le suivi des séances délibérantes (https://adullact.net/projects/idelibre)
 *
 * PHP version 5
 * @author Stéphane Sampaio
 * @copyright Adullact Projet
 * @link http://adullact.org/
 * @license http://www.cecill.info/licences/Licence_CeCILL_V2-fr.txt CeCiLL v2
 *
 * SVN Informations
 * $Date: 2014-12-17 18:59:13 +0100 (mer. 17 déc. 2014) $
 * $Revision: 561 $
 * $Author: rdubourget $
 * $HeadURL: svn+ssh://rdubourget@scm.adullact.net/scmrepos/svn/idelibre/trunk/app/Console/Command/WsClientShell.php $
 * $Id: WsClientShell.php 561 2014-12-17 17:59:13Z rdubourget $
 *
 */
App::uses('ClassRegistry', 'Cake.Utility');

class WsClientShell extends AppShell {

    public function main() {

    }

    public function send() {
        $this->out('');
        $this->out('Envoi de convocation');
        $this->out('');


        $url = 'https://' . IDELIBRE_CURL_WSTEST_DOMAIN . '/seances.json';
        $file = IDELIBRE_CURL_WSTEST_FILE_EXEMPLE;
        
         

        $jsonData = array(
            'type_seance' => 'Commission permanente3 (wsclient)',
            'date_seance' => date('Y-m-d H:i' . (!empty($this->args[0]) && $this->args[0] === 'second' ? ':s' : '')) . (!empty($this->args[0]) && $this->args[0] === 'second' ? '' : ':00'),
            //'acteurs_convoques' => '[{"Acteur":{"id":38,"typeacteur_id":7,"nom":"GUILLAUME","prenom":"Didier","salutation":"Monsieur","titre":"Pr\\u00e9sident","position":1,"date_naissance":null,"adresse1":"","adresse2":"","cp":"","ville":"","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2011-05-05 14:47:31","modified":"2012-12-28 09:48:27","suppleant_id":2},"Typeacteur":{"elu":true}},{"Acteur":{"id":2,"typeacteur_id":7,"nom":"GREGOIRE","prenom":"Michel","salutation":"Monsieur","titre":"1ER Vice-President","position":2,"date_naissance":null,"adresse1":"","adresse2":"","cp":"26000","ville":"Buis-les-Baronnies","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2008-07-24 17:24:04","modified":"2012-12-28 09:48:47","suppleant_id":7},"Typeacteur":{"elu":true}},{"Acteur":{"id":30,"typeacteur_id":3,"nom":"FAIVRE-PIERRET","prenom":"Jean-Charles","salutation":"Monsieur","titre":"","position":30,"date_naissance":"1970-01-01","adresse1":"","adresse2":"","cp":"","ville":"Valence IV","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2008-07-24 17:44:35","modified":"2008-07-24 17:44:35","suppleant_id":null},"Typeacteur":{"elu":false}},{"Acteur":{"id":31,"typeacteur_id":3,"nom":"GILLES","prenom":"Andre","salutation":"Monsieur","titre":"","position":31,"date_naissance":"1970-01-01","adresse1":"","adresse2":"","cp":"","ville":"Marsanne","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2008-07-24 17:45:03","modified":"2008-07-24 17:45:03","suppleant_id":null},"Typeacteur":{"elu":false}},{"Acteur":{"id":34,"typeacteur_id":3,"nom":"MOUTON","prenom":"Marie-Pierre","salutation":"Madame","titre":"","position":34,"date_naissance":"1970-01-01","adresse1":"","adresse2":"","cp":"","ville":"Pierrelatte","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2008-07-24 17:46:33","modified":"2008-07-24 17:46:33","suppleant_id":null},"Typeacteur":{"elu":false}},{"Acteur":{"id":33,"typeacteur_id":3,"nom":"LIMONTA","prenom":"Fabien","salutation":"Monsieur","titre":"","position":999,"date_naissance":null,"adresse1":"","adresse2":"","cp":"","ville":"Saint-Paul-Trois-Chateaux","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2008-07-24 17:46:06","modified":"2010-10-19 16:29:50","suppleant_id":null},"Typeacteur":{"elu":false}}]',
            //ne passe pas (89 élus)
            'acteurs_convoques' => '[{"Acteur":{"id":75,"typeacteur_id":1,"nom":"GILLIET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":1,"date_naissance":"1964-10-30","adresse1":"17 impasse Gambetta","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"04 73 26 82 45","note":"cr\\u00e9\\u00e9 le 08\\/10\\/2013 (rempla\\u00e7ant Jacques BLAIZE)","actif":true,"created":"2012-05-02 14:45:54","modified":"2014-09-08 15:44:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":147,"typeacteur_id":1,"nom":"BELLEROSE","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":2,"date_naissance":null,"adresse1":"61 Rue du Chambon","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:10:09","modified":"2014-04-14 16:10:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":14,"typeacteur_id":1,"nom":"LAVILLE","prenom":"Didier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":3,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"Avenue Pierre de Coubertin","cp":"63510","ville":"AULNAT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:42","modified":"2014-03-27 16:31:52","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":148,"typeacteur_id":1,"nom":"SIMEON","prenom":"Marianne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":4,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63510","ville":"AULNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:07","modified":"2014-04-14 16:11:07","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":149,"typeacteur_id":1,"nom":"DUMEIL","prenom":"Alain","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":5,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:24","modified":"2014-09-08 15:44:37","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":150,"typeacteur_id":1,"nom":"FAYE","prenom":"Aline","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":6,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:52","modified":"2014-04-14 16:11:52","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":3,"typeacteur_id":1,"nom":"SAINT-ANDR\\u00c9","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":7,"date_naissance":null,"adresse1":"20 rue de l\'H\\u00f4tel de Ville ","adresse2":"BP 122","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:09:04","modified":"2014-09-08 15:37:47","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":151,"typeacteur_id":1,"nom":"BEYSSI","prenom":"Michel","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":8,"date_naissance":null,"adresse1":"523 rue des Vigeries","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:15","modified":"2014-09-08 15:44:57","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":152,"typeacteur_id":1,"nom":"FORTE-VIGIER","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":9,"date_naissance":null,"adresse1":"30 rue des Pivoines","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:49","modified":"2014-04-14 16:12:49","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":153,"typeacteur_id":1,"nom":"NEUVY","prenom":"Flavien","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":10,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"CEBAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:13:32","modified":"2014-09-08 15:45:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":154,"typeacteur_id":1,"nom":"CHALUS","prenom":"Jocelyne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":11,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"C\\u00c9BAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:08","modified":"2014-04-14 16:14:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":31,"typeacteur_id":1,"nom":"PRONONCE","prenom":"Herv\\u00e9","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":12,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:23","modified":"2014-09-08 15:42:18","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":35,"typeacteur_id":1,"nom":"BOLIS","prenom":"Jacqueline","salutation":"Madame ","titre":"Conseill\\u00e8re Communautaire","position":13,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:23:05","modified":"2014-03-27 17:02:54","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":155,"typeacteur_id":1,"nom":"MASSELOT","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":14,"date_naissance":null,"adresse1":"65 bis rue des Montagnards","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:31","modified":"2014-09-08 15:45:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":156,"typeacteur_id":1,"nom":"TROTE","prenom":"Marie-Jos\\u00e9","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":15,"date_naissance":null,"adresse1":"29 avenue de Charade","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:58","modified":"2014-04-14 16:14:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":33,"typeacteur_id":1,"nom":"GISCARD D\'ESTAING","prenom":"Louis","salutation":"Monsieur","titre":"2\\u00e8me Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":16,"date_naissance":null,"adresse1":"Maire de Chamali\\u00e8res","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:57","modified":"2014-09-12 14:58:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":157,"typeacteur_id":1,"nom":"LAVAL","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire ","position":17,"date_naissance":null,"adresse1":"8 Rue des Moulins","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:16","modified":"2014-04-14 16:15:16","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":158,"typeacteur_id":1,"nom":"LACROIX","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":18,"date_naissance":null,"adresse1":"116 Avenue Thermale","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:35","modified":"2014-04-14 16:15:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":159,"typeacteur_id":1,"nom":"DUVERT","prenom":"Julie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":19,"date_naissance":null,"adresse1":"59 Avenue de Royat","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:01","modified":"2014-04-14 16:16:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":160,"typeacteur_id":1,"nom":"BORDES","prenom":"Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":20,"date_naissance":null,"adresse1":"2bis Rue du Roc Blanc","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:19","modified":"2014-04-14 16:16:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":161,"typeacteur_id":1,"nom":"DARTEYRE","prenom":"Ren\\u00e9","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":21,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:51","modified":"2014-09-08 15:56:50","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":162,"typeacteur_id":1,"nom":"LEVET","prenom":"Annie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":22,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:17:31","modified":"2014-04-14 16:17:31","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":20,"typeacteur_id":1,"nom":"BIANCHI","prenom":"Olivier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":23,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:13:32","modified":"2014-03-27 16:34:35","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":12,"typeacteur_id":1,"nom":"DULAC-ROUGERIE","prenom":"Christine","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":24,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:23","modified":"2014-03-27 16:34:50","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":51,"typeacteur_id":1,"nom":"LAFFONT","prenom":"Alain","salutation":"Monsieur","titre":"Conseiller communautaire","position":25,"date_naissance":null,"adresse1":"18, rue du Ch\\u00e2teau des Vergnes","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:07","modified":"2014-03-27 17:00:56","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":52,"typeacteur_id":1,"nom":"VIGNAL","prenom":"Odile","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":26,"date_naissance":null,"adresse1":"38 rue de la Rotonde","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:23","modified":"2014-03-27 16:35:04","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":163,"typeacteur_id":1,"nom":"CINEUX","prenom":"Cyril","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":27,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:26","modified":"2014-09-08 15:48:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":164,"typeacteur_id":1,"nom":"GUILHOT","prenom":"Patricia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":28,"date_naissance":null,"adresse1":"1 avenue Barbier Daubr\\u00e9e","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:53","modified":"2014-04-14 16:18:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":93,"typeacteur_id":1,"nom":"BERNARD","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller communautaire","position":29,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:21","modified":"2014-04-14 17:00:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":165,"typeacteur_id":1,"nom":"EL HAFIDHI","prenom":"Sond\\u00e8s","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":30,"date_naissance":null,"adresse1":"18 rue des Gras","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:19:48","modified":"2014-04-14 16:19:48","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":166,"typeacteur_id":1,"nom":"AUSLENDER","prenom":"J\\u00e9r\\u00f4me","salutation":"Monsieur","titre":"Conseiller Communautaire","position":31,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:08","modified":"2014-04-14 16:21:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":104,"typeacteur_id":1,"nom":"NOUHEN","prenom":"Fran\\u00e7oise","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":32,"date_naissance":null,"adresse1":"44, rue Eug\\u00e8ne Gilbert","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:30","modified":"2014-04-14 17:00:00","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":167,"typeacteur_id":1,"nom":"BONNET","prenom":"Nicolas","salutation":"Monsieur","titre":"Conseiller Communautaire","position":33,"date_naissance":null,"adresse1":"2 bis rue de la Pr\\u00e9v\\u00f4t\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:44","modified":"2014-04-14 16:21:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":168,"typeacteur_id":1,"nom":"GALLAIS","prenom":"Magali","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":34,"date_naissance":null,"adresse1":"4 bis rue du 8 mai 1945","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:22:59","modified":"2014-04-14 16:22:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":169,"typeacteur_id":1,"nom":"NARANJO","prenom":"Florent","salutation":"Monsieur","titre":"Conseiller Communautaire","position":35,"date_naissance":null,"adresse1":"19 avenue de la R\\u00e9publique","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:01","modified":"2014-04-14 16:24:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":39,"typeacteur_id":1,"nom":"AUDET","prenom":"C\\u00e9cile","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":36,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:25:01","modified":"2014-03-27 16:37:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":170,"typeacteur_id":1,"nom":"BARA","prenom":"Sa\\u00efd","salutation":"Monsieur","titre":"Conseiller Communautaire","position":37,"date_naissance":null,"adresse1":"11 rue Gr\\u00e9goire de Tours","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:35","modified":"2014-04-14 16:24:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":95,"typeacteur_id":1,"nom":"LAVEST","prenom":"Isabelle","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":38,"date_naissance":null,"adresse1":"37, rue Montlosier","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-2020","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:48","modified":"2014-04-14 17:00:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":171,"typeacteur_id":1,"nom":"POURRET","prenom":"Simon","salutation":"Monsieur","titre":"Conseiller Communautaire","position":39,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:05","modified":"2014-04-14 16:25:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":172,"typeacteur_id":1,"nom":"BRIAT","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":40,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:41","modified":"2014-04-14 16:25:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":173,"typeacteur_id":1,"nom":"BOHELAY","prenom":"Philippe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":41,"date_naissance":null,"adresse1":"44 bis rue du Creux Rouge","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:02","modified":"2014-04-14 16:26:02","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":174,"typeacteur_id":1,"nom":"PRIEUX","prenom":"Nicole","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":42,"date_naissance":null,"adresse1":"76 rue de Nohanent","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:36","modified":"2014-04-14 16:26:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":15,"typeacteur_id":1,"nom":"ADENOT","prenom":"Dominique","salutation":"Monsieur","titre":"Conseiller Communautaire","position":43,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:57","modified":"2014-09-08 15:50:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":175,"typeacteur_id":1,"nom":"ROGUE-SALLARD","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":44,"date_naissance":null,"adresse1":"10 rue de la Treille","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:27:09","modified":"2014-04-14 16:27:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":176,"typeacteur_id":1,"nom":"CERVANTES","prenom":"Jean-Christophe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":45,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:03","modified":"2014-04-14 16:29:03","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":177,"typeacteur_id":1,"nom":"TARDIEU","prenom":"Sylviane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":46,"date_naissance":null,"adresse1":"73 rue Viviani","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:44","modified":"2014-04-14 16:29:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":178,"typeacteur_id":1,"nom":"GUITTARD","prenom":"Pascal","salutation":"Monsieur","titre":"Conseiller Communautaire","position":47,"date_naissance":null,"adresse1":"18 rue du Onze Novembre","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:12","modified":"2014-04-14 16:30:12","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":179,"typeacteur_id":1,"nom":"BERNARD","prenom":"Val\\u00e9rie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":48,"date_naissance":null,"adresse1":"47 rue de la Volont\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:34","modified":"2014-04-14 16:30:34","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":180,"typeacteur_id":1,"nom":"VIMONT","prenom":"Guillaume","salutation":"Monsieur","titre":"Conseiller Communautaire","position":49,"date_naissance":null,"adresse1":"12 rue de Riom","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:59","modified":"2014-04-14 16:30:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":181,"typeacteur_id":1,"nom":"CANALES","prenom":"Marion","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":50,"date_naissance":null,"adresse1":"42 avenue des \\u00c9tats-Unis","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:31:26","modified":"2014-04-14 16:31:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":182,"typeacteur_id":1,"nom":"BOHNER","prenom":"G\\u00e9rard","salutation":"Monsieur","titre":"Conseiller Communautaire","position":51,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:26","modified":"2014-04-14 16:32:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":183,"typeacteur_id":1,"nom":"BRENAS","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":52,"date_naissance":null,"adresse1":"11 avenue Carnot","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:55","modified":"2014-04-14 16:32:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":184,"typeacteur_id":1,"nom":"CANDELIER","prenom":"\\u00c9dith","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":53,"date_naissance":null,"adresse1":"41 avenue des Cottages","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:33:24","modified":"2014-04-14 16:33:24","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":185,"typeacteur_id":1,"nom":"LAVIGNE","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":54,"date_naissance":null,"adresse1":"41 avenue Joseph Agid","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:34:53","modified":"2014-04-14 16:34:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":186,"typeacteur_id":1,"nom":"GUERMIT-MAFFRE","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":55,"date_naissance":null,"adresse1":"36 rue du Capricorne","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:35:27","modified":"2014-04-14 16:35:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":187,"typeacteur_id":1,"nom":"BARRI\\u00c8RE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":56,"date_naissance":null,"adresse1":"57 rue Drelon","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:05","modified":"2014-04-14 16:37:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":188,"typeacteur_id":1,"nom":"JALICON","prenom":"Christiane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":57,"date_naissance":null,"adresse1":"R\\u00e9sidence Topaze, B\\u00e2t D - 8 Rue d\'Orcines","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:33","modified":"2014-04-14 16:37:33","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":189,"typeacteur_id":1,"nom":"MULLER","prenom":"Didier","salutation":"Monsieur","titre":"Conseiller Communautaire","position":58,"date_naissance":null,"adresse1":"1 rue Abb\\u00e9 Lacoste","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:56","modified":"2014-04-14 16:37:56","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":190,"typeacteur_id":1,"nom":"BASTIEN","prenom":"G\\u00e9raldine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":59,"date_naissance":null,"adresse1":"15 rue Jeanne d\'Arc","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:15","modified":"2014-04-14 16:38:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":191,"typeacteur_id":1,"nom":"RECHAGNEUX","prenom":"Antoine","salutation":"Monsieur","titre":"Conseiller Communautaire","position":60,"date_naissance":null,"adresse1":"6 rue des Portes d\'Argent","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:45","modified":"2014-04-14 16:38:45","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":192,"typeacteur_id":1,"nom":"FAUROT","prenom":"Anne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":61,"date_naissance":null,"adresse1":"Lieu-dit Outre","adresse2":"","cp":"63440","ville":"MARCILLAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:39:13","modified":"2014-04-14 16:39:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":2,"typeacteur_id":1,"nom":"PASCIUTO","prenom":"Bertrand","salutation":"Monsieur","titre":"1er Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":62,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville - Place de la Mairie","adresse2":"BP 158","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:07:30","modified":"2014-09-08 15:51:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":193,"typeacteur_id":1,"nom":"POUILLE","prenom":"Monique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":63,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:39:34","modified":"2014-04-14 16:39:34","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":57,"typeacteur_id":1,"nom":"ARNAL","prenom":"Olivier","salutation":"Monsieur","titre":"Conseiller Communautaire","position":64,"date_naissance":null,"adresse1":"35, rue des Pervenches","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:30:21","modified":"2014-03-27 17:01:29","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":59,"typeacteur_id":1,"nom":"JOYEUX","prenom":"Claire","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":65,"date_naissance":null,"adresse1":"4, rue Saint Verny","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:30:56","modified":"2014-03-27 17:01:39","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":21,"typeacteur_id":1,"nom":"RAGE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":66,"date_naissance":null,"adresse1":"95, Avenue Georges Cl\\u00e9menceau","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:14:00","modified":"2014-03-27 16:34:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":194,"typeacteur_id":1,"nom":"RENAUD","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":67,"date_naissance":null,"adresse1":"7 Avenue Mar\\u00e9chal Joffre ","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:40:04","modified":"2014-04-14 16:40:04","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":195,"typeacteur_id":1,"nom":"SABRE","prenom":"Michel","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":68,"date_naissance":null,"adresse1":"1 avenue Pontgibaud","adresse2":"","cp":"63830","ville":"DURTOL","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:40:30","modified":"2014-09-08 15:51:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":196,"typeacteur_id":1,"nom":"RAYNAL","prenom":"Marie-Jeanne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":69,"date_naissance":null,"adresse1":"6 route de Ternant","adresse2":"","cp":"63830","ville":"DURTOL","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:42:41","modified":"2014-04-14 16:42:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":197,"typeacteur_id":1,"nom":"ALBISETTI","prenom":"Jean","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":70,"date_naissance":null,"adresse1":"20 bis petite rue du Pont des Ch\\u00e8vres","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:43:16","modified":"2014-09-08 15:52:32","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":198,"typeacteur_id":1,"nom":"TEYSSIER","prenom":"Yvette","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":71,"date_naissance":null,"adresse1":"7 rue Jean Moulin","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:43:45","modified":"2014-04-14 16:43:45","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":199,"typeacteur_id":1,"nom":"L\\u00c9P\\u00c9E","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller Communautaire","position":72,"date_naissance":null,"adresse1":"3 rue Jean Jaur\\u00e8s","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:44:41","modified":"2014-04-14 16:44:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":200,"typeacteur_id":1,"nom":"GISSELBRECHT","prenom":"Henri","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":73,"date_naissance":null,"adresse1":"3 Rue du Ch\\u00e2teau d\'Eau","adresse2":"","cp":"63370","ville":"LEMPDES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:45:12","modified":"2014-09-08 15:53:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":201,"typeacteur_id":1,"nom":"MISIC","prenom":"Danielle","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":74,"date_naissance":null,"adresse1":"30 Rue des Tilleuls","adresse2":"","cp":"63370","ville":"LEMPDES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:45:37","modified":"2014-04-14 16:45:37","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":202,"typeacteur_id":1,"nom":"GANET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":75,"date_naissance":null,"adresse1":"9 Rue de la Garenne ","adresse2":"","cp":"63830","ville":"NOHANENT\\u00a0","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:00","modified":"2014-09-08 15:53:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":203,"typeacteur_id":1,"nom":"MICHEL","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":76,"date_naissance":null,"adresse1":"20 All\\u00e9e des Amandiers","adresse2":"","cp":"63830","ville":"NOHANENT\\u00a0","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:23","modified":"2014-04-14 16:46:23","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":64,"typeacteur_id":1,"nom":"MORVAN","prenom":"Jean-Marc","salutation":"Monsieur","titre":"Conseiller Communautaire","position":77,"date_naissance":null,"adresse1":"9 Chemin du Clos \\u2013 Ternant","adresse2":"","cp":"63870","ville":"ORCINES","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:32:50","modified":"2014-05-26 12:06:18","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":205,"typeacteur_id":1,"nom":"PRIEUR","prenom":"V\\u00e9ronique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":78,"date_naissance":null,"adresse1":"10, rue de la Riveux - Ternant","adresse2":"","cp":"63870","ville":"ORCINES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:47:13","modified":"2014-04-14 16:47:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":17,"typeacteur_id":1,"nom":"RIOL","prenom":"Pierre","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":79,"date_naissance":null,"adresse1":"15, rue Marcel Magard","adresse2":"","cp":"63170","ville":"PERIGNAT LES SARLIEVE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:12:40","modified":"2014-03-27 16:33:59","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":129,"typeacteur_id":1,"nom":"GALLIOT","prenom":"Blandine","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":80,"date_naissance":null,"adresse1":"2, Impasse Saint Exup\\u00e9ry","adresse2":"","cp":"63170","ville":"PERIGNAT LES SARLIEVE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:07:23","modified":"2014-04-14 17:00:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":22,"typeacteur_id":1,"nom":"VINZIO","prenom":"Ren\\u00e9","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":81,"date_naissance":null,"adresse1":"Place de l\'H\\u00f4tel de Ville","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:14:19","modified":"2014-03-27 16:34:07","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":204,"typeacteur_id":1,"nom":"FAUCHER","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":82,"date_naissance":null,"adresse1":"Rue Saint Michel","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:55","modified":"2014-04-14 16:46:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":206,"typeacteur_id":1,"nom":"MIRAND","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":83,"date_naissance":null,"adresse1":"Chemin du Pont d\'Aval","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:48:10","modified":"2014-04-14 16:48:10","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":207,"typeacteur_id":1,"nom":"BRUNMUROL","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":84,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:03","modified":"2014-09-08 15:55:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":208,"typeacteur_id":1,"nom":"LELI\\u00c8VRE","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":85,"date_naissance":null,"adresse1":"23 Rue de Mozart","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:38","modified":"2014-04-14 16:49:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":70,"typeacteur_id":1,"nom":"ALEDO","prenom":"Marcel","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":86,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"46, Boulevard Barrieu","cp":"63130","ville":"ROYAT","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:34:41","modified":"2014-09-08 15:55:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":103,"typeacteur_id":1,"nom":"PRACROS","prenom":"Claude","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":87,"date_naissance":null,"adresse1":"18, Avenue Anatole France","adresse2":"","cp":"63130","ville":"ROYAT","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:23","modified":"2014-04-14 17:00:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":11,"typeacteur_id":1,"nom":"GARDES","prenom":"Roger","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":88,"date_naissance":null,"adresse1":"12, route d\'Orcines","adresse2":"","cp":"63122","ville":"SAINT GENES CHAMPANELLE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:19","modified":"2014-03-27 16:34:22","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":101,"typeacteur_id":1,"nom":"DESEMARD","prenom":"Agn\\u00e8s","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":89,"date_naissance":null,"adresse1":"2, Impasse de la Forge","adresse2":"","cp":"63122","ville":"THEIX","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:00:16","modified":"2014-04-14 17:00:21","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}}]',
          //  'acteurs_convoques' => '[{"Acteur":{"id":75,"typeacteur_id":1,"nom":"GILLIET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":1,"date_naissance":"1964-10-30","adresse1":"17 impasse Gambetta","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"04 73 26 82 45","note":"cr\\u00e9\\u00e9 le 08\\/10\\/2013 (rempla\\u00e7ant Jacques BLAIZE)","actif":true,"created":"2012-05-02 14:45:54","modified":"2014-09-08 15:44:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":147,"typeacteur_id":1,"nom":"BELLEROSE","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":2,"date_naissance":null,"adresse1":"61 Rue du Chambon","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:10:09","modified":"2014-04-14 16:10:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":14,"typeacteur_id":1,"nom":"LAVILLE","prenom":"Didier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":3,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"Avenue Pierre de Coubertin","cp":"63510","ville":"AULNAT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:42","modified":"2014-03-27 16:31:52","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":148,"typeacteur_id":1,"nom":"SIMEON","prenom":"Marianne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":4,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63510","ville":"AULNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:07","modified":"2014-04-14 16:11:07","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":149,"typeacteur_id":1,"nom":"DUMEIL","prenom":"Alain","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":5,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:24","modified":"2014-09-08 15:44:37","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":150,"typeacteur_id":1,"nom":"FAYE","prenom":"Aline","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":6,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:52","modified":"2014-04-14 16:11:52","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":3,"typeacteur_id":1,"nom":"SAINT-ANDR\\u00c9","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":7,"date_naissance":null,"adresse1":"20 rue de l\'H\\u00f4tel de Ville ","adresse2":"BP 122","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:09:04","modified":"2014-09-08 15:37:47","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":151,"typeacteur_id":1,"nom":"BEYSSI","prenom":"Michel","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":8,"date_naissance":null,"adresse1":"523 rue des Vigeries","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:15","modified":"2014-09-08 15:44:57","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":152,"typeacteur_id":1,"nom":"FORTE-VIGIER","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":9,"date_naissance":null,"adresse1":"30 rue des Pivoines","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:49","modified":"2014-04-14 16:12:49","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":153,"typeacteur_id":1,"nom":"NEUVY","prenom":"Flavien","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":10,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"CEBAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:13:32","modified":"2014-09-08 15:45:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":154,"typeacteur_id":1,"nom":"CHALUS","prenom":"Jocelyne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":11,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"C\\u00c9BAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:08","modified":"2014-04-14 16:14:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":31,"typeacteur_id":1,"nom":"PRONONCE","prenom":"Herv\\u00e9","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":12,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:23","modified":"2014-09-08 15:42:18","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":35,"typeacteur_id":1,"nom":"BOLIS","prenom":"Jacqueline","salutation":"Madame ","titre":"Conseill\\u00e8re Communautaire","position":13,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:23:05","modified":"2014-03-27 17:02:54","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":155,"typeacteur_id":1,"nom":"MASSELOT","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":14,"date_naissance":null,"adresse1":"65 bis rue des Montagnards","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:31","modified":"2014-09-08 15:45:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":156,"typeacteur_id":1,"nom":"TROTE","prenom":"Marie-Jos\\u00e9","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":15,"date_naissance":null,"adresse1":"29 avenue de Charade","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:58","modified":"2014-04-14 16:14:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":33,"typeacteur_id":1,"nom":"GISCARD D\'ESTAING","prenom":"Louis","salutation":"Monsieur","titre":"2\\u00e8me Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":16,"date_naissance":null,"adresse1":"Maire de Chamali\\u00e8res","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:57","modified":"2014-09-12 14:58:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":157,"typeacteur_id":1,"nom":"LAVAL","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire ","position":17,"date_naissance":null,"adresse1":"8 Rue des Moulins","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:16","modified":"2014-04-14 16:15:16","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":158,"typeacteur_id":1,"nom":"LACROIX","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":18,"date_naissance":null,"adresse1":"116 Avenue Thermale","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:35","modified":"2014-04-14 16:15:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":159,"typeacteur_id":1,"nom":"DUVERT","prenom":"Julie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":19,"date_naissance":null,"adresse1":"59 Avenue de Royat","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:01","modified":"2014-04-14 16:16:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":160,"typeacteur_id":1,"nom":"BORDES","prenom":"Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":20,"date_naissance":null,"adresse1":"2bis Rue du Roc Blanc","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:19","modified":"2014-04-14 16:16:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":161,"typeacteur_id":1,"nom":"DARTEYRE","prenom":"Ren\\u00e9","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":21,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:51","modified":"2014-09-08 15:56:50","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":162,"typeacteur_id":1,"nom":"LEVET","prenom":"Annie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":22,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:17:31","modified":"2014-04-14 16:17:31","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":20,"typeacteur_id":1,"nom":"BIANCHI","prenom":"Olivier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":23,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:13:32","modified":"2014-03-27 16:34:35","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":12,"typeacteur_id":1,"nom":"DULAC-ROUGERIE","prenom":"Christine","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":24,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:23","modified":"2014-03-27 16:34:50","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":51,"typeacteur_id":1,"nom":"LAFFONT","prenom":"Alain","salutation":"Monsieur","titre":"Conseiller communautaire","position":25,"date_naissance":null,"adresse1":"18, rue du Ch\\u00e2teau des Vergnes","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:07","modified":"2014-03-27 17:00:56","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":52,"typeacteur_id":1,"nom":"VIGNAL","prenom":"Odile","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":26,"date_naissance":null,"adresse1":"38 rue de la Rotonde","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:23","modified":"2014-03-27 16:35:04","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":163,"typeacteur_id":1,"nom":"CINEUX","prenom":"Cyril","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":27,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:26","modified":"2014-09-08 15:48:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":164,"typeacteur_id":1,"nom":"GUILHOT","prenom":"Patricia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":28,"date_naissance":null,"adresse1":"1 avenue Barbier Daubr\\u00e9e","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:53","modified":"2014-04-14 16:18:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":93,"typeacteur_id":1,"nom":"BERNARD","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller communautaire","position":29,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:21","modified":"2014-04-14 17:00:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":165,"typeacteur_id":1,"nom":"EL HAFIDHI","prenom":"Sond\\u00e8s","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":30,"date_naissance":null,"adresse1":"18 rue des Gras","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:19:48","modified":"2014-04-14 16:19:48","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":166,"typeacteur_id":1,"nom":"AUSLENDER","prenom":"J\\u00e9r\\u00f4me","salutation":"Monsieur","titre":"Conseiller Communautaire","position":31,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:08","modified":"2014-04-14 16:21:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":104,"typeacteur_id":1,"nom":"NOUHEN","prenom":"Fran\\u00e7oise","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":32,"date_naissance":null,"adresse1":"44, rue Eug\\u00e8ne Gilbert","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:30","modified":"2014-04-14 17:00:00","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":167,"typeacteur_id":1,"nom":"BONNET","prenom":"Nicolas","salutation":"Monsieur","titre":"Conseiller Communautaire","position":33,"date_naissance":null,"adresse1":"2 bis rue de la Pr\\u00e9v\\u00f4t\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:44","modified":"2014-04-14 16:21:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":168,"typeacteur_id":1,"nom":"GALLAIS","prenom":"Magali","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":34,"date_naissance":null,"adresse1":"4 bis rue du 8 mai 1945","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:22:59","modified":"2014-04-14 16:22:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":169,"typeacteur_id":1,"nom":"NARANJO","prenom":"Florent","salutation":"Monsieur","titre":"Conseiller Communautaire","position":35,"date_naissance":null,"adresse1":"19 avenue de la R\\u00e9publique","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:01","modified":"2014-04-14 16:24:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":39,"typeacteur_id":1,"nom":"AUDET","prenom":"C\\u00e9cile","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":36,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:25:01","modified":"2014-03-27 16:37:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":170,"typeacteur_id":1,"nom":"BARA","prenom":"Sa\\u00efd","salutation":"Monsieur","titre":"Conseiller Communautaire","position":37,"date_naissance":null,"adresse1":"11 rue Gr\\u00e9goire de Tours","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:35","modified":"2014-04-14 16:24:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":95,"typeacteur_id":1,"nom":"LAVEST","prenom":"Isabelle","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":38,"date_naissance":null,"adresse1":"37, rue Montlosier","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-2020","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:48","modified":"2014-04-14 17:00:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":171,"typeacteur_id":1,"nom":"POURRET","prenom":"Simon","salutation":"Monsieur","titre":"Conseiller Communautaire","position":39,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:05","modified":"2014-04-14 16:25:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":172,"typeacteur_id":1,"nom":"BRIAT","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":40,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:41","modified":"2014-04-14 16:25:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":173,"typeacteur_id":1,"nom":"BOHELAY","prenom":"Philippe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":41,"date_naissance":null,"adresse1":"44 bis rue du Creux Rouge","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:02","modified":"2014-04-14 16:26:02","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":174,"typeacteur_id":1,"nom":"PRIEUX","prenom":"Nicole","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":42,"date_naissance":null,"adresse1":"76 rue de Nohanent","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:36","modified":"2014-04-14 16:26:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":15,"typeacteur_id":1,"nom":"ADENOT","prenom":"Dominique","salutation":"Monsieur","titre":"Conseiller Communautaire","position":43,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:57","modified":"2014-09-08 15:50:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":175,"typeacteur_id":1,"nom":"ROGUE-SALLARD","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":44,"date_naissance":null,"adresse1":"10 rue de la Treille","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:27:09","modified":"2014-04-14 16:27:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":176,"typeacteur_id":1,"nom":"CERVANTES","prenom":"Jean-Christophe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":45,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:03","modified":"2014-04-14 16:29:03","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":177,"typeacteur_id":1,"nom":"TARDIEU","prenom":"Sylviane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":46,"date_naissance":null,"adresse1":"73 rue Viviani","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:44","modified":"2014-04-14 16:29:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":178,"typeacteur_id":1,"nom":"GUITTARD","prenom":"Pascal","salutation":"Monsieur","titre":"Conseiller Communautaire","position":47,"date_naissance":null,"adresse1":"18 rue du Onze Novembre","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:12","modified":"2014-04-14 16:30:12","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":179,"typeacteur_id":1,"nom":"BERNARD","prenom":"Val\\u00e9rie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":48,"date_naissance":null,"adresse1":"47 rue de la Volont\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:34","modified":"2014-04-14 16:30:34","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":180,"typeacteur_id":1,"nom":"VIMONT","prenom":"Guillaume","salutation":"Monsieur","titre":"Conseiller Communautaire","position":49,"date_naissance":null,"adresse1":"12 rue de Riom","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:59","modified":"2014-04-14 16:30:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":181,"typeacteur_id":1,"nom":"CANALES","prenom":"Marion","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":50,"date_naissance":null,"adresse1":"42 avenue des \\u00c9tats-Unis","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:31:26","modified":"2014-04-14 16:31:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":182,"typeacteur_id":1,"nom":"BOHNER","prenom":"G\\u00e9rard","salutation":"Monsieur","titre":"Conseiller Communautaire","position":51,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:26","modified":"2014-04-14 16:32:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":183,"typeacteur_id":1,"nom":"BRENAS","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":52,"date_naissance":null,"adresse1":"11 avenue Carnot","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:55","modified":"2014-04-14 16:32:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":184,"typeacteur_id":1,"nom":"CANDELIER","prenom":"\\u00c9dith","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":53,"date_naissance":null,"adresse1":"41 avenue des Cottages","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:33:24","modified":"2014-04-14 16:33:24","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":185,"typeacteur_id":1,"nom":"LAVIGNE","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":54,"date_naissance":null,"adresse1":"41 avenue Joseph Agid","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:34:53","modified":"2014-04-14 16:34:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":186,"typeacteur_id":1,"nom":"GUERMIT-MAFFRE","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":55,"date_naissance":null,"adresse1":"36 rue du Capricorne","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:35:27","modified":"2014-04-14 16:35:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":187,"typeacteur_id":1,"nom":"BARRI\\u00c8RE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":56,"date_naissance":null,"adresse1":"57 rue Drelon","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:05","modified":"2014-04-14 16:37:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":188,"typeacteur_id":1,"nom":"JALICON","prenom":"Christiane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":57,"date_naissance":null,"adresse1":"R\\u00e9sidence Topaze, B\\u00e2t D - 8 Rue d\'Orcines","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:33","modified":"2014-04-14 16:37:33","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":189,"typeacteur_id":1,"nom":"MULLER","prenom":"Didier","salutation":"Monsieur","titre":"Conseiller Communautaire","position":58,"date_naissance":null,"adresse1":"1 rue Abb\\u00e9 Lacoste","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:56","modified":"2014-04-14 16:37:56","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":190,"typeacteur_id":1,"nom":"BASTIEN","prenom":"G\\u00e9raldine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":59,"date_naissance":null,"adresse1":"15 rue Jeanne d\'Arc","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:15","modified":"2014-04-14 16:38:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":191,"typeacteur_id":1,"nom":"RECHAGNEUX","prenom":"Antoine","salutation":"Monsieur","titre":"Conseiller Communautaire","position":60,"date_naissance":null,"adresse1":"6 rue des Portes d\'Argent","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:45","modified":"2014-04-14 16:38:45","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":192,"typeacteur_id":1,"nom":"FAUROT","prenom":"Anne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":61,"date_naissance":null,"adresse1":"Lieu-dit Outre","adresse2":"","cp":"63440","ville":"MARCILLAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:39:13","modified":"2014-04-14 16:39:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":2,"typeacteur_id":1,"nom":"PASCIUTO","prenom":"Bertrand","salutation":"Monsieur","titre":"1er Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":62,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville - Place de la Mairie","adresse2":"BP 158","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:07:30","modified":"2014-09-08 15:51:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":193,"typeacteur_id":1,"nom":"POUILLE","prenom":"Monique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":63,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:39:34","modified":"2014-04-14 16:39:34","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":57,"typeacteur_id":1,"nom":"ARNAL","prenom":"Olivier","salutation":"Monsieur","titre":"Conseiller Communautaire","position":64,"date_naissance":null,"adresse1":"35, rue des Pervenches","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:30:21","modified":"2014-03-27 17:01:29","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":59,"typeacteur_id":1,"nom":"JOYEUX","prenom":"Claire","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":65,"date_naissance":null,"adresse1":"4, rue Saint Verny","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:30:56","modified":"2014-03-27 17:01:39","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":21,"typeacteur_id":1,"nom":"RAGE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":66,"date_naissance":null,"adresse1":"95, Avenue Georges Cl\\u00e9menceau","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:14:00","modified":"2014-03-27 16:34:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":194,"typeacteur_id":1,"nom":"RENAUD","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":67,"date_naissance":null,"adresse1":"7 Avenue Mar\\u00e9chal Joffre ","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:40:04","modified":"2014-04-14 16:40:04","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":195,"typeacteur_id":1,"nom":"SABRE","prenom":"Michel","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":68,"date_naissance":null,"adresse1":"1 avenue Pontgibaud","adresse2":"","cp":"63830","ville":"DURTOL","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:40:30","modified":"2014-09-08 15:51:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":196,"typeacteur_id":1,"nom":"RAYNAL","prenom":"Marie-Jeanne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":69,"date_naissance":null,"adresse1":"6 route de Ternant","adresse2":"","cp":"63830","ville":"DURTOL","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:42:41","modified":"2014-04-14 16:42:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":197,"typeacteur_id":1,"nom":"ALBISETTI","prenom":"Jean","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":70,"date_naissance":null,"adresse1":"20 bis petite rue du Pont des Ch\\u00e8vres","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:43:16","modified":"2014-09-08 15:52:32","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":198,"typeacteur_id":1,"nom":"TEYSSIER","prenom":"Yvette","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":71,"date_naissance":null,"adresse1":"7 rue Jean Moulin","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:43:45","modified":"2014-04-14 16:43:45","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":199,"typeacteur_id":1,"nom":"L\\u00c9P\\u00c9E","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller Communautaire","position":72,"date_naissance":null,"adresse1":"3 rue Jean Jaur\\u00e8s","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:44:41","modified":"2014-04-14 16:44:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":200,"typeacteur_id":1,"nom":"GISSELBRECHT","prenom":"Henri","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":73,"date_naissance":null,"adresse1":"3 Rue du Ch\\u00e2teau d\'Eau","adresse2":"","cp":"63370","ville":"LEMPDES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:45:12","modified":"2014-09-08 15:53:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":201,"typeacteur_id":1,"nom":"MISIC","prenom":"Danielle","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":74,"date_naissance":null,"adresse1":"30 Rue des Tilleuls","adresse2":"","cp":"63370","ville":"LEMPDES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:45:37","modified":"2014-04-14 16:45:37","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":202,"typeacteur_id":1,"nom":"GANET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":75,"date_naissance":null,"adresse1":"9 Rue de la Garenne ","adresse2":"","cp":"63830","ville":"NOHANENT\\u00a0","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:00","modified":"2014-09-08 15:53:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":203,"typeacteur_id":1,"nom":"MICHEL","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":76,"date_naissance":null,"adresse1":"20 All\\u00e9e des Amandiers","adresse2":"","cp":"63830","ville":"NOHANENT\\u00a0","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:23","modified":"2014-04-14 16:46:23","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":64,"typeacteur_id":1,"nom":"MORVAN","prenom":"Jean-Marc","salutation":"Monsieur","titre":"Conseiller Communautaire","position":77,"date_naissance":null,"adresse1":"9 Chemin du Clos \\u2013 Ternant","adresse2":"","cp":"63870","ville":"ORCINES","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:32:50","modified":"2014-05-26 12:06:18","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":205,"typeacteur_id":1,"nom":"PRIEUR","prenom":"V\\u00e9ronique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":78,"date_naissance":null,"adresse1":"10, rue de la Riveux - Ternant","adresse2":"","cp":"63870","ville":"ORCINES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:47:13","modified":"2014-04-14 16:47:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":17,"typeacteur_id":1,"nom":"RIOL","prenom":"Pierre","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":79,"date_naissance":null,"adresse1":"15, rue Marcel Magard","adresse2":"","cp":"63170","ville":"PERIGNAT LES SARLIEVE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:12:40","modified":"2014-03-27 16:33:59","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":129,"typeacteur_id":1,"nom":"GALLIOT","prenom":"Blandine","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":80,"date_naissance":null,"adresse1":"2, Impasse Saint Exup\\u00e9ry","adresse2":"","cp":"63170","ville":"PERIGNAT LES SARLIEVE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:07:23","modified":"2014-04-14 17:00:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":22,"typeacteur_id":1,"nom":"VINZIO","prenom":"Ren\\u00e9","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":81,"date_naissance":null,"adresse1":"Place de l\'H\\u00f4tel de Ville","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:14:19","modified":"2014-03-27 16:34:07","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":204,"typeacteur_id":1,"nom":"FAUCHER","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":82,"date_naissance":null,"adresse1":"Rue Saint Michel","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:55","modified":"2014-04-14 16:46:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":206,"typeacteur_id":1,"nom":"MIRAND","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":83,"date_naissance":null,"adresse1":"Chemin du Pont d\'Aval","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:48:10","modified":"2014-04-14 16:48:10","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":207,"typeacteur_id":1,"nom":"BRUNMUROL","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":84,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:03","modified":"2014-09-08 15:55:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":208,"typeacteur_id":1,"nom":"LELI\\u00c8VRE","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":85,"date_naissance":null,"adresse1":"23 Rue de Mozart","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:38","modified":"2014-04-14 16:49:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":70,"typeacteur_id":1,"nom":"ALEDO","prenom":"Marcel","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":86,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"46, Boulevard Barrieu","cp":"63130","ville":"ROYAT","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:34:41","modified":"2014-09-08 15:55:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":103,"typeacteur_id":1,"nom":"PRACROS","prenom":"Claude","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":87,"date_naissance":null,"adresse1":"18, Avenue Anatole France","adresse2":"","cp":"63130","ville":"ROYAT","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:23","modified":"2014-04-14 17:00:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":11,"typeacteur_id":1,"nom":"GARDES","prenom":"Roger","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":88,"date_naissance":null,"adresse1":"12, route d\'Orcines","adresse2":"","cp":"63122","ville":"SAINT GENES CHAMPANELLE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:19","modified":"2014-03-27 16:34:22","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":101,"typeacteur_id":1,"nom":"DESEMARD","prenom":"Agn\\u00e8s","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":89,"date_naissance":null,"adresse1":"2, Impasse de la Forge","adresse2":"","cp":"63122","ville":"THEIX","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:00:16","modified":"2014-04-14 17:00:21","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}}]',
            //passe (24c elus)
            //'acteurs_convoques' =>  '[{"Acteur":{"id":3,"typeacteur_id":1,"nom":"SAINT-ANDR\\u00c9","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":7,"date_naissance":null,"adresse1":"20 rue de l\'H\\u00f4tel de Ville ","adresse2":"BP 122","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:09:04","modified":"2014-09-08 15:37:47","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":153,"typeacteur_id":1,"nom":"NEUVY","prenom":"Flavien","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":10,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"CEBAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:13:32","modified":"2014-09-08 15:45:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":156,"typeacteur_id":1,"nom":"TROTE","prenom":"Marie-Jos\\u00e9","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":15,"date_naissance":null,"adresse1":"29 avenue de Charade","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:58","modified":"2014-04-14 16:14:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":158,"typeacteur_id":1,"nom":"LACROIX","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":18,"date_naissance":null,"adresse1":"116 Avenue Thermale","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:35","modified":"2014-04-14 16:15:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":162,"typeacteur_id":1,"nom":"LEVET","prenom":"Annie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":22,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:17:31","modified":"2014-04-14 16:17:31","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":164,"typeacteur_id":1,"nom":"GUILHOT","prenom":"Patricia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":28,"date_naissance":null,"adresse1":"1 avenue Barbier Daubr\\u00e9e","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:53","modified":"2014-04-14 16:18:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":93,"typeacteur_id":1,"nom":"BERNARD","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller communautaire","position":29,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:21","modified":"2014-04-14 17:00:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":170,"typeacteur_id":1,"nom":"BARA","prenom":"Sa\\u00efd","salutation":"Monsieur","titre":"Conseiller Communautaire","position":37,"date_naissance":null,"adresse1":"11 rue Gr\\u00e9goire de Tours","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:35","modified":"2014-04-14 16:24:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":173,"typeacteur_id":1,"nom":"BOHELAY","prenom":"Philippe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":41,"date_naissance":null,"adresse1":"44 bis rue du Creux Rouge","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:02","modified":"2014-04-14 16:26:02","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":174,"typeacteur_id":1,"nom":"PRIEUX","prenom":"Nicole","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":42,"date_naissance":null,"adresse1":"76 rue de Nohanent","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:36","modified":"2014-04-14 16:26:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":176,"typeacteur_id":1,"nom":"CERVANTES","prenom":"Jean-Christophe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":45,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:03","modified":"2014-04-14 16:29:03","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":188,"typeacteur_id":1,"nom":"JALICON","prenom":"Christiane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":57,"date_naissance":null,"adresse1":"R\\u00e9sidence Topaze, B\\u00e2t D - 8 Rue d\'Orcines","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:33","modified":"2014-04-14 16:37:33","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":190,"typeacteur_id":1,"nom":"BASTIEN","prenom":"G\\u00e9raldine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":59,"date_naissance":null,"adresse1":"15 rue Jeanne d\'Arc","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:15","modified":"2014-04-14 16:38:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":191,"typeacteur_id":1,"nom":"RECHAGNEUX","prenom":"Antoine","salutation":"Monsieur","titre":"Conseiller Communautaire","position":60,"date_naissance":null,"adresse1":"6 rue des Portes d\'Argent","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:38:45","modified":"2014-04-14 16:38:45","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":21,"typeacteur_id":1,"nom":"RAGE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":66,"date_naissance":null,"adresse1":"95, Avenue Georges Cl\\u00e9menceau","adresse2":"","cp":"63800","ville":"COURNON D\'AUVERGNE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:14:00","modified":"2014-03-27 16:34:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":197,"typeacteur_id":1,"nom":"ALBISETTI","prenom":"Jean","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":70,"date_naissance":null,"adresse1":"20 bis petite rue du Pont des Ch\\u00e8vres","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:43:16","modified":"2014-09-08 15:52:32","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":199,"typeacteur_id":1,"nom":"L\\u00c9P\\u00c9E","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller Communautaire","position":72,"date_naissance":null,"adresse1":"3 rue Jean Jaur\\u00e8s","adresse2":"","cp":"63360","ville":"GERZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:44:41","modified":"2014-04-14 16:44:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":202,"typeacteur_id":1,"nom":"GANET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":75,"date_naissance":null,"adresse1":"9 Rue de la Garenne ","adresse2":"","cp":"63830","ville":"NOHANENT\\u00a0","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:00","modified":"2014-09-08 15:53:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":205,"typeacteur_id":1,"nom":"PRIEUR","prenom":"V\\u00e9ronique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":78,"date_naissance":null,"adresse1":"10, rue de la Riveux - Ternant","adresse2":"","cp":"63870","ville":"ORCINES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:47:13","modified":"2014-04-14 16:47:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":204,"typeacteur_id":1,"nom":"FAUCHER","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":82,"date_naissance":null,"adresse1":"Rue Saint Michel","adresse2":"","cp":"63430","ville":"PONT DU CHATEAU","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:46:55","modified":"2014-04-14 16:46:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":207,"typeacteur_id":1,"nom":"BRUNMUROL","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":84,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:03","modified":"2014-09-08 15:55:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":208,"typeacteur_id":1,"nom":"LELI\\u00c8VRE","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":85,"date_naissance":null,"adresse1":"23 Rue de Mozart","adresse2":"","cp":"63540","ville":"ROMAGNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:49:38","modified":"2014-04-14 16:49:38","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":103,"typeacteur_id":1,"nom":"PRACROS","prenom":"Claude","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":87,"date_naissance":null,"adresse1":"18, Avenue Anatole France","adresse2":"","cp":"63130","ville":"ROYAT","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:23","modified":"2014-04-14 17:00:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":11,"typeacteur_id":1,"nom":"GARDES","prenom":"Roger","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":88,"date_naissance":null,"adresse1":"12, route d\'Orcines","adresse2":"","cp":"63122","ville":"SAINT GENES CHAMPANELLE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:19","modified":"2014-03-27 16:34:22","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}}]',
            
            
          //  'acteurs_convoques' => '[{"Acteur":{"id":75,"typeacteur_id":1,"nom":"GILLIET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":1,"date_naissance":"1964-10-30","adresse1":"17 impasse Gambetta","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"04 73 26 82 45","note":"cr\\u00e9\\u00e9 le 08\\/10\\/2013 (rempla\\u00e7ant Jacques BLAIZE)","actif":true,"created":"2012-05-02 14:45:54","modified":"2014-09-08 15:44:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":147,"typeacteur_id":1,"nom":"BELLEROSE","prenom":"Martine","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":2,"date_naissance":null,"adresse1":"61 Rue du Chambon","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:10:09","modified":"2014-04-14 16:10:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":14,"typeacteur_id":1,"nom":"LAVILLE","prenom":"Didier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":3,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"Avenue Pierre de Coubertin","cp":"63510","ville":"AULNAT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:42","modified":"2014-03-27 16:31:52","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":148,"typeacteur_id":1,"nom":"SIMEON","prenom":"Marianne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":4,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63510","ville":"AULNAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:07","modified":"2014-04-14 16:11:07","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":149,"typeacteur_id":1,"nom":"DUMEIL","prenom":"Alain","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":5,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:24","modified":"2014-09-08 15:44:37","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":150,"typeacteur_id":1,"nom":"FAYE","prenom":"Aline","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":6,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:11:52","modified":"2014-04-14 16:11:52","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":3,"typeacteur_id":1,"nom":"SAINT-ANDR\\u00c9","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":7,"date_naissance":null,"adresse1":"20 rue de l\'H\\u00f4tel de Ville ","adresse2":"BP 122","cp":"63110","ville":"BEAUMONT","email":"","telfixe":"2008-14 T,2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:09:04","modified":"2014-09-08 15:37:47","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":151,"typeacteur_id":1,"nom":"BEYSSI","prenom":"Michel","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":8,"date_naissance":null,"adresse1":"523 rue des Vigeries","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:15","modified":"2014-09-08 15:44:57","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":152,"typeacteur_id":1,"nom":"FORTE-VIGIER","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":9,"date_naissance":null,"adresse1":"30 rue des Pivoines","adresse2":"","cp":"63112","ville":"BLANZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:12:49","modified":"2014-04-14 16:12:49","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":153,"typeacteur_id":1,"nom":"NEUVY","prenom":"Flavien","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":10,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"CEBAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:13:32","modified":"2014-09-08 15:45:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":154,"typeacteur_id":1,"nom":"CHALUS","prenom":"Jocelyne","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":11,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63118","ville":"C\\u00c9BAZAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:08","modified":"2014-04-14 16:14:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":31,"typeacteur_id":1,"nom":"PRONONCE","prenom":"Herv\\u00e9","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":12,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:23","modified":"2014-09-08 15:42:18","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":35,"typeacteur_id":1,"nom":"BOLIS","prenom":"Jacqueline","salutation":"Madame ","titre":"Conseill\\u00e8re Communautaire","position":13,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"7, rue de la Mairie","cp":"63670","ville":"LE CENDRE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:23:05","modified":"2014-03-27 17:02:54","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":155,"typeacteur_id":1,"nom":"MASSELOT","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":14,"date_naissance":null,"adresse1":"65 bis rue des Montagnards","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:31","modified":"2014-09-08 15:45:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":156,"typeacteur_id":1,"nom":"TROTE","prenom":"Marie-Jos\\u00e9","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":15,"date_naissance":null,"adresse1":"29 avenue de Charade","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:14:58","modified":"2014-04-14 16:14:58","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":33,"typeacteur_id":1,"nom":"GISCARD D\'ESTAING","prenom":"Louis","salutation":"Monsieur","titre":"2\\u00e8me Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":16,"date_naissance":null,"adresse1":"Maire de Chamali\\u00e8res","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:22:57","modified":"2014-09-12 14:58:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":157,"typeacteur_id":1,"nom":"LAVAL","prenom":"Chantal","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire ","position":17,"date_naissance":null,"adresse1":"8 Rue des Moulins","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:16","modified":"2014-04-14 16:15:16","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":158,"typeacteur_id":1,"nom":"LACROIX","prenom":"Michel","salutation":"Monsieur","titre":"Conseiller Communautaire","position":18,"date_naissance":null,"adresse1":"116 Avenue Thermale","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:15:35","modified":"2014-04-14 16:15:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":159,"typeacteur_id":1,"nom":"DUVERT","prenom":"Julie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":19,"date_naissance":null,"adresse1":"59 Avenue de Royat","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:01","modified":"2014-04-14 16:16:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":160,"typeacteur_id":1,"nom":"BORDES","prenom":"Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":20,"date_naissance":null,"adresse1":"2bis Rue du Roc Blanc","adresse2":"","cp":"63400","ville":"CHAMALIERES","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:19","modified":"2014-04-14 16:16:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":161,"typeacteur_id":1,"nom":"DARTEYRE","prenom":"Ren\\u00e9","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":21,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:16:51","modified":"2014-09-08 15:56:50","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":162,"typeacteur_id":1,"nom":"LEVET","prenom":"Annie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":22,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63119","ville":"CHATEAUGAY","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:17:31","modified":"2014-04-14 16:17:31","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":20,"typeacteur_id":1,"nom":"BIANCHI","prenom":"Olivier","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":23,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:13:32","modified":"2014-03-27 16:34:35","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":12,"typeacteur_id":1,"nom":"DULAC-ROUGERIE","prenom":"Christine","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":24,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:23","modified":"2014-03-27 16:34:50","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":51,"typeacteur_id":1,"nom":"LAFFONT","prenom":"Alain","salutation":"Monsieur","titre":"Conseiller communautaire","position":25,"date_naissance":null,"adresse1":"18, rue du Ch\\u00e2teau des Vergnes","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:07","modified":"2014-03-27 17:00:56","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":52,"typeacteur_id":1,"nom":"VIGNAL","prenom":"Odile","salutation":"Madame","titre":"Vice-Pr\\u00e9sidente de Clermont Communaut\\u00e9","position":26,"date_naissance":null,"adresse1":"38 rue de la Rotonde","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:28:23","modified":"2014-03-27 16:35:04","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":163,"typeacteur_id":1,"nom":"CINEUX","prenom":"Cyril","salutation":"Monsieur","titre":"Vice-Pr\\u00e9sident de Clermont Communaut\\u00e9","position":27,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:26","modified":"2014-09-08 15:48:13","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":164,"typeacteur_id":1,"nom":"GUILHOT","prenom":"Patricia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":28,"date_naissance":null,"adresse1":"1 avenue Barbier Daubr\\u00e9e","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:18:53","modified":"2014-04-14 16:18:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":93,"typeacteur_id":1,"nom":"BERNARD","prenom":"Gr\\u00e9gory","salutation":"Monsieur","titre":"Conseiller communautaire","position":29,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:21","modified":"2014-04-14 17:00:15","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":165,"typeacteur_id":1,"nom":"EL HAFIDHI","prenom":"Sond\\u00e8s","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":30,"date_naissance":null,"adresse1":"18 rue des Gras","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:19:48","modified":"2014-04-14 16:19:48","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":166,"typeacteur_id":1,"nom":"AUSLENDER","prenom":"J\\u00e9r\\u00f4me","salutation":"Monsieur","titre":"Conseiller Communautaire","position":31,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:08","modified":"2014-04-14 16:21:08","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":104,"typeacteur_id":1,"nom":"NOUHEN","prenom":"Fran\\u00e7oise","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":32,"date_naissance":null,"adresse1":"44, rue Eug\\u00e8ne Gilbert","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 15:01:30","modified":"2014-04-14 17:00:00","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":167,"typeacteur_id":1,"nom":"BONNET","prenom":"Nicolas","salutation":"Monsieur","titre":"Conseiller Communautaire","position":33,"date_naissance":null,"adresse1":"2 bis rue de la Pr\\u00e9v\\u00f4t\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:21:44","modified":"2014-04-14 16:21:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":168,"typeacteur_id":1,"nom":"GALLAIS","prenom":"Magali","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":34,"date_naissance":null,"adresse1":"4 bis rue du 8 mai 1945","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:22:59","modified":"2014-04-14 16:22:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":169,"typeacteur_id":1,"nom":"NARANJO","prenom":"Florent","salutation":"Monsieur","titre":"Conseiller Communautaire","position":35,"date_naissance":null,"adresse1":"19 avenue de la R\\u00e9publique","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:01","modified":"2014-04-14 16:24:01","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":39,"typeacteur_id":1,"nom":"AUDET","prenom":"C\\u00e9cile","salutation":"Madame","titre":"Conseill\\u00e8re communautaire","position":36,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:25:01","modified":"2014-03-27 16:37:43","suppleant_id":0},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":170,"typeacteur_id":1,"nom":"BARA","prenom":"Sa\\u00efd","salutation":"Monsieur","titre":"Conseiller Communautaire","position":37,"date_naissance":null,"adresse1":"11 rue Gr\\u00e9goire de Tours","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:24:35","modified":"2014-04-14 16:24:35","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":95,"typeacteur_id":1,"nom":"LAVEST","prenom":"Isabelle","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":38,"date_naissance":null,"adresse1":"37, rue Montlosier","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 S, 2014-2020","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:58:48","modified":"2014-04-14 17:00:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":171,"typeacteur_id":1,"nom":"POURRET","prenom":"Simon","salutation":"Monsieur","titre":"Conseiller Communautaire","position":39,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:05","modified":"2014-04-14 16:25:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":172,"typeacteur_id":1,"nom":"BRIAT","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":40,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:25:41","modified":"2014-04-14 16:25:41","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":173,"typeacteur_id":1,"nom":"BOHELAY","prenom":"Philippe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":41,"date_naissance":null,"adresse1":"44 bis rue du Creux Rouge","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:02","modified":"2014-04-14 16:26:02","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":174,"typeacteur_id":1,"nom":"PRIEUX","prenom":"Nicole","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":42,"date_naissance":null,"adresse1":"76 rue de Nohanent","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:26:36","modified":"2014-04-14 16:26:36","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":15,"typeacteur_id":1,"nom":"ADENOT","prenom":"Dominique","salutation":"Monsieur","titre":"Conseiller Communautaire","position":43,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"2008-14 T, 2014-20","telmobile":"","note":"","actif":true,"created":"2012-05-02 14:11:57","modified":"2014-09-08 15:50:17","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":175,"typeacteur_id":1,"nom":"ROGUE-SALLARD","prenom":"Dominique","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":44,"date_naissance":null,"adresse1":"10 rue de la Treille","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:27:09","modified":"2014-04-14 16:27:09","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":176,"typeacteur_id":1,"nom":"CERVANTES","prenom":"Jean-Christophe","salutation":"Monsieur","titre":"Conseiller Communautaire","position":45,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:03","modified":"2014-04-14 16:29:03","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":177,"typeacteur_id":1,"nom":"TARDIEU","prenom":"Sylviane","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":46,"date_naissance":null,"adresse1":"73 rue Viviani","adresse2":"","cp":"63100","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:29:44","modified":"2014-04-14 16:29:44","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":178,"typeacteur_id":1,"nom":"GUITTARD","prenom":"Pascal","salutation":"Monsieur","titre":"Conseiller Communautaire","position":47,"date_naissance":null,"adresse1":"18 rue du Onze Novembre","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:12","modified":"2014-04-14 16:30:12","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":179,"typeacteur_id":1,"nom":"BERNARD","prenom":"Val\\u00e9rie","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":48,"date_naissance":null,"adresse1":"47 rue de la Volont\\u00e9","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:34","modified":"2014-04-14 16:30:34","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":180,"typeacteur_id":1,"nom":"VIMONT","prenom":"Guillaume","salutation":"Monsieur","titre":"Conseiller Communautaire","position":49,"date_naissance":null,"adresse1":"12 rue de Riom","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:30:59","modified":"2014-04-14 16:30:59","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":181,"typeacteur_id":1,"nom":"CANALES","prenom":"Marion","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":50,"date_naissance":null,"adresse1":"42 avenue des \\u00c9tats-Unis","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:31:26","modified":"2014-04-14 16:31:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":182,"typeacteur_id":1,"nom":"BOHNER","prenom":"G\\u00e9rard","salutation":"Monsieur","titre":"Conseiller Communautaire","position":51,"date_naissance":null,"adresse1":"H\\u00f4tel de Ville","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:26","modified":"2014-04-14 16:32:26","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":183,"typeacteur_id":1,"nom":"BRENAS","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":52,"date_naissance":null,"adresse1":"11 avenue Carnot","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:32:55","modified":"2014-04-14 16:32:55","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":184,"typeacteur_id":1,"nom":"CANDELIER","prenom":"\\u00c9dith","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":53,"date_naissance":null,"adresse1":"41 avenue des Cottages","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:33:24","modified":"2014-04-14 16:33:24","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":185,"typeacteur_id":1,"nom":"LAVIGNE","prenom":"Jean-Pierre","salutation":"Monsieur","titre":"Conseiller Communautaire","position":54,"date_naissance":null,"adresse1":"41 avenue Joseph Agid","adresse2":"","cp":"63122","ville":"CEYRAT","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:34:53","modified":"2014-04-14 16:34:53","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":186,"typeacteur_id":1,"nom":"GUERMIT-MAFFRE","prenom":"Nadia","salutation":"Madame","titre":"Conseill\\u00e8re Communautaire","position":55,"date_naissance":null,"adresse1":"36 rue du Capricorne","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:35:27","modified":"2014-04-14 16:35:27","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}},{"Acteur":{"id":187,"typeacteur_id":1,"nom":"BARRI\\u00c8RE","prenom":"Fran\\u00e7ois","salutation":"Monsieur","titre":"Conseiller Communautaire","position":56,"date_naissance":null,"adresse1":"57 rue Drelon","adresse2":"","cp":"63000","ville":"CLERMONT-FERRAND","email":"","telfixe":"","telmobile":"","note":"","actif":true,"created":"2014-04-14 16:37:05","modified":"2014-04-14 16:37:05","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}}]',
        //'acteurs_convoques' => '[{"Acteur":{"id":75,"typeacteur_id":1,"nom":"GILLIET","prenom":"Laurent","salutation":"Monsieur","titre":"Membre du Bureau de Clermont Communaut\\u00e9","position":1,"date_naissance":"1964-10-30","adresse1":"17 impasse Gambetta","adresse2":"","cp":"63170","ville":"AUBIERE","email":"","telfixe":"2008-14 S, 2014-20","telmobile":"04 73 26 82 45","note":"cr\\u00e9\\u00e9 le 08\\/10\\/2013 (rempla\\u00e7ant Jacques BLAIZE)","actif":true,"created":"2012-05-02 14:45:54","modified":"2014-09-08 15:44:19","suppleant_id":null},"Suppleant":{"id":null,"typeacteur_id":null,"nom":null,"prenom":null,"salutation":null,"titre":null,"position":null,"date_naissance":null,"adresse1":null,"adresse2":null,"cp":null,"ville":null,"email":null,"telfixe":null,"telmobile":null,"note":null,"actif":null,"created":null,"modified":null,"suppleant_id":null},"Typeacteur":{"id":1,"nom":"Acteurs \\u00c9lus titulaires","commentaire":"","elu":true,"created":"2012-05-02 13:48:16","modified":"2012-05-02 14:38:53"}}]',
//'acteurs_convoques' => '[{\"Acteur\":{\"id\":2,\"typeacteur_id\":2,\"nom\":\"BAYROU\",\"prenom\":\"Fran\\u00e7ois\",\"salutation\":\"M.\",\"titre\":\"Pr\\u00e9sident\",\"position\":1,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:34:45\",\"modified\":\"2014-10-08 14:34:45\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":10,\"typeacteur_id\":2,\"nom\":\"SEMAVOINE\",\"prenom\":\"Monique\",\"salutation\":\"Mme\",\"titre\":\"premier Vice-Pr\\u00e9sident\",\"position\":2,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:30\",\"modified\":\"2014-10-08 14:46:33\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":14,\"typeacteur_id\":2,\"nom\":\"HILD\",\"prenom\":\"Annie\",\"salutation\":\"Mme\",\"titre\":\"deuxi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":3,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:44:15\",\"modified\":\"2014-10-08 14:46:14\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":32,\"typeacteur_id\":2,\"nom\":\"BERNOS\",\"prenom\":\"Michel\",\"salutation\":\"M.\",\"titre\":\"troisi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":4,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:32\",\"modified\":\"2014-10-08 14:48:27\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":42,\"typeacteur_id\":2,\"nom\":\"PATRIARCHE\",\"prenom\":\"Nicolas\",\"salutation\":\"M.\",\"titre\":\"quatri\\u00e8me Vice-Pr\\u00e9sident\",\"position\":5,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:18\",\"modified\":\"2014-10-08 14:49:18\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":48,\"typeacteur_id\":2,\"nom\":\"PEES\",\"prenom\":\"Francis\",\"salutation\":\"M.\",\"titre\":\"cinqui\\u00e8me Vice-Pr\\u00e9sident\",\"position\":6,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:50:35\",\"modified\":\"2014-10-08 14:50:35\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":51,\"typeacteur_id\":2,\"nom\":\"ARRIBES\",\"prenom\":\"Andr\\u00e9\",\"salutation\":\"M.\",\"titre\":\"sixi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":7,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:51:23\",\"modified\":\"2014-10-08 14:53:33\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":52,\"typeacteur_id\":2,\"nom\":\"LABAN-WINOGRAD\",\"prenom\":\"Mich\\u00e8le\",\"salutation\":\"Mme\",\"titre\":\"septi\\u00e8me Vice-Pr\\u00e9sidente\",\"position\":8,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:52:17\",\"modified\":\"2014-10-08 14:52:17\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":55,\"typeacteur_id\":2,\"nom\":\"LALANNE\",\"prenom\":\"Jean-Yves\",\"salutation\":\"M.\",\"titre\":\"huiti\\u00e8me Vice-Pr\\u00e9sident\",\"position\":9,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:53:01\",\"modified\":\"2014-10-08 14:53:01\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":60,\"typeacteur_id\":2,\"nom\":\"LAINE\",\"prenom\":\"Christian\",\"salutation\":\"M.\",\"titre\":\"neuvi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":10,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:54:25\",\"modified\":\"2014-10-08 14:54:25\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":63,\"typeacteur_id\":2,\"nom\":\"MORA\",\"prenom\":\"Pascal\",\"salutation\":\"M.\",\"titre\":\"dixi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":11,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:55:07\",\"modified\":\"2014-10-08 14:55:07\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":65,\"typeacteur_id\":2,\"nom\":\"BOURIAT\",\"prenom\":\"Jean-Claude\",\"salutation\":\"M.\",\"titre\":\"onzi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":12,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:56:15\",\"modified\":\"2014-10-08 14:56:15\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":66,\"typeacteur_id\":2,\"nom\":\"PLISSONNEAU\",\"prenom\":\"Michel\",\"salutation\":\"M.\",\"titre\":\"douzi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":13,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:57:19\",\"modified\":\"2014-10-08 14:57:19\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":67,\"typeacteur_id\":2,\"nom\":\"GUILLAUME\",\"prenom\":\"G\\u00e9rard\",\"salutation\":\"M.\",\"titre\":\"treizi\\u00e8me Vice-Pr\\u00e9sident\",\"position\":14,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:58:10\",\"modified\":\"2014-10-08 14:58:10\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":3,\"typeacteur_id\":2,\"nom\":\"POUEYTO\",\"prenom\":\"Josy\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":15,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:40:40\",\"modified\":\"2014-10-08 14:44:52\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":5,\"typeacteur_id\":2,\"nom\":\"CABANE\",\"prenom\":\"Marc\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":16,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:42:05\",\"modified\":\"2014-10-08 14:43:47\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":8,\"typeacteur_id\":2,\"nom\":\"LIPSOS-SALLENAVE\",\"prenom\":\"V\\u00e9ronique\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":17,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:14\",\"modified\":\"2014-10-08 14:43:14\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":16,\"typeacteur_id\":2,\"nom\":\"SAUBATTE\",\"prenom\":\"Eric\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":18,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:44:27\",\"modified\":\"2014-10-08 14:44:27\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":25,\"typeacteur_id\":2,\"nom\":\"WOLFS\",\"prenom\":\"Patricia\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":19,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:32\",\"modified\":\"2014-10-08 16:25:44\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":28,\"typeacteur_id\":2,\"nom\":\"BONIFACE\",\"prenom\":\"Pascal\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":20,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:00\",\"modified\":\"2014-10-08 16:26:14\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":31,\"typeacteur_id\":2,\"nom\":\"DENIS\",\"prenom\":\"Odile\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":21,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:30\",\"modified\":\"2014-10-08 16:26:24\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":36,\"typeacteur_id\":2,\"nom\":\"PERES\",\"prenom\":\"Jean-Louis\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":22,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:48:01\",\"modified\":\"2014-10-08 16:26:35\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":37,\"typeacteur_id\":2,\"nom\":\"BRIN\",\"prenom\":\"Jean-Paul\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":23,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:48:27\",\"modified\":\"2014-10-08 16:26:45\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":43,\"typeacteur_id\":2,\"nom\":\"VAN DAELE\",\"prenom\":\"Marylis\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":24,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:18\",\"modified\":\"2014-10-08 16:26:55\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":53,\"typeacteur_id\":2,\"nom\":\"ARBERET\",\"prenom\":\"Jean-Marc\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":25,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:52:32\",\"modified\":\"2014-10-08 16:27:05\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":56,\"typeacteur_id\":2,\"nom\":\"COY\",\"prenom\":\"Philippe\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":26,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:53:09\",\"modified\":\"2014-10-08 16:27:17\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":58,\"typeacteur_id\":2,\"nom\":\"DURROTY\",\"prenom\":\"Bruno\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":27,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:53:40\",\"modified\":\"2014-10-08 16:27:28\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":59,\"typeacteur_id\":2,\"nom\":\"TISNERAT\",\"prenom\":\"Corinne\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":28,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:54:09\",\"modified\":\"2014-10-08 16:27:42\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":62,\"typeacteur_id\":2,\"nom\":\"BIGNALET\",\"prenom\":\"Martine\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":29,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:54:44\",\"modified\":\"2014-10-08 16:27:55\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":68,\"typeacteur_id\":2,\"nom\":\"PAUMARD\",\"prenom\":\"Pascal\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":30,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 16:28:25\",\"modified\":\"2014-10-08 16:28:25\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":9,\"typeacteur_id\":2,\"nom\":\"LOUBET\",\"prenom\":\"Bertrand\",\"salutation\":\"M\",\"titre\":\"Conseiller communautaire\",\"position\":31,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:28\",\"modified\":\"2014-10-08 14:45:35\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":18,\"typeacteur_id\":2,\"nom\":\"JACOTTIN\",\"prenom\":\"Arnaud\",\"salutation\":\"M\",\"titre\":\"Conseiller communautaire\",\"position\":32,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:45:01\",\"modified\":\"2014-10-08 14:45:43\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":23,\"typeacteur_id\":2,\"nom\":\"DEHOS\",\"prenom\":\"V\\u00e9ronique\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":33,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:10\",\"modified\":\"2014-10-08 14:46:10\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":27,\"typeacteur_id\":2,\"nom\":\"CLERIS\",\"prenom\":\"Patrick\",\"salutation\":\"M\",\"titre\":\"Conseiller communautaire\",\"position\":34,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:59\",\"modified\":\"2014-10-08 14:46:59\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":35,\"typeacteur_id\":2,\"nom\":\"TISSANIE\",\"prenom\":\"Jean-Michel\",\"salutation\":\"M\",\"titre\":\"Conseiller communautaire\",\"position\":35,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:58\",\"modified\":\"2014-10-08 14:47:58\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":41,\"typeacteur_id\":2,\"nom\":\"LAVIGNE\",\"prenom\":\"Gwendoline\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":36,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:14\",\"modified\":\"2014-10-08 14:56:45\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":46,\"typeacteur_id\":2,\"nom\":\"MANUEL\",\"prenom\":\"Josiane\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":37,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:50:01\",\"modified\":\"2014-10-08 14:50:01\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":50,\"typeacteur_id\":2,\"nom\":\"SANNIER\",\"prenom\":\"Bernadette\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":38,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:50:42\",\"modified\":\"2014-10-08 14:50:42\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":54,\"typeacteur_id\":2,\"nom\":\"REVEL DA ROCHA\",\"prenom\":\"Val\\u00e9rie\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":39,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:52:42\",\"modified\":\"2014-10-08 14:52:42\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":57,\"typeacteur_id\":2,\"nom\":\"GRATACOS\",\"prenom\":\"Jo\\u00ebl\",\"salutation\":\"M\",\"titre\":\"Conseiller communautaire\",\"position\":40,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:53:23\",\"modified\":\"2014-10-08 14:53:23\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":61,\"typeacteur_id\":2,\"nom\":\"SAUVANIER-AUGERAUD\",\"prenom\":\"Marion\",\"salutation\":\"Mme\",\"titre\":\"Conseiller Communautaire\",\"position\":41,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:54:28\",\"modified\":\"2014-10-08 14:56:10\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":64,\"typeacteur_id\":2,\"nom\":\"THIEUX- MORA\",\"prenom\":\"Florence\",\"salutation\":\"Mme\",\"titre\":\"Conseiller Communautaire\",\"position\":42,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:56:09\",\"modified\":\"2014-10-08 14:56:09\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":4,\"typeacteur_id\":2,\"nom\":\"BIASON\",\"prenom\":\"Catherine\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":43,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:41:52\",\"modified\":\"2014-10-08 14:45:53\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":11,\"typeacteur_id\":2,\"nom\":\"GARCIA\",\"prenom\":\"Patricia\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":44,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:36\",\"modified\":\"2014-10-08 14:46:02\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":13,\"typeacteur_id\":2,\"nom\":\"CAZABAT\",\"prenom\":\"Eric\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":45,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:44:02\",\"modified\":\"2014-10-08 14:46:11\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":17,\"typeacteur_id\":2,\"nom\":\"ZEROUAL\",\"prenom\":\"Sylvie\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":46,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:44:32\",\"modified\":\"2014-10-08 14:46:25\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":19,\"typeacteur_id\":2,\"nom\":\"LACOSTE\",\"prenom\":\"Jean\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":47,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:45:19\",\"modified\":\"2014-10-08 14:45:19\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":26,\"typeacteur_id\":2,\"nom\":\"ROY\",\"prenom\":\"Pauline\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":48,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:48\",\"modified\":\"2014-10-08 14:46:48\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":30,\"typeacteur_id\":2,\"nom\":\"LAURAND\",\"prenom\":\"R\\u00e9gis\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":49,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:21\",\"modified\":\"2014-10-08 14:47:21\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":34,\"typeacteur_id\":2,\"nom\":\"DESPAUX\",\"prenom\":\"Laurence\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":50,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:48\",\"modified\":\"2014-10-08 14:47:48\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":39,\"typeacteur_id\":2,\"nom\":\"CHENEVIERE\",\"prenom\":\"Thibault\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":51,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:48:59\",\"modified\":\"2014-10-08 14:48:59\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":44,\"typeacteur_id\":2,\"nom\":\"MESTELAN\",\"prenom\":\"Marie-Laure\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":52,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:22\",\"modified\":\"2014-10-08 14:49:22\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":45,\"typeacteur_id\":2,\"nom\":\"BOUCHANNAFA\",\"prenom\":\"Nejia\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":53,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:56\",\"modified\":\"2014-10-08 14:57:31\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":49,\"typeacteur_id\":2,\"nom\":\"CASTERA\",\"prenom\":\"Anne\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":54,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:50:38\",\"modified\":\"2014-10-08 14:50:38\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":40,\"typeacteur_id\":2,\"nom\":\"LESTORTE\",\"prenom\":\"Andr\\u00e9\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":55,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:49:06\",\"modified\":\"2014-10-08 14:49:06\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":38,\"typeacteur_id\":2,\"nom\":\"PEDEUTOUR\",\"prenom\":\"Genevi\\u00e8ve\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":56,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:48:27\",\"modified\":\"2014-10-08 14:48:27\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":33,\"typeacteur_id\":2,\"nom\":\"GIRAUD\",\"prenom\":\"Pascal\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":57,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:47\",\"modified\":\"2014-10-08 14:47:47\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":29,\"typeacteur_id\":2,\"nom\":\"BONNEMASON CARRERE\",\"prenom\":\"Christelle\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":58,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:47:17\",\"modified\":\"2014-10-08 14:47:17\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":24,\"typeacteur_id\":2,\"nom\":\"VAUJANY\",\"prenom\":\"Alain\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":59,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:31\",\"modified\":\"2014-10-08 14:46:31\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":22,\"typeacteur_id\":2,\"nom\":\"HABIB\",\"prenom\":\"David\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":60,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:46:04\",\"modified\":\"2014-10-08 14:46:04\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":20,\"typeacteur_id\":2,\"nom\":\"LARRADET\",\"prenom\":\"Nathalie\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":61,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:45:23\",\"modified\":\"2014-10-08 14:45:23\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":15,\"typeacteur_id\":2,\"nom\":\"DUCHATEAU\",\"prenom\":\"Andr\\u00e9\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":62,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:44:23\",\"modified\":\"2014-10-08 14:44:23\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":12,\"typeacteur_id\":2,\"nom\":\"ESPAGNAC\",\"prenom\":\"Fr\\u00e9d\\u00e9rique\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":63,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:47\",\"modified\":\"2014-10-08 14:43:47\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":7,\"typeacteur_id\":2,\"nom\":\"DARTIGOLLES\",\"prenom\":\"Olivier\",\"salutation\":\"M.\",\"titre\":\"Conseiller communautaire\",\"position\":64,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:43:08\",\"modified\":\"2014-10-08 14:43:08\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}},{\"Acteur\":{\"id\":6,\"typeacteur_id\":2,\"nom\":\"LAURENT\",\"prenom\":\"R\\u00e9gine\",\"salutation\":\"Mme\",\"titre\":\"Conseiller communautaire\",\"position\":65,\"date_naissance\":null,\"adresse1\":\"\",\"adresse2\":\"\",\"cp\":\"\",\"ville\":\"\",\"email\":\"\",\"telfixe\":\"\",\"telmobile\":\"\",\"suppleant_id\":null,\"note\":\"\",\"actif\":true,\"created\":\"2014-10-08 14:42:18\",\"modified\":\"2014-10-08 14:42:18\"},\"Suppleant\":{\"id\":null,\"typeacteur_id\":null,\"nom\":null,\"prenom\":null,\"salutation\":null,\"titre\":null,\"position\":null,\"date_naissance\":null,\"adresse1\":null,\"adresse2\":null,\"cp\":null,\"ville\":null,\"email\":null,\"telfixe\":null,\"telmobile\":null,\"suppleant_id\":null,\"note\":null,\"actif\":null,\"created\":null,\"modified\":null},\"Typeacteur\":{\"id\":2,\"nom\":\"Elus\",\"commentaire\":\"\",\"elu\":true,\"created\":\"2014-10-08 14:24:59\",\"modified\":\"2014-10-08 14:24:59\"}}]',            
            
            'projets' => array(
                0 => array(
                    'ordre' => 0,
                    'libelle' => 'tarif cimetiere',
                    'theme' => 'Finances',
                    'annexes' => array(
                        array(
                            'libelle' => $file,
                            'ordre' => 0
                        )
                    )
                ),
                1 => array(
                    'ordre' => 1,
                    'libelle' => 'Subvention',
                    'theme' => 'Environnement',
                    'annexes' => array(
                        array(
                            'libelle' => $file,
                            'ordre' => 0
                        ),
                        array(
                            'libelle' => $file,
                            'ordre' => 1
                        )
                    )
                )
            )
        );

        $data = array(
            'username' => IDELIBRE_CURL_WSTEST_USER,
            'password' => IDELIBRE_CURL_WSTEST_PASS,
            'conn' => IDELIBRE_CURL_WSTEST_CONN,
            'jsonData' => json_encode($jsonData),
            'convocation' => "@$file",
            'projet_0_rapport' => "@$file",
            'projet_0_0_annexe' => "@$file",
            'projet_1_rapport' => "@$file",
            'projet_1_0_annexe' => "@$file",
            'projet_1_1_annexe' => "@$file"
        );


        $ch = curl_init();

        //FIXME : mettre en place les vérifications
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_CAINFO, getcwd() . IDELIBRE_CURL_WSTEST_HTTPS_CERTIFICATE);

        curl_setopt($ch, CURLOPT_URL, $url);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_POST, 1);
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

        $result = curl_exec($ch);
        $this->out(var_export(array('url' => $url, 'data' => $data, 'result' => $result, 'error' => $result === false ? curl_error($ch) : ''), true));
        curl_close($ch);
    }

}
